// This code conforms with the UFC specification version 2018.1.0
// and was automatically generated by FFC version 2019.2.0.dev0.
//
// This code was generated with the option '-l dolfin' and
// contains DOLFIN-specific wrappers that depend on DOLFIN.
//
// This code was generated with the following parameters:
//

//  add_tabulate_tensor_timing:     False
//  convert_exceptions_to_warnings: False
//  cpp_optimize:                   True
//  cpp_optimize_flags:             '-O2'
//  epsilon:                        1e-14
//  error_control:                  False
//  external_include_dirs:          ''
//  external_includes:              ''
//  external_libraries:             ''
//  external_library_dirs:          ''
//  form_postfix:                   True
//  format:                         'dolfin'
//  generate_dummy_tabulate_tensor: False
//  max_signature_length:           0
//  optimize:                       True
//  precision:                      None
//  quadrature_degree:              None
//  quadrature_rule:                None
//  representation:                 'auto'
//  split:                          False

#ifndef __FORMS_H
#define __FORMS_H
#include <algorithm>
#include <cmath>
#include <iostream>
#include <stdexcept>
#include <ufc.h>

class forms_finite_element_0: public ufc::finite_element
{
public:

  forms_finite_element_0() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FiniteElement('Lagrange', triangle, 1)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 3;
  }

  std::size_t value_rank() const final override
  {
    return 0;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    return 1;
  }

  std::size_t value_size() const final override
  {
    return 1;
  }

  std::size_t reference_value_rank() const final override
  {
    return 0;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    return 1;
  }

  std::size_t reference_value_size() const final override
  {
    return 1;
  }

  std::size_t degree() const final override
  {
    return 1;
  }

  const char * family() const final override
  {
    return "Lagrange";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[1][3] = { { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    for (std::size_t k = 0; k < num_points * 3; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip + 1] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip + 2] += coefficients2[0][r] * basisvalues1[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 3 * num_derivatives, 0.0);
    if (order > 1)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][3][3] =
        { { { 0.0, 0.0, 0.0 },
            { 4.8989794855663495, 0.0, 0.0 },
            { 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0 },
            { 2.449489742783182, 0.0, 0.0 },
            { 4.242640687119285, 0.0, 0.0 } } };
    static const double coefficients0[1][3] = { { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    const std::size_t reference_offset[3] = {};
    const std::size_t num_components[3] = { 1, 1, 1 };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 3; ++i)
        {
            double derivatives[2] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[3 * num_derivatives * ip + num_derivatives * i + r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    std::fill_n(values, num_points * 3 * num_derivatives, 0.0);
    const std::size_t reference_offsets[3] = {};
    const std::size_t physical_offsets[3] = {};
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[2][2];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 3; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 1; ++i)
                {
                    // Using affine transform to map values back to the physical element.
                    const double mapped_value = reference_values[3 * num_derivatives * ip + num_derivatives * d + s + reference_offsets[d]];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[3 * num_derivatives * ip + num_derivatives * d + r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[3];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[3];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 1; ++k)
        values[k] = physical_values[i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold value of a single dof.
    double dof_values = 0.0;
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 3; ++r)
    {
        evaluate_basis(r, &dof_values, x, coordinate_dofs, cell_orientation);
        values[r] = dof_values;
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    // Declare transformation matrix
    double transform[2][2] =
        { { 1.0, 1.0 },
          { 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 1:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 2:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, num_derivatives * 3, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 3; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < num_derivatives; ++s)
            values[num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[1];
    // Declare variable for physical coordinates
    double y[2];
    switch (i)
    {
    case 0:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 1:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 2:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[1];
    // Declare variable for physical coordinates
    double y[2];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[2 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 2] = coordinate_dofs[4];
    dof_coordinates[2 * 2 + 1] = coordinate_dofs[5];
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    static const double dof_X[6] = { 0.0, 0.0, 1.0, 0.0, 0.0, 1.0 };
    std::copy_n(dof_X, 6, reference_dof_coordinates);
  }

  std::size_t num_sub_elements() const final override
  {
    return 0;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_0();
  }

};


class forms_finite_element_1: public ufc::finite_element
{
public:

  forms_finite_element_1() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 6;
  }

  std::size_t value_rank() const final override
  {
    return 1;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t value_size() const final override
  {
    return 2;
  }

  std::size_t reference_value_rank() const final override
  {
    return 1;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t reference_value_size() const final override
  {
    return 2;
  }

  std::size_t degree() const final override
  {
    return 1;
  }

  const char * family() const final override
  {
    return "Lagrange";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[1][3] = { { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    for (std::size_t k = 0; k < num_points * 6 * 2; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 2] += coefficients2[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 3 + 1] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 4 + 1] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 5 + 1] += coefficients2[0][r] * basisvalues1[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 6 * num_derivatives * 2, 0.0);
    if (order > 1)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][3][3] =
        { { { 0.0, 0.0, 0.0 },
            { 4.8989794855663495, 0.0, 0.0 },
            { 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0 },
            { 2.449489742783182, 0.0, 0.0 },
            { 4.242640687119285, 0.0, 0.0 } } };
    static const double coefficients0[1][3] = { { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    const std::size_t reference_offset[6] = { 0, 0, 0, 1, 1, 1 };
    const std::size_t num_components[6] = { 1, 1, 1, 1, 1, 1 };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 6; ++i)
        {
            double derivatives[2] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            case 3:
                // Compute reference derivatives for dof 3.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 4:
                // Compute reference derivatives for dof 4.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 5:
                // Compute reference derivatives for dof 5.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * i + 2 * r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    std::fill_n(values, num_points * 6 * num_derivatives * 2, 0.0);
    const std::size_t reference_offsets[6] = { 0, 0, 0, 1, 1, 1 };
    const std::size_t physical_offsets[6] = { 0, 0, 0, 1, 1, 1 };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[2][2];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 6; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 1; ++i)
                {
                    // Using affine transform to map values back to the physical element.
                    const double mapped_value = reference_values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + reference_offsets[d]];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[12];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[12];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 2; ++k)
        values[k] = physical_values[2 * i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 6; ++r)
    {
        evaluate_basis(r, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2; ++s)
            values[r * 2 + s] = dof_values[s];
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, 2 * num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    // Declare transformation matrix
    double transform[2][2] =
        { { 1.0, 1.0 },
          { 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 1:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 2:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 3:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    case 4:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    case 5:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, 2 * num_derivatives * 6, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[4] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 6; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2 * num_derivatives; ++s)
            values[2 * num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    switch (i)
    {
    case 0:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 1:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 2:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 3:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    case 4:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    case 5:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[3] = vals[1];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[4] = vals[1];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[5] = vals[1];
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[2] = dof_values[1];
    vertex_values[4] = dof_values[2];
    // Evaluate function and change variables
    vertex_values[1] = dof_values[3];
    vertex_values[3] = dof_values[4];
    vertex_values[5] = dof_values[5];
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[2 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 2] = coordinate_dofs[4];
    dof_coordinates[2 * 2 + 1] = coordinate_dofs[5];
    dof_coordinates[2 * 3] = coordinate_dofs[0];
    dof_coordinates[2 * 3 + 1] = coordinate_dofs[1];
    dof_coordinates[2 * 4] = coordinate_dofs[2];
    dof_coordinates[2 * 4 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 5] = coordinate_dofs[4];
    dof_coordinates[2 * 5 + 1] = coordinate_dofs[5];
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    static const double dof_X[12] = { 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0 };
    std::copy_n(dof_X, 12, reference_dof_coordinates);
  }

  std::size_t num_sub_elements() const final override
  {
    return 2;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_0();
    case 1:
        return new forms_finite_element_0();
    default:
        return nullptr;
    }
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_1();
  }

};


class forms_finite_element_2: public ufc::finite_element
{
public:

  forms_finite_element_2() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_2() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FiniteElement('Nedelec 1st kind H(curl)', triangle, 3)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 15;
  }

  std::size_t value_rank() const final override
  {
    return 1;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t value_size() const final override
  {
    return 2;
  }

  std::size_t reference_value_rank() const final override
  {
    return 1;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t reference_value_size() const final override
  {
    return 2;
  }

  std::size_t degree() const final override
  {
    return 3;
  }

  const char * family() const final override
  {
    return "Nedelec 1st kind H(curl)";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[2][10] =
        { { 0.0, 0.0, 0.0, -0.16953317256112305, 0.08417937871268444, -0.11664236870396065, 0.0, -0.14682003422210352, 0.07290148043997564, -0.10101525445522067 },
          { 0.0, 0.0, 0.0, 0.32167832742366925, -0.13468700594029484, 0.0972019739199673, 0.26057971086461407, -0.1298792610426302, 0.09768798378956733, -0.06313453403451322 } };
    static const double coefficients1[2][10] =
        { { 0.0, 0.0, 0.0, 0.0782460796435951, -0.1683587574253686, 0.3499271061118821, 0.0, 0.06776309271789378, -0.1458029608799512, 0.3030457633656624 },
          { 0.0, 0.0, 0.0, -0.16518616813647952, 0.2357022603955162, -0.27216552697590857, -0.12026755886059151, 0.1468200342221039, -0.22453655975512485, 0.17677669529663695 } };
    static const double coefficients2[2][10] =
        { { 0.0, 0.0, 0.0, -0.03912303982179753, -0.08417937871268419, -0.34992710611188227, 0.0, -0.033881546358946905, -0.07290148043997538, -0.3030457633656628 },
          { 0.0, 0.0, 0.0, 0.06085806194501872, 0.0, 0.21384434262392868, 0.060133779430295714, 0.0395284707521046, 0.11226827987756254, -0.13889597487592917 } };
    static const double coefficients3[2][10] =
        { { 0.0, 0.0, 0.0, 0.16953317256112277, 0.08417937871268391, 0.11664236870396082, 0.0, 0.14682003422210346, 0.07290148043997538, 0.10101525445522093 },
          { 0.0, 0.0, 0.0, 0.49121149998479163, 0.21886638465297903, 0.21384434262392799, -0.2605797108646136, 0.016940773179473394, -0.0247865033495918, 0.03788072042070807 } };
    static const double coefficients4[2][10] =
        { { 0.0, 0.0, 0.0, -0.07824607964359508, -0.16835875742536852, -0.3499271061118824, 0.0, -0.06776309271789387, -0.14580296087995095, -0.3030457633656629 },
          { 0.0, 0.0, 0.0, -0.24343224778007372, -0.40406101782088466, -0.6220926330877908, 0.12026755886059104, 0.07905694150420951, 0.07873359887517375, -0.1262690680690266 } };
    static const double coefficients5[2][10] =
        { { 0.0, 0.0, 0.0, 0.03912303982179732, -0.08417937871268408, 0.3499271061118821, 0.0, 0.033881546358946815, -0.07290148043997555, 0.30304576336566263 },
          { 0.0, 0.0, 0.0, 0.09998110176681575, -0.08417937871268388, 0.5637714487358106, -0.060133779430295804, 0.07341001711105198, -0.18516976031753798, 0.16414978848973436 } };
    static const double coefficients6[2][10] =
        { { 0.0, 0.0, 0.0, 0.3825363893686874, 0.30304576336566336, 0.3110463165438959, 0.0, -0.09035079029052522, -0.14580296087995084, -0.20203050891044197 },
          { 0.0, 0.0, 0.0, 0.16953317256112282, 0.08417937871268413, 0.11664236870396108, 0.16035674514745454, 0.0677630927178938, 0.03207665139358943, -0.07576144084141599 } };
    static const double coefficients7[2][10] =
        { { 0.0, 0.0, 0.0, -0.7650727787373746, 0.0, -0.15552315827194763, 0.0, 0.18070158058105046, 0.0, 0.10101525445522097 },
          { 0.0, 0.0, 0.0, -0.38253638936868767, 0.06734350297014775, -0.07776157913597376, -0.3207134902949093, 0.09035079029052548, -0.06415330278717865, 0.050507627227610714 } };
    static const double coefficients8[2][10] =
        { { 0.0, 0.0, 0.0, 0.3825363893686873, -0.3030457633656635, 0.3110463165438962, 0.0, -0.09035079029052508, 0.14580296087995115, -0.20203050891044175 },
          { 0.0, 0.0, 0.0, 0.21300321680756507, -0.2188663846529794, 0.19440394783993487, 0.16035674514745504, -0.1581138830084195, 0.17787961227354052, -0.1262690680690264 } };
    static const double coefficients9[2][10] =
        { { 3.9999999999999996, 0.0, 0.0, -0.36885555678165943, -0.47619047619047533, -1.6495721976846465, 0.0, -0.3194382824999711, -0.4123930494211605, 0.5714285714285697 },
          { 0.0, 0.0, 0.0, 0.6147592613027633, 0.476190476190476, -0.5498573992282135, 0.56694670951384, 0.15971914124998549, -0.45363235436327703, 0.35714285714285654 } };
    static const double coefficients10[2][10] =
        { { 0.0, 3.999999999999998, 0.0, -0.6776309271789392, 1.807956714911394, 0.0, 0.0, -0.5868455973269653, -1.2626906806902616, 0.0 },
          { 0.0, 0.0, 0.0, 1.054092553389456, 1.1664236870396085, -0.33671751485073326, 1.0415476122441178, 0.6846531968814589, -0.5808377131175201, 0.21870444131992509 } };
    static const double coefficients11[2][10] =
        { { 0.0, 0.0, 3.9999999999999987, 0.1304101327393258, -0.8417937871268423, 0.9331389496316885, 0.0, 0.11293848786315673, -0.729014804399755, -2.0203050891044185 },
          { 0.0, 0.0, 0.0, -0.3477603539715332, 0.33671751485073514, 1.3608276348795458, -0.20044593143431694, 0.6211616832473603, 0.5977921396078004, -0.8838834764831854 } };
    static const double coefficients12[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 0.952380952380952, 0.0, 0.0, 0.0, 0.824786098842322, 0.0 },
          { 4.000000000000001, 0.0, 0.0, -1.5983740793871857, 0.4761904761904759, -0.549857399228216, 0.0, -0.6388765649999407, 0.412393049421161, -0.1428571428571425 } };
    static const double coefficients13[2][10] =
        { { 0.0, 0.0, 0.0, 1.3552618543578767, 0.0, 0.0, 0.0, 1.1736911946539281, 0.0, 0.0 },
          { 0.0, 3.999999999999997, 0.0, 0.6776309271789375, -0.5248906591678234, 0.0, -2.0830952244882397, 0.5868455973269641, -0.10101525445522172, 0.0 } };
    static const double coefficients14[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 1.6835875742536839, 0.0, 0.0, 0.0, 1.45802960879951, 0.0 },
          { 0.0, 0.0, 4.000000000000001, 0.8259308406823959, 0.8417937871268415, -1.7885163201274024, 0.0, -1.1293848786315657, 0.7290148043997549, -0.25253813613805187 } };
    for (std::size_t k = 0; k < num_points * 15 * 2; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues3[10] = {};
        basisvalues3[0] = 1.0;
        const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues3[1] = tmp1_3;
        const double tmp2_3 = (1.0 - Y[1]) / 2.0;
        const double tmp3_3 = tmp2_3 * tmp2_3;
        basisvalues3[3] = 1.5 * tmp1_3 * basisvalues3[1] - 0.5 * tmp3_3 * basisvalues3[0];
        basisvalues3[6] = 1.6666666666666667 * tmp1_3 * basisvalues3[3] - 0.6666666666666666 * tmp3_3 * basisvalues3[1];
        basisvalues3[2] = (0.5 + 1.5 * Y[1]) * basisvalues3[0];
        basisvalues3[4] = (1.5 + 2.5 * Y[1]) * basisvalues3[1];
        basisvalues3[7] = (2.5 + 3.5 * Y[1]) * basisvalues3[3];
        basisvalues3[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues3[2] - 0.5555555555555556 * basisvalues3[0];
        basisvalues3[9] = (0.05 + 1.75 * Y[1]) * basisvalues3[5] - 0.7 * basisvalues3[2];
        basisvalues3[8] = (0.54 + 2.1 * Y[1]) * basisvalues3[4] - 0.56 * basisvalues3[1];
        basisvalues3[0] *= std::sqrt(0.5);
        basisvalues3[2] *= std::sqrt(1.0);
        basisvalues3[5] *= std::sqrt(1.5);
        basisvalues3[9] *= std::sqrt(2.0);
        basisvalues3[1] *= std::sqrt(3.0);
        basisvalues3[4] *= std::sqrt(4.5);
        basisvalues3[8] *= std::sqrt(6.0);
        basisvalues3[3] *= std::sqrt(7.5);
        basisvalues3[7] *= std::sqrt(10.0);
        basisvalues3[6] *= std::sqrt(14.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + c] += coefficients0[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 + c] += coefficients1[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 2 + c] += coefficients2[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 3 + c] += coefficients3[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 4 + c] += coefficients4[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 5 + c] += coefficients5[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 6 + c] += coefficients6[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 7 + c] += coefficients7[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 8 + c] += coefficients8[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 9 + c] += coefficients9[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 10 + c] += coefficients10[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 11 + c] += coefficients11[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 12 + c] += coefficients12[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 13 + c] += coefficients13[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 14 + c] += coefficients14[c][r] * basisvalues3[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 15 * num_derivatives * 2, 0.0);
    if (order > 3)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][10][10] =
        { { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 4.898979485566352, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 3.999999999999999, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 5.291502622129195, 0.0, -2.993325909419163, 13.662601021279459, 0.0, 0.6110100926607823, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 4.381780460041331, 0.0, 0.0, 12.521980673998824, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 3.4641016151377606, 0.0, 7.838367176906175, 0.0, 0.0, 8.400000000000006, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.5819888974716223, 4.743416490252574, -0.9128709291752789, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 1.999999999999918, 6.123724356957938, 3.5355339059327355, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { -2.30940107675849, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.645751311064574, 5.1845925587262585, -1.4966629547095671, 6.831300510639726, -1.058300524425831, 0.3055050463303896, 0.0, 0.0, 0.0, 0.0 },
            { 2.2360679774998258, 2.1908902300206754, 2.529822128134679, 8.082903768654775, 6.2609903369994075, -1.8073922282301222, 0.0, 0.0, 0.0, 0.0 },
            { 1.7320508075688785, -5.091168824543145, 3.9191835884530946, 0.0, 9.699484522385688, 4.200000000000007, 0.0, 0.0, 0.0, 0.0 },
            { 5.000000000000025, 0.0, -2.828427124746234, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } } };
    static const double coefficients0[2][10] =
        { { 0.0, 0.0, 0.0, -0.16953317256112305, 0.08417937871268444, -0.11664236870396065, 0.0, -0.14682003422210352, 0.07290148043997564, -0.10101525445522067 },
          { 0.0, 0.0, 0.0, 0.32167832742366925, -0.13468700594029484, 0.0972019739199673, 0.26057971086461407, -0.1298792610426302, 0.09768798378956733, -0.06313453403451322 } };
    static const double coefficients1[2][10] =
        { { 0.0, 0.0, 0.0, 0.0782460796435951, -0.1683587574253686, 0.3499271061118821, 0.0, 0.06776309271789378, -0.1458029608799512, 0.3030457633656624 },
          { 0.0, 0.0, 0.0, -0.16518616813647952, 0.2357022603955162, -0.27216552697590857, -0.12026755886059151, 0.1468200342221039, -0.22453655975512485, 0.17677669529663695 } };
    static const double coefficients2[2][10] =
        { { 0.0, 0.0, 0.0, -0.03912303982179753, -0.08417937871268419, -0.34992710611188227, 0.0, -0.033881546358946905, -0.07290148043997538, -0.3030457633656628 },
          { 0.0, 0.0, 0.0, 0.06085806194501872, 0.0, 0.21384434262392868, 0.060133779430295714, 0.0395284707521046, 0.11226827987756254, -0.13889597487592917 } };
    static const double coefficients3[2][10] =
        { { 0.0, 0.0, 0.0, 0.16953317256112277, 0.08417937871268391, 0.11664236870396082, 0.0, 0.14682003422210346, 0.07290148043997538, 0.10101525445522093 },
          { 0.0, 0.0, 0.0, 0.49121149998479163, 0.21886638465297903, 0.21384434262392799, -0.2605797108646136, 0.016940773179473394, -0.0247865033495918, 0.03788072042070807 } };
    static const double coefficients4[2][10] =
        { { 0.0, 0.0, 0.0, -0.07824607964359508, -0.16835875742536852, -0.3499271061118824, 0.0, -0.06776309271789387, -0.14580296087995095, -0.3030457633656629 },
          { 0.0, 0.0, 0.0, -0.24343224778007372, -0.40406101782088466, -0.6220926330877908, 0.12026755886059104, 0.07905694150420951, 0.07873359887517375, -0.1262690680690266 } };
    static const double coefficients5[2][10] =
        { { 0.0, 0.0, 0.0, 0.03912303982179732, -0.08417937871268408, 0.3499271061118821, 0.0, 0.033881546358946815, -0.07290148043997555, 0.30304576336566263 },
          { 0.0, 0.0, 0.0, 0.09998110176681575, -0.08417937871268388, 0.5637714487358106, -0.060133779430295804, 0.07341001711105198, -0.18516976031753798, 0.16414978848973436 } };
    static const double coefficients6[2][10] =
        { { 0.0, 0.0, 0.0, 0.3825363893686874, 0.30304576336566336, 0.3110463165438959, 0.0, -0.09035079029052522, -0.14580296087995084, -0.20203050891044197 },
          { 0.0, 0.0, 0.0, 0.16953317256112282, 0.08417937871268413, 0.11664236870396108, 0.16035674514745454, 0.0677630927178938, 0.03207665139358943, -0.07576144084141599 } };
    static const double coefficients7[2][10] =
        { { 0.0, 0.0, 0.0, -0.7650727787373746, 0.0, -0.15552315827194763, 0.0, 0.18070158058105046, 0.0, 0.10101525445522097 },
          { 0.0, 0.0, 0.0, -0.38253638936868767, 0.06734350297014775, -0.07776157913597376, -0.3207134902949093, 0.09035079029052548, -0.06415330278717865, 0.050507627227610714 } };
    static const double coefficients8[2][10] =
        { { 0.0, 0.0, 0.0, 0.3825363893686873, -0.3030457633656635, 0.3110463165438962, 0.0, -0.09035079029052508, 0.14580296087995115, -0.20203050891044175 },
          { 0.0, 0.0, 0.0, 0.21300321680756507, -0.2188663846529794, 0.19440394783993487, 0.16035674514745504, -0.1581138830084195, 0.17787961227354052, -0.1262690680690264 } };
    static const double coefficients9[2][10] =
        { { 3.9999999999999996, 0.0, 0.0, -0.36885555678165943, -0.47619047619047533, -1.6495721976846465, 0.0, -0.3194382824999711, -0.4123930494211605, 0.5714285714285697 },
          { 0.0, 0.0, 0.0, 0.6147592613027633, 0.476190476190476, -0.5498573992282135, 0.56694670951384, 0.15971914124998549, -0.45363235436327703, 0.35714285714285654 } };
    static const double coefficients10[2][10] =
        { { 0.0, 3.999999999999998, 0.0, -0.6776309271789392, 1.807956714911394, 0.0, 0.0, -0.5868455973269653, -1.2626906806902616, 0.0 },
          { 0.0, 0.0, 0.0, 1.054092553389456, 1.1664236870396085, -0.33671751485073326, 1.0415476122441178, 0.6846531968814589, -0.5808377131175201, 0.21870444131992509 } };
    static const double coefficients11[2][10] =
        { { 0.0, 0.0, 3.9999999999999987, 0.1304101327393258, -0.8417937871268423, 0.9331389496316885, 0.0, 0.11293848786315673, -0.729014804399755, -2.0203050891044185 },
          { 0.0, 0.0, 0.0, -0.3477603539715332, 0.33671751485073514, 1.3608276348795458, -0.20044593143431694, 0.6211616832473603, 0.5977921396078004, -0.8838834764831854 } };
    static const double coefficients12[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 0.952380952380952, 0.0, 0.0, 0.0, 0.824786098842322, 0.0 },
          { 4.000000000000001, 0.0, 0.0, -1.5983740793871857, 0.4761904761904759, -0.549857399228216, 0.0, -0.6388765649999407, 0.412393049421161, -0.1428571428571425 } };
    static const double coefficients13[2][10] =
        { { 0.0, 0.0, 0.0, 1.3552618543578767, 0.0, 0.0, 0.0, 1.1736911946539281, 0.0, 0.0 },
          { 0.0, 3.999999999999997, 0.0, 0.6776309271789375, -0.5248906591678234, 0.0, -2.0830952244882397, 0.5868455973269641, -0.10101525445522172, 0.0 } };
    static const double coefficients14[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 1.6835875742536839, 0.0, 0.0, 0.0, 1.45802960879951, 0.0 },
          { 0.0, 0.0, 4.000000000000001, 0.8259308406823959, 0.8417937871268415, -1.7885163201274024, 0.0, -1.1293848786315657, 0.7290148043997549, -0.25253813613805187 } };
    const std::size_t reference_offset[15] = {};
    const std::size_t num_components[15] = { 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2 };
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues3[10] = {};
        basisvalues3[0] = 1.0;
        const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues3[1] = tmp1_3;
        const double tmp2_3 = (1.0 - Y[1]) / 2.0;
        const double tmp3_3 = tmp2_3 * tmp2_3;
        basisvalues3[3] = 1.5 * tmp1_3 * basisvalues3[1] - 0.5 * tmp3_3 * basisvalues3[0];
        basisvalues3[6] = 1.6666666666666667 * tmp1_3 * basisvalues3[3] - 0.6666666666666666 * tmp3_3 * basisvalues3[1];
        basisvalues3[2] = (0.5 + 1.5 * Y[1]) * basisvalues3[0];
        basisvalues3[4] = (1.5 + 2.5 * Y[1]) * basisvalues3[1];
        basisvalues3[7] = (2.5 + 3.5 * Y[1]) * basisvalues3[3];
        basisvalues3[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues3[2] - 0.5555555555555556 * basisvalues3[0];
        basisvalues3[9] = (0.05 + 1.75 * Y[1]) * basisvalues3[5] - 0.7 * basisvalues3[2];
        basisvalues3[8] = (0.54 + 2.1 * Y[1]) * basisvalues3[4] - 0.56 * basisvalues3[1];
        basisvalues3[0] *= std::sqrt(0.5);
        basisvalues3[2] *= std::sqrt(1.0);
        basisvalues3[5] *= std::sqrt(1.5);
        basisvalues3[9] *= std::sqrt(2.0);
        basisvalues3[1] *= std::sqrt(3.0);
        basisvalues3[4] *= std::sqrt(4.5);
        basisvalues3[8] *= std::sqrt(6.0);
        basisvalues3[3] *= std::sqrt(7.5);
        basisvalues3[7] *= std::sqrt(10.0);
        basisvalues3[6] *= std::sqrt(14.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 15; ++i)
        {
            double derivatives[16] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients0[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients0[1][s] * aux[s];
                    }
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients1[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients1[1][s] * aux[s];
                    }
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients2[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients2[1][s] * aux[s];
                    }
                }
                break;
            case 3:
                // Compute reference derivatives for dof 3.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients3[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients3[1][s] * aux[s];
                    }
                }
                break;
            case 4:
                // Compute reference derivatives for dof 4.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients4[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients4[1][s] * aux[s];
                    }
                }
                break;
            case 5:
                // Compute reference derivatives for dof 5.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients5[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients5[1][s] * aux[s];
                    }
                }
                break;
            case 6:
                // Compute reference derivatives for dof 6.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients6[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients6[1][s] * aux[s];
                    }
                }
                break;
            case 7:
                // Compute reference derivatives for dof 7.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients7[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients7[1][s] * aux[s];
                    }
                }
                break;
            case 8:
                // Compute reference derivatives for dof 8.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients8[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients8[1][s] * aux[s];
                    }
                }
                break;
            case 9:
                // Compute reference derivatives for dof 9.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients9[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients9[1][s] * aux[s];
                    }
                }
                break;
            case 10:
                // Compute reference derivatives for dof 10.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients10[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients10[1][s] * aux[s];
                    }
                }
                break;
            case 11:
                // Compute reference derivatives for dof 11.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients11[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients11[1][s] * aux[s];
                    }
                }
                break;
            case 12:
                // Compute reference derivatives for dof 12.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients12[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients12[1][s] * aux[s];
                    }
                }
                break;
            case 13:
                // Compute reference derivatives for dof 13.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients13[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients13[1][s] * aux[s];
                    }
                }
                break;
            case 14:
                // Compute reference derivatives for dof 14.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients14[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients14[1][s] * aux[s];
                    }
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * i + 2 * r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    std::fill_n(values, num_points * 15 * num_derivatives * 2, 0.0);
    const std::size_t reference_offsets[15] = {};
    const std::size_t physical_offsets[15] = {};
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[8][8];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 15; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 2; ++i)
                {
                    // Using covariant Piola transform to map values back to the physical element.
                    const double mapped_value = K[2 * 2 * ip + i] * reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + reference_offsets[d]] + K[2 * 2 * ip + 2 + i] * reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + (reference_offsets[d] + 1)];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[30];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[30];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 2; ++k)
        values[k] = physical_values[2 * i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 15; ++r)
    {
        evaluate_basis(r, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2; ++s)
            values[r * 2 + s] = dof_values[s];
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, 2 * num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 3)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    // Declare transformation matrix
    double transform[8][8] =
        { { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.16953317256112305, 0.08417937871268444, -0.11664236870396065, 0.0, -0.14682003422210352, 0.07290148043997564, -0.10101525445522067 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.32167832742366925, -0.13468700594029484, 0.0972019739199673, 0.26057971086461407, -0.1298792610426302, 0.09768798378956733, -0.06313453403451322 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566352, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999999, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129195, -3.819545788160748e-14, -2.993325909419163, 13.662601021279459, 0.0, 0.6110100926607823, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041331, 0.0, 0.0, 12.521980673998824, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377606, 0.0, 7.838367176906175, 0.0, 0.0, 8.400000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716223, 4.743416490252574, -0.9128709291752789, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.999999999999918, 6.123724356957938, 3.5355339059327355, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.30940107675849, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064574, 5.1845925587262585, -1.4966629547095671, 6.831300510639726, -1.058300524425831, 0.3055050463303896, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998258, 2.1908902300206754, 2.529822128134679, 8.082903768654775, 6.2609903369994075, -1.8073922282301222, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688785, -5.091168824543145, 3.9191835884530946, 0.0, 9.699484522385688, 4.200000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000025, 0.0, -2.828427124746234, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 1:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.0782460796435951, -0.1683587574253686, 0.3499271061118821, 0.0, 0.06776309271789378, -0.1458029608799512, 0.3030457633656624 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.16518616813647952, 0.2357022603955162, -0.27216552697590857, -0.12026755886059151, 0.1468200342221039, -0.22453655975512485, 0.17677669529663695 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566352, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999999, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129195, -3.819545788160748e-14, -2.993325909419163, 13.662601021279459, 0.0, 0.6110100926607823, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041331, 0.0, 0.0, 12.521980673998824, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377606, 0.0, 7.838367176906175, 0.0, 0.0, 8.400000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716223, 4.743416490252574, -0.9128709291752789, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.999999999999918, 6.123724356957938, 3.5355339059327355, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.30940107675849, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064574, 5.1845925587262585, -1.4966629547095671, 6.831300510639726, -1.058300524425831, 0.3055050463303896, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998258, 2.1908902300206754, 2.529822128134679, 8.082903768654775, 6.2609903369994075, -1.8073922282301222, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688785, -5.091168824543145, 3.9191835884530946, 0.0, 9.699484522385688, 4.200000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000025, 0.0, -2.828427124746234, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 2:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.03912303982179753, -0.08417937871268419, -0.34992710611188227, 0.0, -0.033881546358946905, -0.07290148043997538, -0.3030457633656628 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.06085806194501872, 0.0, 0.21384434262392868, 0.060133779430295714, 0.0395284707521046, 0.11226827987756254, -0.13889597487592917 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566352, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999999, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129195, -3.819545788160748e-14, -2.993325909419163, 13.662601021279459, 0.0, 0.6110100926607823, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041331, 0.0, 0.0, 12.521980673998824, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377606, 0.0, 7.838367176906175, 0.0, 0.0, 8.400000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716223, 4.743416490252574, -0.9128709291752789, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.999999999999918, 6.123724356957938, 3.5355339059327355, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.30940107675849, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064574, 5.1845925587262585, -1.4966629547095671, 6.831300510639726, -1.058300524425831, 0.3055050463303896, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998258, 2.1908902300206754, 2.529822128134679, 8.082903768654775, 6.2609903369994075, -1.8073922282301222, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688785, -5.091168824543145, 3.9191835884530946, 0.0, 9.699484522385688, 4.200000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000025, 0.0, -2.828427124746234, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 3:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.16953317256112277, 0.08417937871268391, 0.11664236870396082, 0.0, 0.14682003422210346, 0.07290148043997538, 0.10101525445522093 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.49121149998479163, 0.21886638465297903, 0.21384434262392799, -0.2605797108646136, 0.016940773179473394, -0.0247865033495918, 0.03788072042070807 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566352, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999999, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129195, -3.819545788160748e-14, -2.993325909419163, 13.662601021279459, 0.0, 0.6110100926607823, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041331, 0.0, 0.0, 12.521980673998824, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377606, 0.0, 7.838367176906175, 0.0, 0.0, 8.400000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716223, 4.743416490252574, -0.9128709291752789, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.999999999999918, 6.123724356957938, 3.5355339059327355, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.30940107675849, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064574, 5.1845925587262585, -1.4966629547095671, 6.831300510639726, -1.058300524425831, 0.3055050463303896, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998258, 2.1908902300206754, 2.529822128134679, 8.082903768654775, 6.2609903369994075, -1.8073922282301222, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688785, -5.091168824543145, 3.9191835884530946, 0.0, 9.699484522385688, 4.200000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000025, 0.0, -2.828427124746234, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 4:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.07824607964359508, -0.16835875742536852, -0.3499271061118824, 0.0, -0.06776309271789387, -0.14580296087995095, -0.3030457633656629 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.24343224778007372, -0.40406101782088466, -0.6220926330877908, 0.12026755886059104, 0.07905694150420951, 0.07873359887517375, -0.1262690680690266 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566352, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999999, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129195, -3.819545788160748e-14, -2.993325909419163, 13.662601021279459, 0.0, 0.6110100926607823, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041331, 0.0, 0.0, 12.521980673998824, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377606, 0.0, 7.838367176906175, 0.0, 0.0, 8.400000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716223, 4.743416490252574, -0.9128709291752789, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.999999999999918, 6.123724356957938, 3.5355339059327355, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.30940107675849, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064574, 5.1845925587262585, -1.4966629547095671, 6.831300510639726, -1.058300524425831, 0.3055050463303896, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998258, 2.1908902300206754, 2.529822128134679, 8.082903768654775, 6.2609903369994075, -1.8073922282301222, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688785, -5.091168824543145, 3.9191835884530946, 0.0, 9.699484522385688, 4.200000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000025, 0.0, -2.828427124746234, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 5:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.03912303982179732, -0.08417937871268408, 0.3499271061118821, 0.0, 0.033881546358946815, -0.07290148043997555, 0.30304576336566263 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.09998110176681575, -0.08417937871268388, 0.5637714487358106, -0.060133779430295804, 0.07341001711105198, -0.18516976031753798, 0.16414978848973436 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566352, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999999, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129195, -3.819545788160748e-14, -2.993325909419163, 13.662601021279459, 0.0, 0.6110100926607823, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041331, 0.0, 0.0, 12.521980673998824, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377606, 0.0, 7.838367176906175, 0.0, 0.0, 8.400000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716223, 4.743416490252574, -0.9128709291752789, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.999999999999918, 6.123724356957938, 3.5355339059327355, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.30940107675849, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064574, 5.1845925587262585, -1.4966629547095671, 6.831300510639726, -1.058300524425831, 0.3055050463303896, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998258, 2.1908902300206754, 2.529822128134679, 8.082903768654775, 6.2609903369994075, -1.8073922282301222, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688785, -5.091168824543145, 3.9191835884530946, 0.0, 9.699484522385688, 4.200000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000025, 0.0, -2.828427124746234, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 6:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.3825363893686874, 0.30304576336566336, 0.3110463165438959, 0.0, -0.09035079029052522, -0.14580296087995084, -0.20203050891044197 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.16953317256112282, 0.08417937871268413, 0.11664236870396108, 0.16035674514745454, 0.0677630927178938, 0.03207665139358943, -0.07576144084141599 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566352, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999999, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129195, -3.819545788160748e-14, -2.993325909419163, 13.662601021279459, 0.0, 0.6110100926607823, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041331, 0.0, 0.0, 12.521980673998824, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377606, 0.0, 7.838367176906175, 0.0, 0.0, 8.400000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716223, 4.743416490252574, -0.9128709291752789, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.999999999999918, 6.123724356957938, 3.5355339059327355, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.30940107675849, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064574, 5.1845925587262585, -1.4966629547095671, 6.831300510639726, -1.058300524425831, 0.3055050463303896, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998258, 2.1908902300206754, 2.529822128134679, 8.082903768654775, 6.2609903369994075, -1.8073922282301222, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688785, -5.091168824543145, 3.9191835884530946, 0.0, 9.699484522385688, 4.200000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000025, 0.0, -2.828427124746234, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 7:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.7650727787373746, 0.0, -0.15552315827194763, 0.0, 0.18070158058105046, 0.0, 0.10101525445522097 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.38253638936868767, 0.06734350297014775, -0.07776157913597376, -0.3207134902949093, 0.09035079029052548, -0.06415330278717865, 0.050507627227610714 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566352, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999999, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129195, -3.819545788160748e-14, -2.993325909419163, 13.662601021279459, 0.0, 0.6110100926607823, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041331, 0.0, 0.0, 12.521980673998824, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377606, 0.0, 7.838367176906175, 0.0, 0.0, 8.400000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716223, 4.743416490252574, -0.9128709291752789, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.999999999999918, 6.123724356957938, 3.5355339059327355, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.30940107675849, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064574, 5.1845925587262585, -1.4966629547095671, 6.831300510639726, -1.058300524425831, 0.3055050463303896, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998258, 2.1908902300206754, 2.529822128134679, 8.082903768654775, 6.2609903369994075, -1.8073922282301222, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688785, -5.091168824543145, 3.9191835884530946, 0.0, 9.699484522385688, 4.200000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000025, 0.0, -2.828427124746234, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 8:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.3825363893686873, -0.3030457633656635, 0.3110463165438962, 0.0, -0.09035079029052508, 0.14580296087995115, -0.20203050891044175 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.21300321680756507, -0.2188663846529794, 0.19440394783993487, 0.16035674514745504, -0.1581138830084195, 0.17787961227354052, -0.1262690680690264 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566352, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999999, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129195, -3.819545788160748e-14, -2.993325909419163, 13.662601021279459, 0.0, 0.6110100926607823, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041331, 0.0, 0.0, 12.521980673998824, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377606, 0.0, 7.838367176906175, 0.0, 0.0, 8.400000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716223, 4.743416490252574, -0.9128709291752789, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.999999999999918, 6.123724356957938, 3.5355339059327355, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.30940107675849, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064574, 5.1845925587262585, -1.4966629547095671, 6.831300510639726, -1.058300524425831, 0.3055050463303896, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998258, 2.1908902300206754, 2.529822128134679, 8.082903768654775, 6.2609903369994075, -1.8073922282301222, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688785, -5.091168824543145, 3.9191835884530946, 0.0, 9.699484522385688, 4.200000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000025, 0.0, -2.828427124746234, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 9:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 3.9999999999999996, 0.0, 0.0, -0.36885555678165943, -0.47619047619047533, -1.6495721976846465, 0.0, -0.3194382824999711, -0.4123930494211605, 0.5714285714285697 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.6147592613027633, 0.476190476190476, -0.5498573992282135, 0.56694670951384, 0.15971914124998549, -0.45363235436327703, 0.35714285714285654 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566352, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999999, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129195, -3.819545788160748e-14, -2.993325909419163, 13.662601021279459, 0.0, 0.6110100926607823, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041331, 0.0, 0.0, 12.521980673998824, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377606, 0.0, 7.838367176906175, 0.0, 0.0, 8.400000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716223, 4.743416490252574, -0.9128709291752789, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.999999999999918, 6.123724356957938, 3.5355339059327355, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.30940107675849, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064574, 5.1845925587262585, -1.4966629547095671, 6.831300510639726, -1.058300524425831, 0.3055050463303896, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998258, 2.1908902300206754, 2.529822128134679, 8.082903768654775, 6.2609903369994075, -1.8073922282301222, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688785, -5.091168824543145, 3.9191835884530946, 0.0, 9.699484522385688, 4.200000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000025, 0.0, -2.828427124746234, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 10:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 3.999999999999998, 0.0, -0.6776309271789392, 1.807956714911394, 0.0, 0.0, -0.5868455973269653, -1.2626906806902616, 0.0 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 1.054092553389456, 1.1664236870396085, -0.33671751485073326, 1.0415476122441178, 0.6846531968814589, -0.5808377131175201, 0.21870444131992509 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566352, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999999, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129195, -3.819545788160748e-14, -2.993325909419163, 13.662601021279459, 0.0, 0.6110100926607823, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041331, 0.0, 0.0, 12.521980673998824, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377606, 0.0, 7.838367176906175, 0.0, 0.0, 8.400000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716223, 4.743416490252574, -0.9128709291752789, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.999999999999918, 6.123724356957938, 3.5355339059327355, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.30940107675849, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064574, 5.1845925587262585, -1.4966629547095671, 6.831300510639726, -1.058300524425831, 0.3055050463303896, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998258, 2.1908902300206754, 2.529822128134679, 8.082903768654775, 6.2609903369994075, -1.8073922282301222, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688785, -5.091168824543145, 3.9191835884530946, 0.0, 9.699484522385688, 4.200000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000025, 0.0, -2.828427124746234, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 11:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 3.9999999999999987, 0.1304101327393258, -0.8417937871268423, 0.9331389496316885, 0.0, 0.11293848786315673, -0.729014804399755, -2.0203050891044185 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.3477603539715332, 0.33671751485073514, 1.3608276348795458, -0.20044593143431694, 0.6211616832473603, 0.5977921396078004, -0.8838834764831854 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566352, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999999, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129195, -3.819545788160748e-14, -2.993325909419163, 13.662601021279459, 0.0, 0.6110100926607823, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041331, 0.0, 0.0, 12.521980673998824, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377606, 0.0, 7.838367176906175, 0.0, 0.0, 8.400000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716223, 4.743416490252574, -0.9128709291752789, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.999999999999918, 6.123724356957938, 3.5355339059327355, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.30940107675849, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064574, 5.1845925587262585, -1.4966629547095671, 6.831300510639726, -1.058300524425831, 0.3055050463303896, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998258, 2.1908902300206754, 2.529822128134679, 8.082903768654775, 6.2609903369994075, -1.8073922282301222, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688785, -5.091168824543145, 3.9191835884530946, 0.0, 9.699484522385688, 4.200000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000025, 0.0, -2.828427124746234, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 12:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.0, 0.952380952380952, 0.0, 0.0, 0.0, 0.824786098842322, 0.0 };
            static const double coefficients1[10] = { 4.000000000000001, 0.0, 0.0, -1.5983740793871857, 0.4761904761904759, -0.549857399228216, 0.0, -0.6388765649999407, 0.412393049421161, -0.1428571428571425 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566352, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999999, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129195, -3.819545788160748e-14, -2.993325909419163, 13.662601021279459, 0.0, 0.6110100926607823, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041331, 0.0, 0.0, 12.521980673998824, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377606, 0.0, 7.838367176906175, 0.0, 0.0, 8.400000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716223, 4.743416490252574, -0.9128709291752789, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.999999999999918, 6.123724356957938, 3.5355339059327355, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.30940107675849, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064574, 5.1845925587262585, -1.4966629547095671, 6.831300510639726, -1.058300524425831, 0.3055050463303896, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998258, 2.1908902300206754, 2.529822128134679, 8.082903768654775, 6.2609903369994075, -1.8073922282301222, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688785, -5.091168824543145, 3.9191835884530946, 0.0, 9.699484522385688, 4.200000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000025, 0.0, -2.828427124746234, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 13:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 1.3552618543578767, 0.0, 0.0, 0.0, 1.1736911946539281, 0.0, 0.0 };
            static const double coefficients1[10] = { 0.0, 3.999999999999997, 0.0, 0.6776309271789375, -0.5248906591678234, 0.0, -2.0830952244882397, 0.5868455973269641, -0.10101525445522172, 0.0 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566352, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999999, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129195, -3.819545788160748e-14, -2.993325909419163, 13.662601021279459, 0.0, 0.6110100926607823, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041331, 0.0, 0.0, 12.521980673998824, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377606, 0.0, 7.838367176906175, 0.0, 0.0, 8.400000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716223, 4.743416490252574, -0.9128709291752789, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.999999999999918, 6.123724356957938, 3.5355339059327355, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.30940107675849, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064574, 5.1845925587262585, -1.4966629547095671, 6.831300510639726, -1.058300524425831, 0.3055050463303896, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998258, 2.1908902300206754, 2.529822128134679, 8.082903768654775, 6.2609903369994075, -1.8073922282301222, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688785, -5.091168824543145, 3.9191835884530946, 0.0, 9.699484522385688, 4.200000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000025, 0.0, -2.828427124746234, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 14:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.0, 1.6835875742536839, 0.0, 0.0, 0.0, 1.45802960879951, 0.0 };
            static const double coefficients1[10] = { 0.0, 0.0, 4.000000000000001, 0.8259308406823959, 0.8417937871268415, -1.7885163201274024, 0.0, -1.1293848786315657, 0.7290148043997549, -0.25253813613805187 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566352, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505145, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.999999999999999, 0.0, 7.071067811865469, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129195, -3.819545788160748e-14, -2.993325909419163, 13.662601021279459, 0.0, 0.6110100926607823, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041331, 0.0, 0.0, 12.521980673998824, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.4641016151377606, 0.0, 7.838367176906175, 0.0, 0.0, 8.400000000000006, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.4494897427831828, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.2426406871192865, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716223, 4.743416490252574, -0.9128709291752789, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.999999999999918, 6.123724356957938, 3.5355339059327355, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.30940107675849, 0.0, 8.16496580927727, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.645751311064574, 5.1845925587262585, -1.4966629547095671, 6.831300510639726, -1.058300524425831, 0.3055050463303896, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998258, 2.1908902300206754, 2.529822128134679, 8.082903768654775, 6.2609903369994075, -1.8073922282301222, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688785, -5.091168824543145, 3.9191835884530946, 0.0, 9.699484522385688, 4.200000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 5.000000000000025, 0.0, -2.828427124746234, 0.0, 0.0, 12.12435565298216, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, 2 * num_derivatives * 15, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 3)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[16] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 15; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2 * num_derivatives; ++s)
            values[2 * num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    double result;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    switch (i)
    {
    case 0:
        {
            y[0] = 0.75 * coordinate_dofs[2] + 0.25 * coordinate_dofs[4];
            y[1] = 0.75 * coordinate_dofs[3] + 0.25 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 1:
        {
            y[0] = 0.5 * coordinate_dofs[2] + 0.5 * coordinate_dofs[4];
            y[1] = 0.5 * coordinate_dofs[3] + 0.5 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 2:
        {
            y[0] = 0.25 * coordinate_dofs[2] + 0.75 * coordinate_dofs[4];
            y[1] = 0.25 * coordinate_dofs[3] + 0.75 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 3:
        {
            y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[4];
            y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 4:
        {
            y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[4];
            y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 5:
        {
            y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[4];
            y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 6:
        {
            y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[2];
            y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 7:
        {
            y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[2];
            y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 8:
        {
            y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[2];
            y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 9:
        {
            result = 0.0;
            double X_9[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_9[36][1] = {};
            double W_9[36][1] =
                { { 0.004380007035333952 },
                  { 0.00821012828325171 },
                  { 0.008528136573677752 },
                  { 0.0059761382734593235 },
                  { 0.002662467899383865 },
                  { 0.0005292995210569465 },
                  { 0.009223072580491742 },
                  { 0.017288239137681006 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.011962482987098903 },
                  { 0.022423142044750127 },
                  { 0.023291672330955 },
                  { 0.016321766574367406 },
                  { 0.0072716154775874856 },
                  { 0.001445599622248223 },
                  { 0.011962482987098896 },
                  { 0.022423142044750117 },
                  { 0.023291672330954985 },
                  { 0.016321766574367395 },
                  { 0.007271615477587481 },
                  { 0.0014455996222482222 },
                  { 0.009223072580491742 },
                  { 0.01728823913768101 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.004380007035333964 },
                  { 0.008210128283251733 },
                  { 0.008528136573677774 },
                  { 0.005976138273459339 },
                  { 0.0026624678993838725 },
                  { 0.000529299521056948 } };
            double copy_9[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_9[r][0] - X_9[r][1];
                const double w1 = X_9[r][0];
                const double w2 = X_9[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_9[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_9[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_9[D_9[r][s]] * W_9[r][s];
            }
            return result;
        }
        break;
    case 10:
        {
            result = 0.0;
            double X_10[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_10[36][1] = {};
            double W_10[36][1] =
                { { -0.009710973194534896 },
                  { -0.015975694174423887 },
                  { -0.012914808498775162 },
                  { -0.006024109540551331 },
                  { -0.0014033523604530267 },
                  { -8.831972792250468e-5 },
                  { -0.01449999797697064 },
                  { -0.023854203751711895 },
                  { -0.019283823912786737 },
                  { -0.00899493535830189 },
                  { -0.00209542400951097 },
                  { -0.00013187513244538945 },
                  { -0.006787033586233021 },
                  { -0.011165469284399073 },
                  { -0.009026205436370045 },
                  { -0.0042102715103650165 },
                  { -0.0009808079389071213 },
                  { -6.172697089456968e-5 },
                  { 0.006787033586233017 },
                  { 0.011165469284399062 },
                  { 0.00902620543637004 },
                  { 0.004210271510365018 },
                  { 0.0009808079389071207 },
                  { 6.172697089456923e-5 },
                  { 0.014499997976970646 },
                  { 0.023854203751711905 },
                  { 0.01928382391278674 },
                  { 0.008994935358301898 },
                  { 0.00209542400951097 },
                  { 0.00013187513244538915 },
                  { 0.00971097319453492 },
                  { 0.015975694174423925 },
                  { 0.012914808498775193 },
                  { 0.006024109540551347 },
                  { 0.0014033523604530306 },
                  { 8.831972792250464e-5 } };
            double copy_10[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_10[r][0] - X_10[r][1];
                const double w1 = X_10[r][0];
                const double w2 = X_10[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_10[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_10[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_10[D_10[r][s]] * W_10[r][s];
            }
            return result;
        }
        break;
    case 11:
        {
            result = 0.0;
            double X_11[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_11[36][1] = {};
            double W_11[36][1] =
                { { -0.00564948416560004 },
                  { -0.006452908537728117 },
                  { 0.0001321127369674421 },
                  { 0.005713361221947881 },
                  { 0.00492388644483935 },
                  { 0.0013330322995734722 },
                  { -0.011896237170700168 },
                  { -0.013588024703755641 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.015429623211032667 },
                  { -0.017623900595856532 },
                  { 0.0003608205091003015 },
                  { 0.015604081423921987 },
                  { 0.013447902560801864 },
                  { 0.0036407193130650224 },
                  { -0.015429623211032657 },
                  { -0.017623900595856525 },
                  { 0.00036082050910030123 },
                  { 0.015604081423921978 },
                  { 0.013447902560801856 },
                  { 0.0036407193130650202 },
                  { -0.011896237170700168 },
                  { -0.013588024703755645 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.005649484165600055 },
                  { -0.006452908537728134 },
                  { 0.00013211273696744246 },
                  { 0.005713361221947897 },
                  { 0.004923886444839364 },
                  { 0.0013330322995734759 } };
            double copy_11[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_11[r][0] - X_11[r][1];
                const double w1 = X_11[r][0];
                const double w2 = X_11[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_11[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_11[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_11[D_11[r][s]] * W_11[r][s];
            }
            return result;
        }
        break;
    case 12:
        {
            result = 0.0;
            double X_12[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_12[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_12[36][1] =
                { { 0.004380007035333952 },
                  { 0.00821012828325171 },
                  { 0.008528136573677752 },
                  { 0.0059761382734593235 },
                  { 0.002662467899383865 },
                  { 0.0005292995210569465 },
                  { 0.009223072580491742 },
                  { 0.017288239137681006 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.011962482987098903 },
                  { 0.022423142044750127 },
                  { 0.023291672330955 },
                  { 0.016321766574367406 },
                  { 0.0072716154775874856 },
                  { 0.001445599622248223 },
                  { 0.011962482987098896 },
                  { 0.022423142044750117 },
                  { 0.023291672330954985 },
                  { 0.016321766574367395 },
                  { 0.007271615477587481 },
                  { 0.0014455996222482222 },
                  { 0.009223072580491742 },
                  { 0.01728823913768101 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.004380007035333964 },
                  { 0.008210128283251733 },
                  { 0.008528136573677774 },
                  { 0.005976138273459339 },
                  { 0.0026624678993838725 },
                  { 0.000529299521056948 } };
            double copy_12[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_12[r][0] - X_12[r][1];
                const double w1 = X_12[r][0];
                const double w2 = X_12[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_12[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_12[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_12[D_12[r][s]] * W_12[r][s];
            }
            return result;
        }
        break;
    case 13:
        {
            result = 0.0;
            double X_13[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_13[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_13[36][1] =
                { { -0.009710973194534896 },
                  { -0.015975694174423887 },
                  { -0.012914808498775162 },
                  { -0.006024109540551331 },
                  { -0.0014033523604530267 },
                  { -8.831972792250468e-5 },
                  { -0.01449999797697064 },
                  { -0.023854203751711895 },
                  { -0.019283823912786737 },
                  { -0.00899493535830189 },
                  { -0.00209542400951097 },
                  { -0.00013187513244538945 },
                  { -0.006787033586233021 },
                  { -0.011165469284399073 },
                  { -0.009026205436370045 },
                  { -0.0042102715103650165 },
                  { -0.0009808079389071213 },
                  { -6.172697089456968e-5 },
                  { 0.006787033586233017 },
                  { 0.011165469284399062 },
                  { 0.00902620543637004 },
                  { 0.004210271510365018 },
                  { 0.0009808079389071207 },
                  { 6.172697089456923e-5 },
                  { 0.014499997976970646 },
                  { 0.023854203751711905 },
                  { 0.01928382391278674 },
                  { 0.008994935358301898 },
                  { 0.00209542400951097 },
                  { 0.00013187513244538915 },
                  { 0.00971097319453492 },
                  { 0.015975694174423925 },
                  { 0.012914808498775193 },
                  { 0.006024109540551347 },
                  { 0.0014033523604530306 },
                  { 8.831972792250464e-5 } };
            double copy_13[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_13[r][0] - X_13[r][1];
                const double w1 = X_13[r][0];
                const double w2 = X_13[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_13[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_13[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_13[D_13[r][s]] * W_13[r][s];
            }
            return result;
        }
        break;
    case 14:
        {
            result = 0.0;
            double X_14[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_14[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_14[36][1] =
                { { -0.00564948416560004 },
                  { -0.006452908537728117 },
                  { 0.0001321127369674421 },
                  { 0.005713361221947881 },
                  { 0.00492388644483935 },
                  { 0.0013330322995734722 },
                  { -0.011896237170700168 },
                  { -0.013588024703755641 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.015429623211032667 },
                  { -0.017623900595856532 },
                  { 0.0003608205091003015 },
                  { 0.015604081423921987 },
                  { 0.013447902560801864 },
                  { 0.0036407193130650224 },
                  { -0.015429623211032657 },
                  { -0.017623900595856525 },
                  { 0.00036082050910030123 },
                  { 0.015604081423921978 },
                  { 0.013447902560801856 },
                  { 0.0036407193130650202 },
                  { -0.011896237170700168 },
                  { -0.013588024703755645 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.005649484165600055 },
                  { -0.006452908537728134 },
                  { 0.00013211273696744246 },
                  { 0.005713361221947897 },
                  { 0.004923886444839364 },
                  { 0.0013330322995734759 } };
            double copy_14[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_14[r][0] - X_14[r][1];
                const double w1 = X_14[r][0];
                const double w2 = X_14[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_14[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_14[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_14[D_14[r][s]] * W_14[r][s];
            }
            return result;
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    double result;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    y[0] = 0.75 * coordinate_dofs[2] + 0.25 * coordinate_dofs[4];
    y[1] = 0.75 * coordinate_dofs[3] + 0.25 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[0] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.5 * coordinate_dofs[2] + 0.5 * coordinate_dofs[4];
    y[1] = 0.5 * coordinate_dofs[3] + 0.5 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[1] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.25 * coordinate_dofs[2] + 0.75 * coordinate_dofs[4];
    y[1] = 0.25 * coordinate_dofs[3] + 0.75 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[4];
    y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[3] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[4];
    y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[4] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[4];
    y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[5] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[2];
    y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[6] = vals[0] * J[0] + vals[1] * J[2];
    y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[2];
    y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[7] = vals[0] * J[0] + vals[1] * J[2];
    y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[2];
    y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[8] = vals[0] * J[0] + vals[1] * J[2];
    result = 0.0;
    double X_9[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_9[36][1] = {};
    double W_9[36][1] =
        { { 0.004380007035333952 },
          { 0.00821012828325171 },
          { 0.008528136573677752 },
          { 0.0059761382734593235 },
          { 0.002662467899383865 },
          { 0.0005292995210569465 },
          { 0.009223072580491742 },
          { 0.017288239137681006 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.011962482987098903 },
          { 0.022423142044750127 },
          { 0.023291672330955 },
          { 0.016321766574367406 },
          { 0.0072716154775874856 },
          { 0.001445599622248223 },
          { 0.011962482987098896 },
          { 0.022423142044750117 },
          { 0.023291672330954985 },
          { 0.016321766574367395 },
          { 0.007271615477587481 },
          { 0.0014455996222482222 },
          { 0.009223072580491742 },
          { 0.01728823913768101 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.004380007035333964 },
          { 0.008210128283251733 },
          { 0.008528136573677774 },
          { 0.005976138273459339 },
          { 0.0026624678993838725 },
          { 0.000529299521056948 } };
    double copy_9[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_9[r][0] - X_9[r][1];
        const double w1 = X_9[r][0];
        const double w2 = X_9[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_9[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_9[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_9[D_9[r][s]] * W_9[r][s];
    }
    values[9] = result;
    result = 0.0;
    double X_10[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_10[36][1] = {};
    double W_10[36][1] =
        { { -0.009710973194534896 },
          { -0.015975694174423887 },
          { -0.012914808498775162 },
          { -0.006024109540551331 },
          { -0.0014033523604530267 },
          { -8.831972792250468e-5 },
          { -0.01449999797697064 },
          { -0.023854203751711895 },
          { -0.019283823912786737 },
          { -0.00899493535830189 },
          { -0.00209542400951097 },
          { -0.00013187513244538945 },
          { -0.006787033586233021 },
          { -0.011165469284399073 },
          { -0.009026205436370045 },
          { -0.0042102715103650165 },
          { -0.0009808079389071213 },
          { -6.172697089456968e-5 },
          { 0.006787033586233017 },
          { 0.011165469284399062 },
          { 0.00902620543637004 },
          { 0.004210271510365018 },
          { 0.0009808079389071207 },
          { 6.172697089456923e-5 },
          { 0.014499997976970646 },
          { 0.023854203751711905 },
          { 0.01928382391278674 },
          { 0.008994935358301898 },
          { 0.00209542400951097 },
          { 0.00013187513244538915 },
          { 0.00971097319453492 },
          { 0.015975694174423925 },
          { 0.012914808498775193 },
          { 0.006024109540551347 },
          { 0.0014033523604530306 },
          { 8.831972792250464e-5 } };
    double copy_10[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_10[r][0] - X_10[r][1];
        const double w1 = X_10[r][0];
        const double w2 = X_10[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_10[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_10[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_10[D_10[r][s]] * W_10[r][s];
    }
    values[10] = result;
    result = 0.0;
    double X_11[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_11[36][1] = {};
    double W_11[36][1] =
        { { -0.00564948416560004 },
          { -0.006452908537728117 },
          { 0.0001321127369674421 },
          { 0.005713361221947881 },
          { 0.00492388644483935 },
          { 0.0013330322995734722 },
          { -0.011896237170700168 },
          { -0.013588024703755641 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.015429623211032667 },
          { -0.017623900595856532 },
          { 0.0003608205091003015 },
          { 0.015604081423921987 },
          { 0.013447902560801864 },
          { 0.0036407193130650224 },
          { -0.015429623211032657 },
          { -0.017623900595856525 },
          { 0.00036082050910030123 },
          { 0.015604081423921978 },
          { 0.013447902560801856 },
          { 0.0036407193130650202 },
          { -0.011896237170700168 },
          { -0.013588024703755645 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.005649484165600055 },
          { -0.006452908537728134 },
          { 0.00013211273696744246 },
          { 0.005713361221947897 },
          { 0.004923886444839364 },
          { 0.0013330322995734759 } };
    double copy_11[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_11[r][0] - X_11[r][1];
        const double w1 = X_11[r][0];
        const double w2 = X_11[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_11[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_11[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_11[D_11[r][s]] * W_11[r][s];
    }
    values[11] = result;
    result = 0.0;
    double X_12[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_12[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_12[36][1] =
        { { 0.004380007035333952 },
          { 0.00821012828325171 },
          { 0.008528136573677752 },
          { 0.0059761382734593235 },
          { 0.002662467899383865 },
          { 0.0005292995210569465 },
          { 0.009223072580491742 },
          { 0.017288239137681006 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.011962482987098903 },
          { 0.022423142044750127 },
          { 0.023291672330955 },
          { 0.016321766574367406 },
          { 0.0072716154775874856 },
          { 0.001445599622248223 },
          { 0.011962482987098896 },
          { 0.022423142044750117 },
          { 0.023291672330954985 },
          { 0.016321766574367395 },
          { 0.007271615477587481 },
          { 0.0014455996222482222 },
          { 0.009223072580491742 },
          { 0.01728823913768101 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.004380007035333964 },
          { 0.008210128283251733 },
          { 0.008528136573677774 },
          { 0.005976138273459339 },
          { 0.0026624678993838725 },
          { 0.000529299521056948 } };
    double copy_12[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_12[r][0] - X_12[r][1];
        const double w1 = X_12[r][0];
        const double w2 = X_12[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_12[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_12[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_12[D_12[r][s]] * W_12[r][s];
    }
    values[12] = result;
    result = 0.0;
    double X_13[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_13[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_13[36][1] =
        { { -0.009710973194534896 },
          { -0.015975694174423887 },
          { -0.012914808498775162 },
          { -0.006024109540551331 },
          { -0.0014033523604530267 },
          { -8.831972792250468e-5 },
          { -0.01449999797697064 },
          { -0.023854203751711895 },
          { -0.019283823912786737 },
          { -0.00899493535830189 },
          { -0.00209542400951097 },
          { -0.00013187513244538945 },
          { -0.006787033586233021 },
          { -0.011165469284399073 },
          { -0.009026205436370045 },
          { -0.0042102715103650165 },
          { -0.0009808079389071213 },
          { -6.172697089456968e-5 },
          { 0.006787033586233017 },
          { 0.011165469284399062 },
          { 0.00902620543637004 },
          { 0.004210271510365018 },
          { 0.0009808079389071207 },
          { 6.172697089456923e-5 },
          { 0.014499997976970646 },
          { 0.023854203751711905 },
          { 0.01928382391278674 },
          { 0.008994935358301898 },
          { 0.00209542400951097 },
          { 0.00013187513244538915 },
          { 0.00971097319453492 },
          { 0.015975694174423925 },
          { 0.012914808498775193 },
          { 0.006024109540551347 },
          { 0.0014033523604530306 },
          { 8.831972792250464e-5 } };
    double copy_13[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_13[r][0] - X_13[r][1];
        const double w1 = X_13[r][0];
        const double w2 = X_13[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_13[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_13[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_13[D_13[r][s]] * W_13[r][s];
    }
    values[13] = result;
    result = 0.0;
    double X_14[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_14[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_14[36][1] =
        { { -0.00564948416560004 },
          { -0.006452908537728117 },
          { 0.0001321127369674421 },
          { 0.005713361221947881 },
          { 0.00492388644483935 },
          { 0.0013330322995734722 },
          { -0.011896237170700168 },
          { -0.013588024703755641 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.015429623211032667 },
          { -0.017623900595856532 },
          { 0.0003608205091003015 },
          { 0.015604081423921987 },
          { 0.013447902560801864 },
          { 0.0036407193130650224 },
          { -0.015429623211032657 },
          { -0.017623900595856525 },
          { 0.00036082050910030123 },
          { 0.015604081423921978 },
          { 0.013447902560801856 },
          { 0.0036407193130650202 },
          { -0.011896237170700168 },
          { -0.013588024703755645 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.005649484165600055 },
          { -0.006452908537728134 },
          { 0.00013211273696744246 },
          { 0.005713361221947897 },
          { 0.004923886444839364 },
          { 0.0013330322995734759 } };
    double copy_14[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_14[r][0] - X_14[r][1];
        const double w1 = X_14[r][0];
        const double w2 = X_14[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_14[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_14[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_14[D_14[r][s]] * W_14[r][s];
    }
    values[14] = result;
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Evaluate function and change variables
    vertex_values[0] = dof_values[3] * (K[2] * 2.999999999999999) + dof_values[4] * (K[2] * -3.0) + dof_values[5] * K[2] + dof_values[6] * (K[0] * 3.0) + dof_values[7] * (K[0] * -2.999999999999999) + dof_values[8] * K[0];
    vertex_values[2] = dof_values[0] * (K[2] * 3.0000000000000027) + dof_values[1] * (K[2] * -3.000000000000006) + dof_values[2] * K[2] + dof_values[6] * (K[0] + K[2]) + dof_values[7] * (K[0] * -3.0 + K[2] * -3.0000000000000027) + dof_values[8] * (K[0] * 3.0 + K[2] * 3.0000000000000053);
    vertex_values[4] = dof_values[0] * -K[0] + dof_values[1] * (K[0] * 2.999999999999994) + dof_values[2] * (K[0] * -2.9999999999999964) + dof_values[3] * (K[0] + K[2]) + dof_values[4] * (K[0] * -2.9999999999999973 + K[2] * -3.0) + dof_values[5] * (K[0] * 2.9999999999999956 + K[2] * 3.0000000000000004);
    vertex_values[1] = dof_values[3] * (K[2 + 1] * 2.999999999999999) + dof_values[4] * (K[2 + 1] * -3.0) + dof_values[5] * K[2 + 1] + dof_values[6] * (K[1] * 3.0) + dof_values[7] * (K[1] * -2.999999999999999) + dof_values[8] * K[1];
    vertex_values[3] = dof_values[0] * (K[2 + 1] * 3.0000000000000027) + dof_values[1] * (K[2 + 1] * -3.000000000000006) + dof_values[2] * K[2 + 1] + dof_values[6] * (K[1] + K[2 + 1]) + dof_values[7] * (K[1] * -3.0 + K[2 + 1] * -3.0000000000000027) + dof_values[8] * (K[1] * 3.0 + K[2 + 1] * 3.0000000000000053);
    vertex_values[5] = dof_values[0] * -K[1] + dof_values[1] * (K[1] * 2.999999999999994) + dof_values[2] * (K[1] * -2.9999999999999964) + dof_values[3] * (K[1] + K[2 + 1]) + dof_values[4] * (K[1] * -2.9999999999999973 + K[2 + 1] * -3.0) + dof_values[5] * (K[1] * 2.9999999999999956 + K[2 + 1] * 3.0000000000000004);
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    throw std::runtime_error("tabulate_dof_coordinates is not defined for this element");
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    throw std::runtime_error("tabulate_reference_dof_coordinates is not defined for this element");
  }

  std::size_t num_sub_elements() const final override
  {
    return 0;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_2();
  }

};


class forms_dofmap_0: public ufc::dofmap
{
public:

  forms_dofmap_0() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for FiniteElement('Lagrange', triangle, 1)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { true, false, false };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return num_global_entities[0];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 3;
  }

  std::size_t num_element_dofs() const final override
  {
    return 3;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 2;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 1, 0, 0 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 1, 2, 3 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    dofs[0] = entity_indices[0][0];
    dofs[1] = entity_indices[0][1];
    dofs[2] = entity_indices[0][2];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 1;
        dofs[1] = 2;
        break;
    case 1:
        dofs[0] = 0;
        dofs[1] = 2;
        break;
    case 2:
        dofs[0] = 0;
        dofs[1] = 1;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            break;
        case 1:
            dofs[0] = 1;
            break;
        case 2:
            dofs[0] = 2;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            break;
        case 1:
            dofs[0] = 1;
            break;
        case 2:
            dofs[0] = 2;
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 1;
            dofs[1] = 2;
            break;
        case 1:
            dofs[0] = 0;
            dofs[1] = 2;
            break;
        case 2:
            dofs[0] = 0;
            dofs[1] = 1;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 0;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_0();
  }

};


class forms_dofmap_1: public ufc::dofmap
{
public:

  forms_dofmap_1() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { true, false, false };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return 2 * num_global_entities[0];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 6;
  }

  std::size_t num_element_dofs() const final override
  {
    return 6;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 4;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 2, 0, 0 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 2, 4, 6 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    std::size_t offset = 0;
    dofs[0] = offset + entity_indices[0][0];
    dofs[1] = offset + entity_indices[0][1];
    dofs[2] = offset + entity_indices[0][2];
    offset += num_global_entities[0];
    dofs[3] = offset + entity_indices[0][0];
    dofs[4] = offset + entity_indices[0][1];
    dofs[5] = offset + entity_indices[0][2];
    offset += num_global_entities[0];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 1;
        dofs[1] = 2;
        dofs[2] = 4;
        dofs[3] = 5;
        break;
    case 1:
        dofs[0] = 0;
        dofs[1] = 2;
        dofs[2] = 3;
        dofs[3] = 5;
        break;
    case 2:
        dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 3;
        dofs[3] = 4;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 3;
            break;
        case 1:
            dofs[0] = 1;
            dofs[1] = 4;
            break;
        case 2:
            dofs[0] = 2;
            dofs[1] = 5;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 3;
            break;
        case 1:
            dofs[0] = 1;
            dofs[1] = 4;
            break;
        case 2:
            dofs[0] = 2;
            dofs[1] = 5;
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 1;
            dofs[1] = 2;
            dofs[2] = 4;
            dofs[3] = 5;
            break;
        case 1:
            dofs[0] = 0;
            dofs[1] = 2;
            dofs[2] = 3;
            dofs[3] = 5;
            break;
        case 2:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 3;
            dofs[3] = 4;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            dofs[3] = 3;
            dofs[4] = 4;
            dofs[5] = 5;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 2;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_0();
    case 1:
        return new forms_dofmap_0();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_1();
  }

};


class forms_dofmap_2: public ufc::dofmap
{
public:

  forms_dofmap_2() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_2() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for FiniteElement('Nedelec 1st kind H(curl)', triangle, 3)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { false, true, true };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return 3 * num_global_entities[1] + 6 * num_global_entities[2];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 15;
  }

  std::size_t num_element_dofs() const final override
  {
    return 15;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 3;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 0, 3, 6 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 0, 3, 15 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    std::size_t offset = 0;
    dofs[0] = offset + 3 * entity_indices[1][0];
    dofs[1] = offset + 3 * entity_indices[1][0] + 1;
    dofs[2] = offset + 3 * entity_indices[1][0] + 2;
    dofs[3] = offset + 3 * entity_indices[1][1];
    dofs[4] = offset + 3 * entity_indices[1][1] + 1;
    dofs[5] = offset + 3 * entity_indices[1][1] + 2;
    dofs[6] = offset + 3 * entity_indices[1][2];
    dofs[7] = offset + 3 * entity_indices[1][2] + 1;
    dofs[8] = offset + 3 * entity_indices[1][2] + 2;
    offset += 3 * num_global_entities[1];
    dofs[9] = offset + 6 * entity_indices[2][0];
    dofs[10] = offset + 6 * entity_indices[2][0] + 1;
    dofs[11] = offset + 6 * entity_indices[2][0] + 2;
    dofs[12] = offset + 6 * entity_indices[2][0] + 3;
    dofs[13] = offset + 6 * entity_indices[2][0] + 4;
    dofs[14] = offset + 6 * entity_indices[2][0] + 5;
    offset += 6 * num_global_entities[2];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 2;
        break;
    case 1:
        dofs[0] = 3;
        dofs[1] = 4;
        dofs[2] = 5;
        break;
    case 2:
        dofs[0] = 6;
        dofs[1] = 7;
        dofs[2] = 8;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        case 1:
            dofs[0] = 3;
            dofs[1] = 4;
            dofs[2] = 5;
            break;
        case 2:
            dofs[0] = 6;
            dofs[1] = 7;
            dofs[2] = 8;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 9;
            dofs[1] = 10;
            dofs[2] = 11;
            dofs[3] = 12;
            dofs[4] = 13;
            dofs[5] = 14;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            break;
        case 1:
            break;
        case 2:
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        case 1:
            dofs[0] = 3;
            dofs[1] = 4;
            dofs[2] = 5;
            break;
        case 2:
            dofs[0] = 6;
            dofs[1] = 7;
            dofs[2] = 8;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            dofs[3] = 3;
            dofs[4] = 4;
            dofs[5] = 5;
            dofs[6] = 6;
            dofs[7] = 7;
            dofs[8] = 8;
            dofs[9] = 9;
            dofs[10] = 10;
            dofs[11] = 11;
            dofs[12] = 12;
            dofs[13] = 13;
            dofs[14] = 14;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 0;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_2();
  }

};


class forms_coordinate_mapping_1: public ufc::coordinate_mapping
{
public:

  forms_coordinate_mapping_1() : ufc::coordinate_mapping()
  {
    // Do nothing
  }

  ~forms_coordinate_mapping_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC coordinate_mapping from VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  ufc::coordinate_mapping * create() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
  }

  void compute_physical_coordinates(
      double * x, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs) const final override
  {
    forms_finite_element_0 xelement;
    double phi[3];
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Compute basis values of coordinate element
        xelement.evaluate_reference_basis(phi, 1, &X[2 * ip]);
        // Compute x
        for (std::size_t i = 0; i < 2; ++i)
            for (std::size_t d = 0; d < 3; ++d)
                x[2 * ip + i] += coordinate_dofs[2 * d + i] * phi[d];
    }
  }

  void compute_reference_coordinates(
      double * X, std::size_t num_points,
      const double * x,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    const double phi_X0[3] = { 1.0, 0.0, 0.0 };
    const double dphi_X0[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    double J[4];
    double detJ[1];
    double K[4];
    double x0[2] = {};
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t k = 0; k < 3; ++k)
            x0[i] += coordinate_dofs[2 * k + i] * phi_X0[k];
    for (std::size_t i = 0; i < 2; ++i)
    {
        for (std::size_t j = 0; j < 2; ++j)
        {
            J[2 * i + j] = 0.0;
            for (std::size_t k = 0; k < 3; ++k)
                J[2 * i + j] += coordinate_dofs[2 * k + i] * dphi_X0[j][k];
        }
    }
    compute_jacobian_determinants(detJ, 1, J, cell_orientation);
    compute_jacobian_inverses(K, 1, J, detJ);
    for (std::size_t ip = 0; ip < num_points; ++ip)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t i = 0; i < 2; ++i)
                X[2 * ip + j] += K[2 * j + i] * (x[2 * ip + i] - x0[i]);
  }

  void compute_reference_geometry(
      double * X, double * J, double * detJ, double * K, std::size_t num_points,
      const double * x,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    const double phi_X0[3] = { 1.0, 0.0, 0.0 };
    const double dphi_X0[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    double x0[2] = {};
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t k = 0; k < 3; ++k)
            x0[i] += coordinate_dofs[2 * k + i] * phi_X0[k];
    for (std::size_t i = 0; i < 2; ++i)
    {
        for (std::size_t j = 0; j < 2; ++j)
        {
            J[2 * i + j] = 0.0;
            for (std::size_t k = 0; k < 3; ++k)
                J[2 * i + j] += coordinate_dofs[2 * k + i] * dphi_X0[j][k];
        }
    }
    compute_jacobian_determinants(detJ, 1, J, cell_orientation);
    compute_jacobian_inverses(K, 1, J, detJ);
    for (std::size_t ip = 0; ip < num_points; ++ip)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t i = 0; i < 2; ++i)
                X[2 * ip + j] += K[2 * j + i] * (x[2 * ip + i] - x0[i]);
  }

  void compute_jacobians(
      double * J, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs) const final override
  {
    forms_finite_element_0 xelement;
    double dphi[6];
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Compute basis derivatives of coordinate element
        xelement.evaluate_reference_basis_derivatives(dphi, 1, 1, &X[2 * ip]);
        // Compute J
        for (std::size_t i = 0; i < 2; ++i)
            for (std::size_t j = 0; j < 2; ++j)
                for (std::size_t d = 0; d < 3; ++d)
                    J[2 * 2 * ip + 2 * i + j] += coordinate_dofs[2 * d + i] * dphi[2 * d + j];
    }
  }

  void compute_jacobian_determinants(
      double * detJ, std::size_t num_points,
      const double * J,
      int cell_orientation) const final override
  {
    for (std::size_t ip = 0; ip < num_points; ++ip)
        detJ[ip] = J[2 * 2 * ip] * J[2 * 2 * ip + 2 + 1] - J[2 * 2 * ip + 1] * J[2 * 2 * ip + 2];
  }

  void compute_jacobian_inverses(
      double * K, std::size_t num_points,
      const double * J, const double * detJ) const final override
  {
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        K[2 * 2 * ip] = J[2 * 2 * ip + 2 + 1] / detJ[ip];
        K[2 * 2 * ip + 1] = -J[2 * 2 * ip + 1] / detJ[ip];
        K[2 * 2 * ip + 2] = -J[2 * 2 * ip + 2] / detJ[ip];
        K[2 * 2 * ip + 2 + 1] = J[2 * 2 * ip] / detJ[ip];
    }
  }

  void compute_geometry(
      double * x, double * J, double * detJ, double * K, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    compute_physical_coordinates(x, num_points, X, coordinate_dofs);
    compute_jacobians(J, num_points, X, coordinate_dofs);
    compute_jacobian_determinants(detJ, num_points, J, cell_orientation);
    compute_jacobian_inverses(K, num_points, J, detJ);
  }

  void compute_midpoint_geometry(
      double * x, double * J,
      const double * coordinate_dofs) const final override
  {
    const double phi_Xm[3] = { 0.33333333333333337, 0.3333333333333333, 0.3333333333333333 };
    const double dphi_Xm[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    // Compute x
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t d = 0; d < 3; ++d)
            x[i] += coordinate_dofs[2 * d + i] * phi_Xm[d];
    // Compute J
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t d = 0; d < 3; ++d)
                J[2 * i + j] += coordinate_dofs[2 * d + i] * dphi_Xm[j][d];
  }

};


class forms_cell_integral_0_otherwise: public ufc::cell_integral
{
public:

  forms_cell_integral_0_otherwise() : ufc::cell_integral()
  {

  }

  ~forms_cell_integral_0_otherwise() override
  {

  }

  const std::vector<bool> & enabled_coefficients() const final override
  {
static const std::vector<bool> enabled({});
return enabled;
  }

  void tabulate_tensor(double * A,
                       const double * const * w,
                       const double * coordinate_dofs,
                       int cell_orientation,
                       std::size_t local_facet) const final override
  {
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    // num_cells:         None
    // optimize:          True
    // precision:         16
    // quadrature_degree: 4
    // quadrature_rule:   'default'
    // representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    // estimated_polynomial_degree: 4
    // optimize:                    True
    // precision:                   16
    // quadrature_degree:           4
    // quadrature_rule:             'default'
    // representation:              'uflacs'
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE3_C0_D01_Q6[1][1][2] = { { { -1.0, 1.0 } } };
    alignas(32) static const double PI0[1][15][15] =
        { { { 2.633333333333341, -2.016666666666669, -0.03333333333333266, -1.591666666666672, -0.0666666666666661, -1.008333333333332, -1.091666666666672, 2.600000000000011, -1.508333333333339, 1.649915822768634, 10.96965511460291, -6.833333333333345, 5.892556509887888, -16.88749537379661, 10.41666666666666 },
            { -2.016666666666669, 2.53333333333334, 0.8166666666666706, -0.06666666666667215, 1.633333333333344, 1.266666666666667, 0.1833333333333358, -1.200000000000004, 1.016666666666666, 3.771236166328269, -8.948929172439174, 11.1666666666667, -11.78511301977583, 7.794228634059968, -20.8333333333334 },
            { -0.03333333333333266, 0.8166666666666706, 0.6333333333333357, -1.008333333333338, 1.266666666666673, 0.4083333333333349, -0.5083333333333334, 0.5999999999999999, -0.09166666666666855, 4.006938426723787, -0.5773502691896069, 4.833333333333352, -5.892556509887922, -3.897114317029975, -10.41666666666671 },
            { -1.591666666666672, -0.06666666666667215, -1.008333333333338, 2.633333333333344, -2.016666666666677, -0.03333333333333698, 1.508333333333335, -2.600000000000005, 1.091666666666673, -7.54247233265655, -5.91784025919372, -3.583333333333357, 5.892556509887944, 16.88749537379659, 10.41666666666674 },
            { -0.0666666666666661, 1.633333333333344, 1.266666666666673, -2.016666666666677, 2.533333333333347, 0.8166666666666708, -1.016666666666667, 1.2, -0.183333333333337, 8.013876853447581, -1.154700538379214, 9.666666666666712, -11.78511301977586, -7.794228634059952, -20.83333333333344 },
            { -1.008333333333332, 1.266666666666667, 0.4083333333333349, -0.03333333333333698, 0.8166666666666708, 0.6333333333333324, 0.09166666666666677, -0.5999999999999985, 0.5083333333333308, 1.885618083164134, -4.474464586219571, 5.583333333333342, -5.892556509887903, 3.897114317029969, -10.41666666666668 },
            { -1.091666666666672, 0.1833333333333358, -0.5083333333333334, 1.508333333333335, -1.016666666666667, 0.09166666666666677, 3.683333333333335, -5.866666666666674, 2.183333333333341, -4.006938426723779, 2.742413778650681, -1.08333333333332, 2.357022603955157, 10.39230484541329, 4.166666666666656 },
            { 2.600000000000011, -1.200000000000004, 0.5999999999999999, -2.600000000000005, 1.2, -0.5999999999999985, -5.866666666666674, 11.73333333333335, -5.866666666666677, 5.656854249492401, 10.39230484541329, -2.000000000000023, 0.0, -20.78460969082658, 0.0 },
            { -1.508333333333339, 1.016666666666666, -0.09166666666666855, 1.091666666666673, -0.183333333333337, 0.5083333333333308, 2.183333333333341, -5.866666666666677, 3.683333333333338, -1.649915822768635, -13.13471862406397, 3.083333333333329, -2.357022603955138, 10.39230484541331, -4.166666666666638 },
            { 1.649915822768634, 3.771236166328269, 4.006938426723787, -7.54247233265655, 8.013876853447581, 1.885618083164134, -4.006938426723779, 5.656854249492401, -1.649915822768635, 26.66666666666683, 4.082482904638828, 25.92724864350683, -33.3333333333335, -36.74234614174783, -58.92556509887923 },
            { 10.96965511460291, -8.948929172439174, -0.5773502691896069, -5.91784025919372, -1.154700538379214, -4.474464586219571, 2.742413778650681, 10.39230484541329, -13.13471862406397, 4.082482904638828, 189.9999999999994, -31.75426480542929, 28.57738033247016, -67.50000000000034, 50.51814855409184 },
            { -6.833333333333345, 11.1666666666667, 4.833333333333352, -3.583333333333357, 9.666666666666712, 5.583333333333342, -1.08333333333332, -2.000000000000023, 3.083333333333329, 25.92724864350683, -31.75426480542929, 53.3333333333335, -58.92556509887915, 12.9903810567667, -104.166666666667 },
            { 5.892556509887888, -11.78511301977583, -5.892556509887922, 5.892556509887944, -11.78511301977586, -5.892556509887903, 2.357022603955157, 0.0, -2.357022603955138, -33.3333333333335, 28.57738033247016, -58.92556509887915, 66.66666666666688, 0.0, 117.8511301977583 },
            { -16.88749537379661, 7.794228634059968, -3.897114317029975, 16.88749537379659, -7.794228634059952, 3.897114317029969, 10.39230484541329, -20.78460969082658, 10.39230484541331, -36.74234614174783, -67.50000000000034, 12.9903810567667, 0.0, 135.0000000000003, 0.0 },
            { 10.41666666666666, -20.8333333333334, -10.41666666666671, 10.41666666666674, -20.83333333333344, -10.41666666666668, 4.166666666666656, 0.0, -4.166666666666638, -58.92556509887923, 50.51814855409184, -104.166666666667, 117.8511301977583, 0.0, 208.333333333334 } } };
    alignas(32) static const double PI1[1][15][15] =
        { { { 0.3583333333333394, 1.116666666666663, -0.8916666666666659, -0.6500000000000032, -0.5333333333333328, 1.183333333333332, -1.108333333333341, 1.216666666666669, 0.3083333333333463, 0.4714045207910198, 0.7216878364869831, 1.583333333333345, -1.649915822768607, -7.36121593216776, -2.916666666666651 },
            { 0.2833333333333332, -1.733333333333337, 2.783333333333346, -0.9500000000000063, 3.066666666666683, -2.116666666666674, -0.03333333333332641, -0.433333333333332, -0.3666666666666857, 6.128258770283461, -1.443375672973976, 1.833333333333343, -3.771236166328283, 1.732050807568877, -6.666666666666724 },
            { 0.441666666666669, -0.7166666666666702, 1.691666666666674, -1.150000000000004, 2.133333333333342, -0.9833333333333387, -0.6916666666666639, 0.3833333333333343, -0.1083333333333408, 5.18544972870137, -0.7216878364869928, 2.41666666666667, -4.006938426723781, -3.031088913245544, -7.083333333333355 },
            { -0.9416666666666742, 0.4666666666666758, -2.19166666666668, 2.275000000000009, -3.13333333333335, 0.8583333333333443, 1.816666666666665, -1.383333333333334, -0.01666666666666233, -8.720983634634116, 0.721687836486989, -4.916666666666691, 7.542472332656525, 9.526279441628857, 13.33333333333336 },
            { 0.8833333333333386, -1.433333333333342, 3.383333333333351, -2.30000000000001, 4.266666666666689, -1.966666666666679, -1.383333333333328, 0.7666666666666686, -0.216666666666682, 10.37089945740275, -1.443375672973985, 4.833333333333345, -8.013876853447568, -6.062177826491091, -14.16666666666672 },
            { 0.1416666666666669, -0.8666666666666674, 1.391666666666671, -0.4750000000000031, 1.533333333333341, -1.058333333333336, -0.01666666666666436, -0.2166666666666647, -0.1833333333333421, 3.064129385141727, -0.7216878364869891, 0.9166666666666756, -1.885618083164139, 0.8660254037844338, -3.33333333333336 },
            { -0.7333333333333453, -0.1166666666666577, 0.2666666666666635, 0.7750000000000071, 0.03333333333332916, -0.3083333333333281, 5.508333333333322, -3.433333333333328, -0.241666666666667, -6.835365551469957, 17.89785834487832, 12.16666666666666, 0.2357022603955041, 7.361215932167792, 0.4166666666666377 },
            { 1.466666666666684, -0.9333333333333421, 0.1333333333333395, -1.133333333333348, 0.2666666666666764, -0.4666666666666714, -7.933333333333318, 5.866666666666656, 2.06666666666668, 1.885618083164118, -30.02221399786045, -2.666666666666637, 1.885618083164118, -10.39230484541338, 3.333333333333331 },
            { -0.7333333333333408, 1.050000000000002, -0.4000000000000088, 0.3583333333333453, -0.300000000000013, 0.7750000000000026, 2.424999999999997, -2.433333333333328, -1.825000000000014, 4.949747468305822, 12.12435565298212, -9.500000000000039, -2.12132034355961, 3.0310889132456, -3.749999999999946 },
            { 3.06412938514173, -3.771236166328278, 10.13519719700723, -7.778174593052061, 13.19932658214895, -5.421151989096899, -5.185449728701339, 3.299831645537234, -0.4714045207910675, 33.33333333333348, -4.082482904638397, 16.49915822768618, -26.66666666666676, -24.49489742783192, -47.14045207910334 },
            { 0.1443375672973208, -3.175426480542791, 4.474464586219609, -0.8660254037844592, 4.618802153517061, -3.752776749732474, 0.7216878364868711, -1.443375672974031, -0.7216878364868851, 8.164965809277408, 57.49999999999892, 105.3664241271069, -4.082482904639196, 7.500000000000131, -7.216878364871341 },
            { 2.416666666666671, -8.166666666666689, 14.91666666666672, -7.000000000000028, 17.33333333333341, -10.33333333333337, -2.416666666666628, -0.1666666666666635, -1.583333333333422, 37.71236166328274, -7.216878364869892, 14.16666666666671, -25.92724864350685, -4.330127018922187, -45.83333333333356 },
            { -3.299831645537237, 8.956685895029629, -17.44196726926825, 9.192388155425164, -20.7417989148055, 11.54941075938033, 4.00693842672374, -0.9428090415820782, 1.649915822768706, -46.66666666666694, 8.164965809276779, -18.85618083164135, 33.33333333333349, 12.24744871391597, 58.92556509887928 },
            { -5.196152422706673, -2.598076211353297, -5.196152422706628, 11.69134295108994, -10.39230484541326, -1.299038105676648, 11.69134295108994, -10.39230484541327, -1.29903810567669, -36.74234614174763, 0.0, -25.98076211353316, 36.74234614174761, 67.50000000000018, 64.95190528383274 },
            { -5.833333333333355, 15.83333333333338, -30.83333333333346, 16.25000000000007, -36.66666666666684, 20.41666666666675, 7.083333333333274, -1.666666666666687, 2.916666666666837, -82.495791138431, 14.43375672973978, -33.33333333333348, 58.92556509887923, 21.65063509461105, 104.1666666666672 } } };
    alignas(32) static const double PI2[1][15][15] =
        { { { -0.6083333333333357, -0.6166666666666661, -0.1916666666666668, -2.283333333333343, -0.09999999999999554, -2.116666666666671, -1.108333333333335, 1.21666666666667, 0.3083333333333332, -5.185449728701357, -10.53664241271068, 0.08333333333333659, 16.73486048808165, -7.361215932167758, 10.08333333333332 },
            { 0.2166666666666655, 0.7333333333333364, -0.6166666666666736, 0.316666666666665, 1.199999999999999, 2.48333333333334, -0.03333333333333993, -0.4333333333333318, -0.366666666666668, 3.299831645537226, 3.752776749732542, -5.16666666666671, -12.25651754056682, 1.73205080756887, -12.66666666666667 },
            { -0.1916666666666678, 0.2166666666666689, -0.6083333333333375, -1.11666666666667, 0.9000000000000008, 0.7166666666666692, -0.6916666666666704, 0.3833333333333345, -0.1083333333333341, -0.4714045207910295, -3.319764047840359, -4.083333333333359, 0.2357022603955239, -3.031088913245553, -4.083333333333341 },
            { 0.6916666666666699, 0.03333333333332911, 1.10833333333334, 3.241666666666677, -1.400000000000003, 0.1583333333333309, 1.816666666666673, -1.383333333333337, -0.01666666666666528, 4.006938426723769, 11.98001808568475, 6.583333333333377, -10.84230397819375, 9.526279441628864, 0.3333333333333512 },
            { -0.3833333333333357, 0.4333333333333383, -1.216666666666676, -2.233333333333341, 1.800000000000002, 1.433333333333341, -1.383333333333342, 0.766666666666669, -0.2166666666666683, -0.9428090415820582, -6.639528095680722, -8.166666666666725, 0.471404520791042, -6.062177826491108, -8.166666666666687 },
            { 0.1083333333333314, 0.3666666666666682, -0.3083333333333366, 0.1583333333333305, 0.599999999999999, 1.241666666666667, -0.0166666666666707, -0.2166666666666643, -0.1833333333333344, 1.649915822768608, 1.876388374866263, -2.583333333333352, -6.128258770283391, 0.8660254037844323, -6.333333333333323 },
            { 2.133333333333351, -0.6833333333333478, 0.4666666666666722, 4.308333333333328, -2.866666666666661, 0.5583333333333325, 1.508333333333342, -2.766666666666686, 1.09166666666668, 5.892556509887912, 10.96965511460291, -1.833333333333341, -11.07800623858926, 7.361215932167669, 8.416666666666682 },
            { -4.933333333333364, 2.533333333333359, -0.9333333333333431, -7.533333333333328, 3.733333333333327, -1.53333333333333, -2.600000000000015, 5.866666666666702, -3.26666666666669, -9.428090415820666, -16.16580753730956, 5.333333333333343, 24.51303508113367, -10.39230484541318, -12.66666666666671 },
            { 2.800000000000015, -1.850000000000013, 0.4666666666666735, 3.225000000000002, -0.8666666666666677, 0.9749999999999958, 1.091666666666676, -3.10000000000002, 2.175000000000012, 3.53553390593276, 5.196152422706668, -3.499999999999989, -13.43502884254442, 3.031088913245512, 4.250000000000036 },
            { -1.649915822768627, 0.9428090415820773, -4.006938426723801, -8.720983634634125, 5.656854249492388, 3.064129385141713, -5.185449728701384, 3.299831645537243, -0.4714045207910371, -6.666666666666694, -28.57738033247057, -25.92724864350692, 13.33333333333349, -24.49489742783194, -18.85618083164128 },
            { 0.7216878364871016, 1.443375672974015, -0.7216878364870365, -11.83568051838744, -5.196152422706555, -8.9489291724392, 0.7216878364870385, -1.443375672974122, -0.7216878364869779, 8.164965809277277, 12.49999999999996, -7.216878364870508, 69.40220937885674, 7.499999999999044, 44.7446458621959 },
            { 0.08333333333332825, 3.166666666666683, -4.083333333333366, -2.666666666666672, 6.999999999999995, 10.6666666666667, -2.416666666666695, -0.1666666666666637, -1.58333333333334, 9.428090415820671, 1.443375672973984, -30.83333333333356, -40.06938426723768, -4.33012701892225, -55.83333333333336 },
            { 0.4714045207910448, -3.299831645537243, 5.185449728701393, 5.421151989096902, -8.485281374238573, -11.07800623858927, 4.006938426723814, -0.9428090415820788, 1.649915822768619, -6.666666666666671, 8.164965809277442, 37.71236166328281, 33.33333333333319, 12.24744871391604, 58.92556509887898 },
            { 5.196152422706645, 2.598076211353311, 5.196152422706641, 22.08364779650324, -5.19615242270664, 9.093266739736643, 11.69134295108994, -10.39230484541328, -1.299038105676661, 36.74234614174772, 90.00000000000004, 25.9807621135332, -110.2270384252433, 67.50000000000021, -38.97114317029977 },
            { 0.8333333333333482, -5.833333333333368, 9.166666666666741, 9.583333333333385, -15.0, -19.58333333333338, 7.083333333333403, -1.666666666666682, 2.916666666666678, -11.78511301977583, 14.43375672974089, 66.66666666666714, 58.92556509887877, 21.65063509461121, 104.1666666666667 } } };
    alignas(32) static const double PI3[1][15][15] =
        { { { -0.608333333333329, -0.61666666666668, -0.1916666666666621, -0.6500000000000083, -0.5333333333333318, 1.18333333333333, -1.108333333333335, 1.216666666666665, 0.3083333333333452, -5.185449728701379, -10.53664241271072, 0.08333333333335613, 4.00693842672379, 3.897114317029966, -1.41666666666667 },
            { 0.2166666666666587, 0.7333333333333498, -0.6166666666666762, -0.9499999999999993, 3.066666666666674, -2.116666666666675, -0.03333333333333738, -0.433333333333328, -0.3666666666666809, 3.299831645537248, 3.752776749732595, -5.166666666666712, -0.9428090415820525, -3.464101615137764, 0.3333333333333524 },
            { -0.1916666666666696, 0.216666666666672, -0.6083333333333369, -1.150000000000002, 2.133333333333336, -0.9833333333333395, -0.6916666666666684, 0.3833333333333348, -0.1083333333333375, -0.4714045207910242, -3.319764047840342, -4.08333333333335, 1.649915822768627, -0.4330127018922372, -0.5833333333333244 },
            { 0.6916666666666682, 0.03333333333333219, 1.108333333333337, 2.275000000000007, -3.133333333333339, 0.8583333333333464, 1.81666666666667, -1.383333333333334, -0.01666666666666689, 4.006938426723772, 11.98001808568475, 6.583333333333349, -5.185449728701384, -1.732050807568845, 1.83333333333331 },
            { -0.3833333333333393, 0.4333333333333447, -1.216666666666675, -2.300000000000005, 4.266666666666675, -1.966666666666682, -1.383333333333338, 0.7666666666666697, -0.2166666666666754, -0.9428090415820471, -6.639528095680685, -8.166666666666707, 3.299831645537254, -0.8660254037844759, -1.166666666666647 },
            { 0.1083333333333287, 0.3666666666666739, -0.3083333333333377, -0.4749999999999996, 1.533333333333336, -1.058333333333336, -0.01666666666666938, -0.2166666666666628, -0.1833333333333399, 1.649915822768617, 1.876388374866287, -2.583333333333351, -0.4714045207910225, -1.732050807568874, 0.1666666666666781 },
            { 1.150000000000004, 0.9499999999999998, 0.6500000000000018, 2.591666666666664, -3.933333333333326, 1.34166666666667, 2.275000000000003, -2.300000000000003, -0.4750000000000008, 9.192388155425128, 19.91858428704211, 1.999999999999998, -7.778174593052068, -6.495190528383264, 2.749999999999967 },
            { -2.133333333333334, -3.066666666666677, 0.5333333333333358, -3.933333333333338, 5.866666666666657, -1.933333333333335, -3.133333333333336, 4.266666666666667, 1.533333333333345, -20.74179891480542, -36.9504172281361, 9.333333333333357, 13.19932658214895, 17.32050807568872, -4.666666666666668 },
            { 0.9833333333333306, 2.116666666666677, -1.183333333333336, 1.341666666666676, -1.933333333333337, 0.5916666666666669, 0.8583333333333359, -1.966666666666665, -1.058333333333344, 11.5494107593803, 17.031832941094, -11.33333333333334, -5.421151989096884, -10.82531754730546, 1.9166666666667 },
            { -1.649915822768631, 0.9428090415820849, -4.006938426723792, -7.778174593052047, 13.19932658214891, -5.421151989096904, -5.18544972870137, 3.299831645537239, -0.4714045207910486, -6.666666666666673, -28.57738033247048, -25.92724864350684, 13.33333333333348, 0.0, -4.714045207910269 },
            { 0.7216878364870858, 1.443375672973947, -0.7216878364870265, -0.866025403784549, 4.618802153517113, -3.752776749732455, 0.7216878364870047, -1.443375672974093, -0.7216878364869399, 8.164965809276985, 12.49999999999938, -7.216878364870428, -4.082482904638974, 52.5000000000002, 105.3664241271056 },
            { 0.08333333333329959, 3.16666666666674, -4.083333333333374, -6.999999999999996, 17.33333333333335, -10.33333333333338, -2.416666666666679, -0.1666666666666491, -1.583333333333395, 9.428090415820762, 1.443375672974222, -30.83333333333352, 2.357022603955228, -12.99038105676668, -0.8333333333332369 },
            { 0.4714045207910733, -3.299831645537297, 5.185449728701398, 9.192388155425132, -20.74179891480544, 11.54941075938033, 4.006938426723796, -0.9428090415820918, 1.649915822768674, -6.666666666666764, 8.16496580927719, 37.71236166328276, -6.666666666666803, 12.24744871391599, 2.357022603955038 },
            { 5.196152422706616, 2.598076211353367, 5.196152422706616, 11.69134295108996, -10.39230484541323, -1.299038105676626, 11.69134295108992, -10.39230484541325, -1.299038105676708, 36.74234614174779, 90.00000000000017, 25.98076211353307, -36.74234614174786, -22.49999999999985, 12.99038105676647 },
            { 0.8333333333334023, -5.833333333333469, 9.166666666666751, 16.25000000000001, -36.66666666666672, 20.41666666666677, 7.083333333333371, -1.666666666666708, 2.91666666666678, -11.785113019776, 14.43375672974044, 66.66666666666706, -11.785113019776, 21.65063509461117, 4.16666666666644 } } };
    alignas(32) static const double PI4[1][15][15] =
        { { { 0.8583333333333454, -0.8000000000000048, 1.275000000000003, -1.295833333333345, 1.675000000000006, -0.8375000000000026, -0.362499999999997, 0.3083333333333402, 0.7625000000000086, 1.767766952966345, -1.732050807568898, 3.749999999999972, -2.474873734152919, -6.278684177437271, -4.375000000000003 },
            { -0.8000000000000048, 2.766666666666663, -3.466666666666673, 1.258333333333347, -3.683333333333347, 3.008333333333333, -0.8583333333333452, 0.2166666666666592, -1.275000000000007, 1.178511301977608, 2.020725942163694, -16.66666666666666, 2.592724864350716, -0.4330127018921495, 4.583333333333417 },
            { 1.275000000000003, -3.466666666666673, 6.19166666666669, -3.170833333333346, 7.258333333333362, -4.295833333333348, 1.095833333333343, -0.44166666666666, 0.6374999999999886, 7.660323462854295, 4.041451884327445, 22.91666666666672, -10.72445284799602, -4.113620667976097, -18.95833333333344 },
            { -1.295833333333345, 1.258333333333347, -3.170833333333346, 2.775000000000011, -4.216666666666683, 1.69166666666668, 0.32083333333333, -0.225000000000005, -0.3874999999999967, -8.249579113843064, -2.23723229310983, -7.708333333333341, 8.367430244040813, 10.60881119635943, 14.79166666666666 },
            { 1.675000000000006, -3.683333333333347, 7.258333333333362, -4.216666666666683, 8.766666666666705, -4.716666666666689, 0.9416666666666742, -0.3833333333333258, 0.5249999999999837, 11.78511301977585, 5.917840259193749, 24.5833333333334, -14.37783788412652, -8.227241335952183, -25.41666666666677 },
            { -0.8375000000000026, 3.008333333333333, -4.295833333333348, 1.69166666666668, -4.716666666666689, 3.441666666666671, -1.054166666666678, 0.3583333333333273, -1.0125, -1.178511301977576, -0.07216878364872858, -18.95833333333336, 4.831896338108129, -0.2165063509460676, 8.541666666666773 },
            { -0.362499999999997, -0.8583333333333452, 1.095833333333343, 0.32083333333333, 0.9416666666666742, -1.054166666666678, 10.04166666666667, -5.083333333333317, 1.62500000000002, -18.97403196183912, 24.75389279150506, 27.95833333333337, -0.2357022603954992, 6.062177826491066, -0.4166666666666492 },
            { 0.3083333333333402, 0.2166666666666592, -0.44166666666666, -0.225000000000005, -0.3833333333333258, 0.3583333333333273, -5.083333333333317, 3.833333333333323, 0.4166666666666584, 2.592724864350697, -19.19689645055494, -8.416666666666664, 0.4714045207910287, -3.464101615137784, 0.8333333333333348 },
            { 0.7625000000000086, -1.275000000000007, 0.6374999999999886, -0.3874999999999967, 0.5249999999999837, -1.0125, 1.62500000000002, 0.4166666666666584, 2.708333333333338, -13.08147545195119, -6.278684177437059, 13.37500000000006, 2.121320343559705, -2.598076211353352, 3.750000000000111 },
            { 1.767766952966345, 1.178511301977608, 7.660323462854295, -8.249579113843064, 11.78511301977585, -1.178511301977576, -18.97403196183912, 2.592724864350697, -13.08147545195119, 113.3333333333337, 14.28869016623505, -64.81812160876702, -36.66666666666687, -30.6186217847896, -64.81812160876721 },
            { -1.732050807568898, 2.020725942163694, 4.041451884327445, -2.23723229310983, 5.917840259193749, -0.07216878364872858, 24.75389279150506, -19.19689645055494, -6.278684177437059, 14.28869016623505, 132.4999999999986, 57.73502691896257, -22.45365597551269, 3.75000000000006, -39.69283100678721 },
            { 3.749999999999972, -16.66666666666666, 22.91666666666672, -7.708333333333341, 24.5833333333334, -18.95833333333336, 27.95833333333337, -8.416666666666664, 13.37500000000006, -64.81812160876702, 57.73502691896257, 219.1666666666673, -22.39171473757415, 10.82531754730565, -39.58333333333366 },
            { -2.474873734152919, 2.592724864350716, -10.72445284799602, 8.367430244040813, -14.37783788412652, 4.831896338108129, -0.2357022603954992, 0.4714045207910287, 2.121320343559705, -36.66666666666687, -22.45365597551269, -22.39171473757415, 33.33333333333333, 24.49489742783164, 58.92556509887896 },
            { -6.278684177437271, -0.4330127018921495, -4.113620667976097, 10.60881119635943, -8.227241335952183, -0.2165063509460676, 6.062177826491066, -3.464101615137784, -2.598076211353352, -30.6186217847896, 3.75000000000006, 10.82531754730565, 24.49489742783164, 67.50000000000048, 43.30127018922163 },
            { -4.375000000000003, 4.583333333333417, -18.95833333333344, 14.79166666666666, -25.41666666666677, 8.541666666666773, -0.4166666666666492, 0.8333333333333348, 3.750000000000111, -64.81812160876721, -39.69283100678721, -39.58333333333366, 58.92556509887896, 43.30127018922163, 104.1666666666667 } } };
    alignas(32) static const double PI5[1][15][15] =
        { { { -1.875000000000023, 1.0, -0.7916666666666747, -0.112500000000001, 0.1416666666666681, 0.5125000000000027, -1.479166666666683, 2.375000000000028, -1.187500000000013, -3.88908729652606, -8.660254037844478, -1.250000000000005, 3.181980515339506, 4.979646071760512, -2.875000000000021 },
            { 1.666666666666684, -2.166666666666675, 1.0, -0.1083333333333334, -0.2833333333333338, -2.025000000000006, 0.708333333333351, -1.583333333333357, 1.958333333333343, -1.649915822768567, -1.443375672973961, 3.333333333333364, 5.421151989096829, -5.62916512459878, 11.58333333333334 },
            { -0.7916666666666736, 1.666666666666676, -1.875000000000013, -1.154166666666679, 1.058333333333336, 2.887500000000009, -1.520833333333346, 0.9583333333333413, -1.145833333333339, 2.003469213361885, -2.886751345948175, -12.08333333333341, -5.067598598503566, -1.515544456622849, -12.45833333333336 },
            { 1.52083333333335, -0.7083333333333467, 1.479166666666677, 1.00833333333334, -0.6833333333333353, -1.075000000000006, 2.270833333333346, -2.291666666666685, 0.7291666666666787, 4.478342947514818, 13.35122497501014, 7.291666666666699, -4.360491817317073, -0.6495190528383237, 3.291666666666706 },
            { -0.9583333333333421, 1.583333333333346, -2.375000000000016, -1.68333333333335, 1.366666666666672, 3.150000000000012, -2.291666666666682, 1.416666666666676, -1.041666666666675, 0.4714045207910378, -7.938566201357398, -15.41666666666676, -3.064129385141675, -3.031088913245616, -12.41666666666672 },
            { 1.145833333333344, -1.958333333333341, 1.187500000000011, 0.2583333333333373, -0.5166666666666682, -2.325000000000008, 0.7291666666666814, -1.041666666666681, 1.604166666666673, -2.592724864350651, -1.804219591217502, 6.04166666666672, 6.246109900481144, -2.814582562299344, 12.04166666666668 },
            { 1.154166666666659, 0.1083333333333341, 0.1124999999999986, 7.504166666666664, -5.258333333333323, 0.9625000000000081, 1.008333333333328, -1.683333333333322, 0.258333333333328, 5.067598598503563, 9.165435523385252, -2.041666666666667, -12.96362432175338, 12.99038105676652, 13.58333333333329 },
            { -1.058333333333332, 0.2833333333333355, -0.1416666666666689, -5.258333333333328, 3.016666666666663, -1.008333333333332, -0.6833333333333345, 1.366666666666665, -0.5166666666666655, -3.064129385141696, -5.340489990004023, 1.583333333333317, 11.78511301977577, -17.32050807568875, -7.16666666666667 },
            { -2.887500000000015, 2.02500000000001, -0.5124999999999985, 0.9625000000000047, -1.008333333333348, 0.1708333333333207, -1.075000000000001, 3.150000000000015, -2.325000000000011, -3.181980515339484, -4.546633369868301, 3.375000000000044, 3.535533905932808, 4.330127018922298, -2.249999999999938 },
            { 5.067598598503608, -5.42115198909686, -3.181980515339486, -12.96362432175341, 11.78511301977582, 3.53553390593276, -4.36049181731705, -3.064129385141733, 6.246109900481181, -6.66666666666657, -34.70110468942832, -36.53385036130514, 3.333333333333314, -6.123724356958192, -22.39171473757414 },
            { 11.5470053837925, -7.216878364870322, 0.0, 18.25870226312183, -14.86676943163276, 0.2165063509461736, 2.52590742770458, -12.26869322027951, 9.021097956087893, 14.28869016623512, 12.49999999999972, -28.86751345948142, -22.4536559755126, 48.74999999999923, 72.89047148518974 },
            { -4.91666666666665, 10.66666666666667, -5.750000000000017, 4.458333333333281, -11.41666666666666, 4.875000000000005, -2.208333333333332, 3.583333333333318, -8.458333333333337, 20.03469213361891, 23.09401076758509, -30.83333333333351, 5.892556509887964, 2.165063509460744, 5.416666666666657 },
            { -2.003469213361904, 1.6499158227686, 3.889087296526025, 5.067598598503634, -3.064129385141715, -3.181980515339474, 4.478342947514794, 0.4714045207910655, -2.592724864350678, 3.333333333333211, 26.53613888015095, 34.17682775734995, -6.66666666666668, 24.49489742783178, 2.357022603955242 },
            { 11.90784930203617, -2.165063509461176, 5.41265877365278, 2.814582562299432, -1.299038105676663, 0.649519052838317, 12.99038105676665, -17.32050807568892, 4.33012701892228, 42.86607049870583, 93.75000000000034, 10.82531754730546, -48.98979485566377, -22.50000000000014, -8.66025403784419 },
            { -3.541666666666711, 2.916666666666647, 6.875000000000025, 8.958333333333407, -5.416666666666683, -5.625000000000026, 7.916666666666647, 0.8333333333334063, -4.583333333333341, 5.89255650988764, 46.90970937165675, 60.41666666666695, -11.78511301977576, 43.30127018922194, 4.166666666666845 } } };
    alignas(32) static const double PI6[1][15][15] =
        { { { -0.6083333333333403, -0.6166666666666789, -0.1916666666666619, -0.4666666666666712, 0.9333333333333262, -0.4666666666666651, -1.108333333333341, 1.216666666666679, 0.3083333333333406, -5.185449728701419, -10.53664241271078, 0.08333333333338655, 4.006938426723837, 3.897114317029939, -1.416666666666769 },
            { 0.2166666666666751, 0.7333333333333427, -0.6166666666666728, 0.6833333333333395, -2.533333333333325, 1.849999999999989, -0.03333333333332833, -0.4333333333333461, -0.36666666666667, 3.299831645537283, 3.752776749732657, -5.166666666666735, -0.9428090415821035, -3.464101615137694, 0.3333333333335426 },
            { -0.1916666666666745, 0.2166666666666718, -0.6083333333333351, -2.133333333333343, 4.933333333333343, -2.800000000000012, -0.6916666666666693, 0.3833333333333394, -0.1083333333333399, -0.4714045207910402, -3.319764047840359, -4.083333333333321, 1.649915822768642, -0.4330127018922619, -0.5833333333333967 },
            { 0.6916666666666729, 0.03333333333333649, 1.108333333333333, 1.508333333333339, -2.600000000000002, 1.091666666666682, 1.816666666666672, -1.383333333333341, -0.016666666666668, 4.006938426723805, 11.98001808568479, 6.583333333333311, -5.185449728701412, -1.73205080756885, 1.833333333333331 },
            { -0.3833333333333423, 0.4333333333333413, -1.216666666666671, -2.766666666666679, 5.866666666666684, -3.100000000000023, -1.383333333333337, 0.766666666666673, -0.2166666666666751, -0.9428090415820674, -6.639528095680705, -8.16666666666667, 3.299831645537269, -0.8660254037844812, -1.166666666666682 },
            { 0.1083333333333408, 0.3666666666666692, -0.3083333333333358, 1.091666666666675, -3.266666666666667, 2.174999999999997, -0.01666666666666328, -0.2166666666666755, -0.1833333333333322, 1.649915822768645, 1.876388374866334, -2.583333333333374, -0.4714045207910591, -1.732050807568823, 0.1666666666668246 },
            { 1.116666666666665, -0.3166666666666909, 2.283333333333356, 4.308333333333324, -7.533333333333329, 3.224999999999997, 3.241666666666671, -2.233333333333323, 0.1583333333333464, 5.42115198909678, 19.34123401785238, 14.3333333333335, -8.720983634634063, -8.227241335952183, -8.916666666666845 },
            { -0.899999999999999, -1.199999999999988, 0.09999999999999465, -2.866666666666666, 3.733333333333328, -0.8666666666666725, -1.399999999999998, 1.799999999999994, 0.5999999999999951, -8.485281374238518, -15.58845726811981, 2.999999999999962, 5.656854249492393, 3.464101615137686, -7.999999999999952 },
            { -0.7166666666666635, -2.48333333333334, 2.116666666666679, 0.5583333333333409, -1.533333333333357, 0.9749999999999978, 0.1583333333333424, 1.433333333333329, 1.241666666666674, -11.07800623858924, -12.41303078757691, 17.66666666666675, 3.064129385141736, 4.763139720814403, -13.08333333333321 },
            { -0.2357022603955425, 12.25651754056688, -16.7348604880817, -11.07800623858925, 24.51303508113373, -13.43502884254442, -10.84230397819378, 0.4714045207910522, -6.128258770283457, 33.33333333333334, -4.082482904638866, -124.9221980096239, 13.33333333333331, 0.0, 80.13876853447549 },
            { 5.051814855409208, 10.10362971081832, -5.051814855409175, 10.9696551146028, -16.16580753730939, 5.196152422706651, 5.051814855409181, -10.10362971081837, -5.051814855409159, 57.15476066494022, 87.49999999999905, -50.51814855409184, -28.5773803324704, -22.49999999999981, 62.06515393788347 },
            { 0.5833333333333679, -7.833333333333398, 11.41666666666674, 2.166666666666609, -2.666666666666644, 0.5, 8.083333333333389, -1.166666666666707, 3.916666666666716, -18.8561808316413, 10.10362971081861, 84.16666666666708, -11.78511301977591, 12.99038105676647, -25.83333333333364 },
            { 0.4714045207910347, -3.299831645537266, 5.185449728701376, 5.892556509887907, -9.428090415820691, 3.535533905932826, 4.006938426723767, -0.9428090415820494, 1.649915822768642, -6.666666666666808, 8.164965809277064, 37.71236166328271, -6.6666666666667, 12.24744871391582, 2.357022603954622 },
            { 5.196152422706662, 2.598076211353384, 5.196152422706608, 3.897114317029989, -3.464101615137718, -0.4330127018921739, 11.69134295108996, -10.39230484541332, -1.299038105676705, 36.74234614174803, 90.00000000000057, 25.9807621135329, -36.74234614174813, -22.49999999999984, 12.99038105676668 },
            { 0.8333333333333344, -5.833333333333417, 9.166666666666714, 10.41666666666669, -16.66666666666677, 6.250000000000162, 7.083333333333321, -1.666666666666633, 2.916666666666724, -11.78511301977608, 14.43375672974021, 66.66666666666697, -11.78511301977582, 21.65063509461086, 4.166666666665698 } } };
    alignas(32) static const double PI7[1][15][15] =
        { { { 6.191666666666711, -3.4666666666667, 1.275000000000012, -1.095833333333337, 0.4416666666666661, -0.6375000000000118, 3.170833333333353, -7.25833333333338, 4.295833333333367, 10.72445284799602, 18.47520861406809, -5.916666666666679, -7.660323462854279, -21.86714144555718, 7.958333333333423 },
            { -3.4666666666667, 2.766666666666691, -0.8000000000000107, 0.8583333333333331, -0.2166666666666645, 1.27500000000001, -1.25833333333335, 3.68333333333337, -3.008333333333359, -2.592724864350715, -3.752776749732635, 2.666666666666669, -1.178511301977562, 13.42339375865887, -10.08333333333341 },
            { 1.275000000000012, -0.8000000000000107, 0.8583333333333414, 0.3625000000000048, -0.3083333333333365, -0.7625000000000073, 1.295833333333343, -1.675000000000013, 0.8375000000000093, 2.474873734152927, 6.928203230275543, 3.250000000000029, -1.767766952966377, -2.381569860407211, 3.375000000000045 },
            { -1.095833333333337, 0.8583333333333331, 0.3625000000000048, 10.04166666666667, -5.08333333333333, 1.625000000000003, 0.3208333333333386, 0.9416666666666674, -1.05416666666667, -0.2357022603955206, 2.670244995002033, 5.458333333333365, -18.97403196183905, 36.58957330989254, 7.458333333333323 },
            { 0.4416666666666661, -0.2166666666666645, -0.3083333333333365, -5.08333333333333, 3.833333333333327, 0.4166666666666644, -0.2250000000000038, -0.3833333333333322, 0.3583333333333336, 0.4714045207910353, -1.010362971081854, -3.416666666666681, 2.592724864350698, -16.88749537379654, -12.41666666666664 },
            { -0.6375000000000118, 1.27500000000001, -0.7625000000000073, 1.625000000000003, 0.4166666666666644, 2.708333333333342, -0.3875000000000088, 0.5250000000000122, -1.01250000000001, 2.121320343559635, 1.948557158514953, -4.125000000000024, -13.08147545195113, 8.443747686898309, -12.12500000000002 },
            { 3.170833333333353, -1.25833333333335, 1.295833333333343, 0.3208333333333386, -0.2250000000000038, -0.3875000000000088, 2.775000000000011, -4.216666666666685, 1.691666666666682, 8.367430244040825, 18.11436469582453, 1.791666666666694, -8.24957911384306, -7.794228634059954, 1.916666666666728 },
            { -7.25833333333338, 3.68333333333337, -1.675000000000013, 0.9416666666666674, -0.3833333333333322, 0.5250000000000122, -4.216666666666685, 8.766666666666715, -4.716666666666704, -14.37783788412651, -26.12509968083061, 5.583333333333344, 11.78511301977581, 24.24871130596437, -7.166666666666768 },
            { 4.295833333333367, -3.008333333333359, 0.8375000000000093, -1.05416666666667, 0.3583333333333336, -1.01250000000001, 1.691666666666682, -4.716666666666704, 3.441666666666694, 4.831896338108112, 7.289047148519075, -4.458333333333345, -1.178511301977585, -16.45448267190442, 9.416666666666737 },
            { 10.72445284799602, -2.592724864350715, 2.474873734152927, -0.2357022603955206, 0.4714045207910353, 2.121320343559635, 8.367430244040825, -14.37783788412651, 4.831896338108112, 33.33333333333336, 63.27848502189875, -8.249579113843083, -36.66666666666667, -30.61862178478982, -8.249579113842955 },
            { 18.47520861406809, -3.752776749732635, 6.928203230275543, 2.670244995002033, -1.010362971081854, 1.948557158514953, 18.11436469582453, -26.12509968083061, 7.289047148519075, 63.27848502189875, 132.4999999999999, 5.773502691896375, -71.44345083117597, -41.24999999999994, -13.71206889325336 },
            { -5.916666666666679, 2.666666666666669, 3.250000000000029, 5.458333333333365, -3.416666666666681, -4.125000000000024, 1.791666666666694, 5.583333333333344, -4.458333333333345, -8.249579113843083, 5.773502691896375, 39.16666666666691, 5.892556509887864, 36.80607966083881, 5.416666666666724 },
            { -7.660323462854279, -1.178511301977562, -1.767766952966377, -18.97403196183905, 2.592724864350698, -13.08147545195113, -8.24957911384306, 11.78511301977581, -1.178511301977585, -36.66666666666667, -71.44345083117597, 5.892556509887864, 113.3333333333333, -48.98979485566367, 44.78342947514783 },
            { -21.86714144555718, 13.42339375865887, -2.381569860407211, 36.58957330989254, -16.88749537379654, 8.443747686898309, -7.794228634059954, 24.24871130596437, -16.45448267190442, -30.61862178478982, -41.24999999999994, 36.80607966083881, -48.98979485566367, 247.4999999999999, -8.660254037844608 },
            { 7.958333333333423, -10.08333333333341, 3.375000000000045, 7.458333333333323, -12.41666666666664, -12.12500000000002, 1.916666666666728, -7.166666666666768, 9.416666666666737, -8.249579113842955, -13.71206889325336, 5.416666666666724, 44.78342947514783, -8.660254037844608, 104.1666666666667 } } };
    alignas(32) static const double PI8[1][15][15] =
        { { { 1.69166666666667, 2.783333333333352, -0.8916666666666752, -0.2666666666666601, -0.1333333333333325, 0.4000000000000111, 2.191666666666674, -3.383333333333342, -1.391666666666682, 17.44196726926825, 29.30052616137362, -10.91666666666673, -10.13519719700728, -15.15544456622762, 3.583333333333352 },
            { -0.7166666666666719, -1.733333333333344, 1.11666666666667, 0.1166666666666601, 0.9333333333333416, -1.050000000000007, -0.466666666666674, 1.433333333333343, 0.866666666666674, -8.956685895029658, -12.41303078757705, 10.1666666666667, 3.771236166328309, 8.660254037844384, -1.333333333333366 },
            { 0.4416666666666703, 0.2833333333333345, 0.3583333333333346, 0.7333333333333396, -1.466666666666675, 0.7333333333333452, 0.9416666666666712, -0.8833333333333381, -0.1416666666666674, 3.29983164553724, 7.649891066762578, 1.583333333333333, -3.064129385141745, -2.165063509461079, 1.08333333333333 },
            { 0.6916666666666691, 0.03333333333332311, 1.108333333333343, 5.508333333333337, -7.933333333333335, 2.425000000000002, 1.81666666666667, -1.383333333333332, -0.01666666666666078, 4.006938426723742, 11.98001808568471, 6.583333333333388, -5.185449728701346, -1.732050807568878, 1.833333333333304 },
            { -0.38333333333334, 0.4333333333333494, -1.216666666666677, -3.433333333333327, 5.86666666666666, -2.433333333333334, -1.383333333333336, 0.7666666666666689, -0.2166666666666789, -0.9428090415820314, -6.639528095680658, -8.166666666666712, 3.29983164553723, -0.8660254037844455, -1.166666666666621 },
            { 0.1083333333333249, 0.3666666666666756, -0.3083333333333375, -0.2416666666666641, 2.06666666666667, -1.825000000000008, -0.01666666666667038, -0.2166666666666588, -0.1833333333333426, 1.649915822768611, 1.87638837486628, -2.58333333333334, -0.4714045207910066, -1.732050807568879, 0.1666666666666736 },
            { 1.150000000000003, 0.9500000000000065, 0.649999999999998, 0.7750000000000076, -1.133333333333338, 0.3583333333333502, 2.275000000000003, -2.300000000000003, -0.4750000000000058, 9.192388155425148, 19.91858428704213, 1.999999999999981, -7.778174593052094, -6.495190528383231, 2.749999999999988 },
            { -2.133333333333336, -3.066666666666688, 0.5333333333333437, 0.03333333333332561, 0.2666666666666641, -0.3000000000000158, -3.133333333333338, 4.266666666666675, 1.533333333333351, -20.74179891480547, -36.95041722813616, 9.333333333333417, 13.199326582149, 17.32050807568869, -4.66666666666667 },
            { 0.9833333333333367, 2.116666666666679, -1.183333333333339, -0.308333333333329, -0.4666666666666688, 0.7750000000000061, 0.8583333333333379, -1.966666666666674, -1.058333333333343, 11.54941075938033, 17.03183294109404, -11.33333333333338, -5.421151989096923, -10.82531754730546, 1.916666666666691 },
            { 4.006938426723765, 3.771236166328285, 1.649915822768592, 0.2357022603955188, 1.885618083164155, -2.121320343559615, 7.542472332656505, -8.013876853447535, -1.885618083164158, 33.33333333333341, 69.40220937885678, 2.357022603955038, -26.66666666666686, -24.49489742783159, 9.428090415820545 },
            { 7.649891066762535, 4.907477288111851, 6.206515393788457, 4.041451884327405, -2.309401076758486, -1.732050807568786, 16.31014510460692, -15.29978213352507, -2.453738644055948, 57.15476066494087, 132.5, 27.42413778650712, -53.07227776030255, -37.49999999999952, 18.76388374866262 },
            { -0.9166666666666465, -4.833333333333369, 4.916666666666694, 6.166666666666688, -10.66666666666672, 4.500000000000052, 1.583333333333352, 1.833333333333318, 2.416666666666697, -18.85618083164129, -15.87713240271469, 39.1666666666668, 2.357022603955104, 21.65063509461095, -0.8333333333333783 },
            { -5.185449728701314, -6.128258770283477, -0.4714045207910114, -6.835365551470009, 1.885618083164141, 4.949747468305804, -8.720983634634084, 10.37089945740266, 3.064129385141773, -46.66666666666676, -89.81462390204999, 9.428090415820698, 33.33333333333344, 36.74234614174747, -11.7851130197758 },
            { -1.732050807568867, -0.8660254037845627, -1.732050807568826, 19.48557158514987, -17.3205080756888, -2.165063509461001, -3.897114317029989, 3.464101615137776, 0.4330127018923018, -12.24744871391632, -30.00000000000065, -8.66025403784408, 12.24744871391592, 67.50000000000003, 99.59292143520966 },
            { 1.833333333333387, 2.166666666666611, 0.1666666666666994, 9.416666666666652, -24.66666666666666, 15.25000000000001, 3.083333333333364, -3.666666666666714, -1.083333333333282, 16.49915822768611, 31.75426480542946, -3.333333333333258, -11.78511301977595, -12.99038105676656, 4.166666666666648 } } };
    alignas(32) static const double PI9[1][15][15] =
        { { { 0.6333333333333324, 0.8166666666666649, -0.03333333333333122, 0.5083333333333401, -0.6000000000000084, 0.0916666666666774, 1.008333333333334, -1.266666666666664, -0.4083333333333342, 5.892556509887884, 10.96965511460287, -1.833333333333313, -4.006938426723794, -3.897114317029913, 2.916666666666667 },
            { 0.8166666666666649, 2.533333333333341, -2.016666666666676, -0.1833333333333407, 1.200000000000024, -1.016666666666666, 0.06666666666666157, -1.633333333333332, -1.266666666666674, 11.7851130197758, 14.14508159514581, -17.16666666666673, -3.771236166328294, -5.196152422706614, 13.33333333333324 },
            { -0.03333333333333122, -2.016666666666676, 2.633333333333348, 1.09166666666667, -2.600000000000017, 1.508333333333339, 1.591666666666676, 0.06666666666666565, 1.008333333333341, -5.892556509887908, -0.5773502691895995, 19.83333333333344, -1.649915822768604, 0.4330127018921914, -12.9166666666667 },
            { 0.5083333333333401, -0.1833333333333407, 1.09166666666667, 3.683333333333332, -5.866666666666663, 2.183333333333338, 1.508333333333336, -1.016666666666671, 0.09166666666667314, 2.357022603955156, 8.804591605141789, 6.916666666666666, -4.006938426723793, 0.433012701892219, 2.916666666666638 },
            { -0.6000000000000084, 1.200000000000024, -2.600000000000017, -5.866666666666663, 11.73333333333334, -5.866666666666669, -2.600000000000005, 1.2, -0.6000000000000189, 0.0, -10.39230484541321, -18.00000000000009, 5.656854249492364, 3.464101615137765, 10.00000000000004 },
            { 0.0916666666666774, -1.016666666666666, 1.508333333333339, 2.183333333333338, -5.866666666666669, 3.683333333333318, 1.091666666666679, -0.1833333333333471, 0.5083333333333371, -2.357022603955106, 1.587713240271583, 11.08333333333334, -1.649915822768623, -3.897114317029964, -12.91666666666647 },
            { 1.008333333333334, 0.06666666666666157, 1.591666666666676, 1.508333333333336, -2.600000000000005, 1.091666666666679, 2.633333333333339, -2.016666666666665, -0.03333333333333217, 5.892556509887884, 17.46484564298618, 9.416666666666732, -7.542472332656545, -6.062177826491039, -3.333333333333412 },
            { -1.266666666666664, -1.633333333333332, 0.06666666666666565, -1.016666666666671, 1.2, -0.1833333333333471, -2.016666666666665, 2.533333333333327, 0.8166666666666694, -11.78511301977577, -21.93931022920574, 3.666666666666652, 8.013876853447581, 7.794228634059854, -5.833333333333292 },
            { -0.4083333333333342, -1.266666666666674, 1.008333333333341, 0.09166666666667314, -0.6000000000000189, 0.5083333333333371, -0.03333333333333217, 0.8166666666666694, 0.6333333333333392, -5.89255650988792, -7.072540797572937, 8.583333333333389, 1.885618083164157, 2.598076211353331, -6.666666666666617 },
            { 5.892556509887884, 11.7851130197758, -5.892556509887908, 2.357022603955156, 0.0, -2.357022603955106, 5.892556509887884, -11.78511301977577, -5.89255650988792, 66.66666666666657, 102.0620726159656, -58.92556509887901, -33.33333333333357, -36.74234614174735, 54.21151989096818 },
            { 10.96965511460287, 14.14508159514581, -0.5773502691895995, 8.804591605141789, -10.39230484541321, 1.587713240271583, 17.46484564298618, -21.93931022920574, -7.072540797572937, 102.0620726159656, 189.9999999999998, -31.75426480542916, -69.40220937885714, -67.49999999999959, 50.51814855409121 },
            { -1.833333333333313, -17.16666666666673, 19.83333333333344, 6.916666666666666, -18.00000000000009, 11.08333333333334, 9.416666666666732, 3.666666666666652, 8.583333333333389, -58.92556509887901, -31.75426480542916, 153.333333333334, -2.35702260395505, 12.99038105676619, -104.1666666666669 },
            { -4.006938426723794, -3.771236166328294, -1.649915822768604, -4.006938426723793, 5.656854249492364, -1.649915822768623, -7.542472332656545, 8.013876853447581, 1.885618083164157, -33.33333333333357, -69.40220937885714, -2.35702260395505, 26.66666666666698, 24.49489742783156, -9.428090415820947 },
            { -3.897114317029913, -5.196152422706614, 0.4330127018921914, 0.433012701892219, 3.464101615137765, -3.897114317029964, -6.062177826491039, 7.794228634059854, 2.598076211353331, -36.74234614174735, -67.49999999999959, 12.99038105676619, 24.49489742783156, 59.9999999999999, 43.30127018922237 },
            { 2.916666666666667, 13.33333333333324, -12.9166666666667, 2.916666666666638, 10.00000000000004, -12.91666666666647, -3.333333333333412, -5.833333333333292, -6.666666666666617, 54.21151989096818, 50.51814855409121, -104.1666666666669, -9.428090415820947, 43.30127018922237, 183.333333333332 } } };
    // Unstructured piecewise computations
    const double J_c3 = coordinate_dofs[1] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[5] * FE3_C0_D01_Q6[0][0][1];
    const double J_c0 = coordinate_dofs[0] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[2] * FE3_C0_D01_Q6[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[4] * FE3_C0_D01_Q6[0][0][1];
    const double J_c2 = coordinate_dofs[1] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[3] * FE3_C0_D01_Q6[0][0][1];
    alignas(32) double sp[36];
    sp[0] = J_c0 * J_c3;
    sp[1] = J_c1 * J_c2;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = J_c3 / sp[2];
    sp[4] = -1 * J_c2 / sp[2];
    sp[5] = J_c0 / sp[2];
    sp[6] = sp[5] * sp[3];
    sp[7] = sp[5] * sp[4];
    sp[8] = -1 * J_c1 / sp[2];
    sp[9] = sp[3] * sp[8];
    sp[10] = sp[8] * sp[4];
    sp[11] = -1 * sp[10] + sp[6];
    sp[12] = -1 * sp[7] + sp[7];
    sp[13] = -1 * sp[9] + sp[9];
    sp[14] = -1 * sp[6] + sp[10];
    sp[15] = sp[11] * sp[11];
    sp[16] = sp[11] * sp[12];
    sp[17] = sp[11] * sp[13];
    sp[18] = sp[11] * sp[14];
    sp[19] = sp[12] * sp[12];
    sp[20] = sp[13] * sp[12];
    sp[21] = sp[12] * sp[14];
    sp[22] = sp[13] * sp[13];
    sp[23] = sp[13] * sp[14];
    sp[24] = sp[14] * sp[14];
    sp[25] = std::abs(sp[2]);
    sp[26] = sp[15] * sp[25];
    sp[27] = sp[16] * sp[25];
    sp[28] = sp[17] * sp[25];
    sp[29] = sp[18] * sp[25];
    sp[30] = sp[19] * sp[25];
    sp[31] = sp[20] * sp[25];
    sp[32] = sp[21] * sp[25];
    sp[33] = sp[22] * sp[25];
    sp[34] = sp[23] * sp[25];
    sp[35] = sp[24] * sp[25];
    A[0] = sp[33] * PI0[0][0][0] + sp[34] * PI1[0][0][0] + sp[28] * PI2[0][0][0] + sp[31] * PI3[0][0][0] + sp[34] * PI1[0][0][0] + sp[35] * PI4[0][0][0] + sp[29] * PI5[0][0][0] + sp[32] * PI6[0][0][0] + sp[28] * PI2[0][0][0] + sp[29] * PI5[0][0][0] + sp[26] * PI7[0][0][0] + sp[27] * PI8[0][0][0] + sp[31] * PI3[0][0][0] + sp[32] * PI6[0][0][0] + sp[27] * PI8[0][0][0] + sp[30] * PI9[0][0][0];
    A[1] = sp[33] * PI0[0][0][1] + sp[34] * PI1[0][0][1] + sp[28] * PI2[0][0][1] + sp[31] * PI3[0][0][1] + sp[34] * PI1[0][1][0] + sp[35] * PI4[0][0][1] + sp[29] * PI5[0][0][1] + sp[32] * PI6[0][0][1] + sp[28] * PI2[0][1][0] + sp[29] * PI5[0][1][0] + sp[26] * PI7[0][0][1] + sp[27] * PI8[0][0][1] + sp[31] * PI3[0][1][0] + sp[32] * PI6[0][1][0] + sp[27] * PI8[0][1][0] + sp[30] * PI9[0][0][1];
    A[2] = sp[33] * PI0[0][0][2] + sp[34] * PI1[0][0][2] + sp[28] * PI2[0][0][2] + sp[31] * PI3[0][0][2] + sp[34] * PI1[0][2][0] + sp[35] * PI4[0][0][2] + sp[29] * PI5[0][0][2] + sp[32] * PI6[0][0][2] + sp[28] * PI2[0][2][0] + sp[29] * PI5[0][2][0] + sp[26] * PI7[0][0][2] + sp[27] * PI8[0][0][2] + sp[31] * PI3[0][2][0] + sp[32] * PI6[0][2][0] + sp[27] * PI8[0][2][0] + sp[30] * PI9[0][0][2];
    A[3] = sp[33] * PI0[0][0][3] + sp[34] * PI1[0][0][3] + sp[28] * PI2[0][0][3] + sp[31] * PI3[0][0][3] + sp[34] * PI1[0][3][0] + sp[35] * PI4[0][0][3] + sp[29] * PI5[0][0][3] + sp[32] * PI6[0][0][3] + sp[28] * PI2[0][3][0] + sp[29] * PI5[0][3][0] + sp[26] * PI7[0][0][3] + sp[27] * PI8[0][0][3] + sp[31] * PI3[0][3][0] + sp[32] * PI6[0][3][0] + sp[27] * PI8[0][3][0] + sp[30] * PI9[0][0][3];
    A[4] = sp[33] * PI0[0][0][4] + sp[34] * PI1[0][0][4] + sp[28] * PI2[0][0][4] + sp[31] * PI3[0][0][4] + sp[34] * PI1[0][4][0] + sp[35] * PI4[0][0][4] + sp[29] * PI5[0][0][4] + sp[32] * PI6[0][0][4] + sp[28] * PI2[0][4][0] + sp[29] * PI5[0][4][0] + sp[26] * PI7[0][0][4] + sp[27] * PI8[0][0][4] + sp[31] * PI3[0][4][0] + sp[32] * PI6[0][4][0] + sp[27] * PI8[0][4][0] + sp[30] * PI9[0][0][4];
    A[5] = sp[33] * PI0[0][0][5] + sp[34] * PI1[0][0][5] + sp[28] * PI2[0][0][5] + sp[31] * PI3[0][0][5] + sp[34] * PI1[0][5][0] + sp[35] * PI4[0][0][5] + sp[29] * PI5[0][0][5] + sp[32] * PI6[0][0][5] + sp[28] * PI2[0][5][0] + sp[29] * PI5[0][5][0] + sp[26] * PI7[0][0][5] + sp[27] * PI8[0][0][5] + sp[31] * PI3[0][5][0] + sp[32] * PI6[0][5][0] + sp[27] * PI8[0][5][0] + sp[30] * PI9[0][0][5];
    A[6] = sp[33] * PI0[0][0][6] + sp[34] * PI1[0][0][6] + sp[28] * PI2[0][0][6] + sp[31] * PI3[0][0][6] + sp[34] * PI1[0][6][0] + sp[35] * PI4[0][0][6] + sp[29] * PI5[0][0][6] + sp[32] * PI6[0][0][6] + sp[28] * PI2[0][6][0] + sp[29] * PI5[0][6][0] + sp[26] * PI7[0][0][6] + sp[27] * PI8[0][0][6] + sp[31] * PI3[0][6][0] + sp[32] * PI6[0][6][0] + sp[27] * PI8[0][6][0] + sp[30] * PI9[0][0][6];
    A[7] = sp[33] * PI0[0][0][7] + sp[34] * PI1[0][0][7] + sp[28] * PI2[0][0][7] + sp[31] * PI3[0][0][7] + sp[34] * PI1[0][7][0] + sp[35] * PI4[0][0][7] + sp[29] * PI5[0][0][7] + sp[32] * PI6[0][0][7] + sp[28] * PI2[0][7][0] + sp[29] * PI5[0][7][0] + sp[26] * PI7[0][0][7] + sp[27] * PI8[0][0][7] + sp[31] * PI3[0][7][0] + sp[32] * PI6[0][7][0] + sp[27] * PI8[0][7][0] + sp[30] * PI9[0][0][7];
    A[8] = sp[33] * PI0[0][0][8] + sp[34] * PI1[0][0][8] + sp[28] * PI2[0][0][8] + sp[31] * PI3[0][0][8] + sp[34] * PI1[0][8][0] + sp[35] * PI4[0][0][8] + sp[29] * PI5[0][0][8] + sp[32] * PI6[0][0][8] + sp[28] * PI2[0][8][0] + sp[29] * PI5[0][8][0] + sp[26] * PI7[0][0][8] + sp[27] * PI8[0][0][8] + sp[31] * PI3[0][8][0] + sp[32] * PI6[0][8][0] + sp[27] * PI8[0][8][0] + sp[30] * PI9[0][0][8];
    A[9] = sp[33] * PI0[0][0][9] + sp[34] * PI1[0][0][9] + sp[28] * PI2[0][0][9] + sp[31] * PI3[0][0][9] + sp[34] * PI1[0][9][0] + sp[35] * PI4[0][0][9] + sp[29] * PI5[0][0][9] + sp[32] * PI6[0][0][9] + sp[28] * PI2[0][9][0] + sp[29] * PI5[0][9][0] + sp[26] * PI7[0][0][9] + sp[27] * PI8[0][0][9] + sp[31] * PI3[0][9][0] + sp[32] * PI6[0][9][0] + sp[27] * PI8[0][9][0] + sp[30] * PI9[0][0][9];
    A[10] = sp[33] * PI0[0][0][10] + sp[34] * PI1[0][0][10] + sp[28] * PI2[0][0][10] + sp[31] * PI3[0][0][10] + sp[34] * PI1[0][10][0] + sp[35] * PI4[0][0][10] + sp[29] * PI5[0][0][10] + sp[32] * PI6[0][0][10] + sp[28] * PI2[0][10][0] + sp[29] * PI5[0][10][0] + sp[26] * PI7[0][0][10] + sp[27] * PI8[0][0][10] + sp[31] * PI3[0][10][0] + sp[32] * PI6[0][10][0] + sp[27] * PI8[0][10][0] + sp[30] * PI9[0][0][10];
    A[11] = sp[33] * PI0[0][0][11] + sp[34] * PI1[0][0][11] + sp[28] * PI2[0][0][11] + sp[31] * PI3[0][0][11] + sp[34] * PI1[0][11][0] + sp[35] * PI4[0][0][11] + sp[29] * PI5[0][0][11] + sp[32] * PI6[0][0][11] + sp[28] * PI2[0][11][0] + sp[29] * PI5[0][11][0] + sp[26] * PI7[0][0][11] + sp[27] * PI8[0][0][11] + sp[31] * PI3[0][11][0] + sp[32] * PI6[0][11][0] + sp[27] * PI8[0][11][0] + sp[30] * PI9[0][0][11];
    A[12] = sp[33] * PI0[0][0][12] + sp[34] * PI1[0][0][12] + sp[28] * PI2[0][0][12] + sp[31] * PI3[0][0][12] + sp[34] * PI1[0][12][0] + sp[35] * PI4[0][0][12] + sp[29] * PI5[0][0][12] + sp[32] * PI6[0][0][12] + sp[28] * PI2[0][12][0] + sp[29] * PI5[0][12][0] + sp[26] * PI7[0][0][12] + sp[27] * PI8[0][0][12] + sp[31] * PI3[0][12][0] + sp[32] * PI6[0][12][0] + sp[27] * PI8[0][12][0] + sp[30] * PI9[0][0][12];
    A[13] = sp[33] * PI0[0][0][13] + sp[34] * PI1[0][0][13] + sp[28] * PI2[0][0][13] + sp[31] * PI3[0][0][13] + sp[34] * PI1[0][13][0] + sp[35] * PI4[0][0][13] + sp[29] * PI5[0][0][13] + sp[32] * PI6[0][0][13] + sp[28] * PI2[0][13][0] + sp[29] * PI5[0][13][0] + sp[26] * PI7[0][0][13] + sp[27] * PI8[0][0][13] + sp[31] * PI3[0][13][0] + sp[32] * PI6[0][13][0] + sp[27] * PI8[0][13][0] + sp[30] * PI9[0][0][13];
    A[14] = sp[33] * PI0[0][0][14] + sp[34] * PI1[0][0][14] + sp[28] * PI2[0][0][14] + sp[31] * PI3[0][0][14] + sp[34] * PI1[0][14][0] + sp[35] * PI4[0][0][14] + sp[29] * PI5[0][0][14] + sp[32] * PI6[0][0][14] + sp[28] * PI2[0][14][0] + sp[29] * PI5[0][14][0] + sp[26] * PI7[0][0][14] + sp[27] * PI8[0][0][14] + sp[31] * PI3[0][14][0] + sp[32] * PI6[0][14][0] + sp[27] * PI8[0][14][0] + sp[30] * PI9[0][0][14];
    A[15] = sp[33] * PI0[0][1][0] + sp[34] * PI1[0][1][0] + sp[28] * PI2[0][1][0] + sp[31] * PI3[0][1][0] + sp[34] * PI1[0][0][1] + sp[35] * PI4[0][1][0] + sp[29] * PI5[0][1][0] + sp[32] * PI6[0][1][0] + sp[28] * PI2[0][0][1] + sp[29] * PI5[0][0][1] + sp[26] * PI7[0][1][0] + sp[27] * PI8[0][1][0] + sp[31] * PI3[0][0][1] + sp[32] * PI6[0][0][1] + sp[27] * PI8[0][0][1] + sp[30] * PI9[0][1][0];
    A[16] = sp[33] * PI0[0][1][1] + sp[34] * PI1[0][1][1] + sp[28] * PI2[0][1][1] + sp[31] * PI3[0][1][1] + sp[34] * PI1[0][1][1] + sp[35] * PI4[0][1][1] + sp[29] * PI5[0][1][1] + sp[32] * PI6[0][1][1] + sp[28] * PI2[0][1][1] + sp[29] * PI5[0][1][1] + sp[26] * PI7[0][1][1] + sp[27] * PI8[0][1][1] + sp[31] * PI3[0][1][1] + sp[32] * PI6[0][1][1] + sp[27] * PI8[0][1][1] + sp[30] * PI9[0][1][1];
    A[17] = sp[33] * PI0[0][1][2] + sp[34] * PI1[0][1][2] + sp[28] * PI2[0][1][2] + sp[31] * PI3[0][1][2] + sp[34] * PI1[0][2][1] + sp[35] * PI4[0][1][2] + sp[29] * PI5[0][1][2] + sp[32] * PI6[0][1][2] + sp[28] * PI2[0][2][1] + sp[29] * PI5[0][2][1] + sp[26] * PI7[0][1][2] + sp[27] * PI8[0][1][2] + sp[31] * PI3[0][2][1] + sp[32] * PI6[0][2][1] + sp[27] * PI8[0][2][1] + sp[30] * PI9[0][1][2];
    A[18] = sp[33] * PI0[0][1][3] + sp[34] * PI1[0][1][3] + sp[28] * PI2[0][1][3] + sp[31] * PI3[0][1][3] + sp[34] * PI1[0][3][1] + sp[35] * PI4[0][1][3] + sp[29] * PI5[0][1][3] + sp[32] * PI6[0][1][3] + sp[28] * PI2[0][3][1] + sp[29] * PI5[0][3][1] + sp[26] * PI7[0][1][3] + sp[27] * PI8[0][1][3] + sp[31] * PI3[0][3][1] + sp[32] * PI6[0][3][1] + sp[27] * PI8[0][3][1] + sp[30] * PI9[0][1][3];
    A[19] = sp[33] * PI0[0][1][4] + sp[34] * PI1[0][1][4] + sp[28] * PI2[0][1][4] + sp[31] * PI3[0][1][4] + sp[34] * PI1[0][4][1] + sp[35] * PI4[0][1][4] + sp[29] * PI5[0][1][4] + sp[32] * PI6[0][1][4] + sp[28] * PI2[0][4][1] + sp[29] * PI5[0][4][1] + sp[26] * PI7[0][1][4] + sp[27] * PI8[0][1][4] + sp[31] * PI3[0][4][1] + sp[32] * PI6[0][4][1] + sp[27] * PI8[0][4][1] + sp[30] * PI9[0][1][4];
    A[20] = sp[33] * PI0[0][1][5] + sp[34] * PI1[0][1][5] + sp[28] * PI2[0][1][5] + sp[31] * PI3[0][1][5] + sp[34] * PI1[0][5][1] + sp[35] * PI4[0][1][5] + sp[29] * PI5[0][1][5] + sp[32] * PI6[0][1][5] + sp[28] * PI2[0][5][1] + sp[29] * PI5[0][5][1] + sp[26] * PI7[0][1][5] + sp[27] * PI8[0][1][5] + sp[31] * PI3[0][5][1] + sp[32] * PI6[0][5][1] + sp[27] * PI8[0][5][1] + sp[30] * PI9[0][1][5];
    A[21] = sp[33] * PI0[0][1][6] + sp[34] * PI1[0][1][6] + sp[28] * PI2[0][1][6] + sp[31] * PI3[0][1][6] + sp[34] * PI1[0][6][1] + sp[35] * PI4[0][1][6] + sp[29] * PI5[0][1][6] + sp[32] * PI6[0][1][6] + sp[28] * PI2[0][6][1] + sp[29] * PI5[0][6][1] + sp[26] * PI7[0][1][6] + sp[27] * PI8[0][1][6] + sp[31] * PI3[0][6][1] + sp[32] * PI6[0][6][1] + sp[27] * PI8[0][6][1] + sp[30] * PI9[0][1][6];
    A[22] = sp[33] * PI0[0][1][7] + sp[34] * PI1[0][1][7] + sp[28] * PI2[0][1][7] + sp[31] * PI3[0][1][7] + sp[34] * PI1[0][7][1] + sp[35] * PI4[0][1][7] + sp[29] * PI5[0][1][7] + sp[32] * PI6[0][1][7] + sp[28] * PI2[0][7][1] + sp[29] * PI5[0][7][1] + sp[26] * PI7[0][1][7] + sp[27] * PI8[0][1][7] + sp[31] * PI3[0][7][1] + sp[32] * PI6[0][7][1] + sp[27] * PI8[0][7][1] + sp[30] * PI9[0][1][7];
    A[23] = sp[33] * PI0[0][1][8] + sp[34] * PI1[0][1][8] + sp[28] * PI2[0][1][8] + sp[31] * PI3[0][1][8] + sp[34] * PI1[0][8][1] + sp[35] * PI4[0][1][8] + sp[29] * PI5[0][1][8] + sp[32] * PI6[0][1][8] + sp[28] * PI2[0][8][1] + sp[29] * PI5[0][8][1] + sp[26] * PI7[0][1][8] + sp[27] * PI8[0][1][8] + sp[31] * PI3[0][8][1] + sp[32] * PI6[0][8][1] + sp[27] * PI8[0][8][1] + sp[30] * PI9[0][1][8];
    A[24] = sp[33] * PI0[0][1][9] + sp[34] * PI1[0][1][9] + sp[28] * PI2[0][1][9] + sp[31] * PI3[0][1][9] + sp[34] * PI1[0][9][1] + sp[35] * PI4[0][1][9] + sp[29] * PI5[0][1][9] + sp[32] * PI6[0][1][9] + sp[28] * PI2[0][9][1] + sp[29] * PI5[0][9][1] + sp[26] * PI7[0][1][9] + sp[27] * PI8[0][1][9] + sp[31] * PI3[0][9][1] + sp[32] * PI6[0][9][1] + sp[27] * PI8[0][9][1] + sp[30] * PI9[0][1][9];
    A[25] = sp[33] * PI0[0][1][10] + sp[34] * PI1[0][1][10] + sp[28] * PI2[0][1][10] + sp[31] * PI3[0][1][10] + sp[34] * PI1[0][10][1] + sp[35] * PI4[0][1][10] + sp[29] * PI5[0][1][10] + sp[32] * PI6[0][1][10] + sp[28] * PI2[0][10][1] + sp[29] * PI5[0][10][1] + sp[26] * PI7[0][1][10] + sp[27] * PI8[0][1][10] + sp[31] * PI3[0][10][1] + sp[32] * PI6[0][10][1] + sp[27] * PI8[0][10][1] + sp[30] * PI9[0][1][10];
    A[26] = sp[33] * PI0[0][1][11] + sp[34] * PI1[0][1][11] + sp[28] * PI2[0][1][11] + sp[31] * PI3[0][1][11] + sp[34] * PI1[0][11][1] + sp[35] * PI4[0][1][11] + sp[29] * PI5[0][1][11] + sp[32] * PI6[0][1][11] + sp[28] * PI2[0][11][1] + sp[29] * PI5[0][11][1] + sp[26] * PI7[0][1][11] + sp[27] * PI8[0][1][11] + sp[31] * PI3[0][11][1] + sp[32] * PI6[0][11][1] + sp[27] * PI8[0][11][1] + sp[30] * PI9[0][1][11];
    A[27] = sp[33] * PI0[0][1][12] + sp[34] * PI1[0][1][12] + sp[28] * PI2[0][1][12] + sp[31] * PI3[0][1][12] + sp[34] * PI1[0][12][1] + sp[35] * PI4[0][1][12] + sp[29] * PI5[0][1][12] + sp[32] * PI6[0][1][12] + sp[28] * PI2[0][12][1] + sp[29] * PI5[0][12][1] + sp[26] * PI7[0][1][12] + sp[27] * PI8[0][1][12] + sp[31] * PI3[0][12][1] + sp[32] * PI6[0][12][1] + sp[27] * PI8[0][12][1] + sp[30] * PI9[0][1][12];
    A[28] = sp[33] * PI0[0][1][13] + sp[34] * PI1[0][1][13] + sp[28] * PI2[0][1][13] + sp[31] * PI3[0][1][13] + sp[34] * PI1[0][13][1] + sp[35] * PI4[0][1][13] + sp[29] * PI5[0][1][13] + sp[32] * PI6[0][1][13] + sp[28] * PI2[0][13][1] + sp[29] * PI5[0][13][1] + sp[26] * PI7[0][1][13] + sp[27] * PI8[0][1][13] + sp[31] * PI3[0][13][1] + sp[32] * PI6[0][13][1] + sp[27] * PI8[0][13][1] + sp[30] * PI9[0][1][13];
    A[29] = sp[33] * PI0[0][1][14] + sp[34] * PI1[0][1][14] + sp[28] * PI2[0][1][14] + sp[31] * PI3[0][1][14] + sp[34] * PI1[0][14][1] + sp[35] * PI4[0][1][14] + sp[29] * PI5[0][1][14] + sp[32] * PI6[0][1][14] + sp[28] * PI2[0][14][1] + sp[29] * PI5[0][14][1] + sp[26] * PI7[0][1][14] + sp[27] * PI8[0][1][14] + sp[31] * PI3[0][14][1] + sp[32] * PI6[0][14][1] + sp[27] * PI8[0][14][1] + sp[30] * PI9[0][1][14];
    A[30] = sp[33] * PI0[0][2][0] + sp[34] * PI1[0][2][0] + sp[28] * PI2[0][2][0] + sp[31] * PI3[0][2][0] + sp[34] * PI1[0][0][2] + sp[35] * PI4[0][2][0] + sp[29] * PI5[0][2][0] + sp[32] * PI6[0][2][0] + sp[28] * PI2[0][0][2] + sp[29] * PI5[0][0][2] + sp[26] * PI7[0][2][0] + sp[27] * PI8[0][2][0] + sp[31] * PI3[0][0][2] + sp[32] * PI6[0][0][2] + sp[27] * PI8[0][0][2] + sp[30] * PI9[0][2][0];
    A[31] = sp[33] * PI0[0][2][1] + sp[34] * PI1[0][2][1] + sp[28] * PI2[0][2][1] + sp[31] * PI3[0][2][1] + sp[34] * PI1[0][1][2] + sp[35] * PI4[0][2][1] + sp[29] * PI5[0][2][1] + sp[32] * PI6[0][2][1] + sp[28] * PI2[0][1][2] + sp[29] * PI5[0][1][2] + sp[26] * PI7[0][2][1] + sp[27] * PI8[0][2][1] + sp[31] * PI3[0][1][2] + sp[32] * PI6[0][1][2] + sp[27] * PI8[0][1][2] + sp[30] * PI9[0][2][1];
    A[32] = sp[33] * PI0[0][2][2] + sp[34] * PI1[0][2][2] + sp[28] * PI2[0][2][2] + sp[31] * PI3[0][2][2] + sp[34] * PI1[0][2][2] + sp[35] * PI4[0][2][2] + sp[29] * PI5[0][2][2] + sp[32] * PI6[0][2][2] + sp[28] * PI2[0][2][2] + sp[29] * PI5[0][2][2] + sp[26] * PI7[0][2][2] + sp[27] * PI8[0][2][2] + sp[31] * PI3[0][2][2] + sp[32] * PI6[0][2][2] + sp[27] * PI8[0][2][2] + sp[30] * PI9[0][2][2];
    A[33] = sp[33] * PI0[0][2][3] + sp[34] * PI1[0][2][3] + sp[28] * PI2[0][2][3] + sp[31] * PI3[0][2][3] + sp[34] * PI1[0][3][2] + sp[35] * PI4[0][2][3] + sp[29] * PI5[0][2][3] + sp[32] * PI6[0][2][3] + sp[28] * PI2[0][3][2] + sp[29] * PI5[0][3][2] + sp[26] * PI7[0][2][3] + sp[27] * PI8[0][2][3] + sp[31] * PI3[0][3][2] + sp[32] * PI6[0][3][2] + sp[27] * PI8[0][3][2] + sp[30] * PI9[0][2][3];
    A[34] = sp[33] * PI0[0][2][4] + sp[34] * PI1[0][2][4] + sp[28] * PI2[0][2][4] + sp[31] * PI3[0][2][4] + sp[34] * PI1[0][4][2] + sp[35] * PI4[0][2][4] + sp[29] * PI5[0][2][4] + sp[32] * PI6[0][2][4] + sp[28] * PI2[0][4][2] + sp[29] * PI5[0][4][2] + sp[26] * PI7[0][2][4] + sp[27] * PI8[0][2][4] + sp[31] * PI3[0][4][2] + sp[32] * PI6[0][4][2] + sp[27] * PI8[0][4][2] + sp[30] * PI9[0][2][4];
    A[35] = sp[33] * PI0[0][2][5] + sp[34] * PI1[0][2][5] + sp[28] * PI2[0][2][5] + sp[31] * PI3[0][2][5] + sp[34] * PI1[0][5][2] + sp[35] * PI4[0][2][5] + sp[29] * PI5[0][2][5] + sp[32] * PI6[0][2][5] + sp[28] * PI2[0][5][2] + sp[29] * PI5[0][5][2] + sp[26] * PI7[0][2][5] + sp[27] * PI8[0][2][5] + sp[31] * PI3[0][5][2] + sp[32] * PI6[0][5][2] + sp[27] * PI8[0][5][2] + sp[30] * PI9[0][2][5];
    A[36] = sp[33] * PI0[0][2][6] + sp[34] * PI1[0][2][6] + sp[28] * PI2[0][2][6] + sp[31] * PI3[0][2][6] + sp[34] * PI1[0][6][2] + sp[35] * PI4[0][2][6] + sp[29] * PI5[0][2][6] + sp[32] * PI6[0][2][6] + sp[28] * PI2[0][6][2] + sp[29] * PI5[0][6][2] + sp[26] * PI7[0][2][6] + sp[27] * PI8[0][2][6] + sp[31] * PI3[0][6][2] + sp[32] * PI6[0][6][2] + sp[27] * PI8[0][6][2] + sp[30] * PI9[0][2][6];
    A[37] = sp[33] * PI0[0][2][7] + sp[34] * PI1[0][2][7] + sp[28] * PI2[0][2][7] + sp[31] * PI3[0][2][7] + sp[34] * PI1[0][7][2] + sp[35] * PI4[0][2][7] + sp[29] * PI5[0][2][7] + sp[32] * PI6[0][2][7] + sp[28] * PI2[0][7][2] + sp[29] * PI5[0][7][2] + sp[26] * PI7[0][2][7] + sp[27] * PI8[0][2][7] + sp[31] * PI3[0][7][2] + sp[32] * PI6[0][7][2] + sp[27] * PI8[0][7][2] + sp[30] * PI9[0][2][7];
    A[38] = sp[33] * PI0[0][2][8] + sp[34] * PI1[0][2][8] + sp[28] * PI2[0][2][8] + sp[31] * PI3[0][2][8] + sp[34] * PI1[0][8][2] + sp[35] * PI4[0][2][8] + sp[29] * PI5[0][2][8] + sp[32] * PI6[0][2][8] + sp[28] * PI2[0][8][2] + sp[29] * PI5[0][8][2] + sp[26] * PI7[0][2][8] + sp[27] * PI8[0][2][8] + sp[31] * PI3[0][8][2] + sp[32] * PI6[0][8][2] + sp[27] * PI8[0][8][2] + sp[30] * PI9[0][2][8];
    A[39] = sp[33] * PI0[0][2][9] + sp[34] * PI1[0][2][9] + sp[28] * PI2[0][2][9] + sp[31] * PI3[0][2][9] + sp[34] * PI1[0][9][2] + sp[35] * PI4[0][2][9] + sp[29] * PI5[0][2][9] + sp[32] * PI6[0][2][9] + sp[28] * PI2[0][9][2] + sp[29] * PI5[0][9][2] + sp[26] * PI7[0][2][9] + sp[27] * PI8[0][2][9] + sp[31] * PI3[0][9][2] + sp[32] * PI6[0][9][2] + sp[27] * PI8[0][9][2] + sp[30] * PI9[0][2][9];
    A[40] = sp[33] * PI0[0][2][10] + sp[34] * PI1[0][2][10] + sp[28] * PI2[0][2][10] + sp[31] * PI3[0][2][10] + sp[34] * PI1[0][10][2] + sp[35] * PI4[0][2][10] + sp[29] * PI5[0][2][10] + sp[32] * PI6[0][2][10] + sp[28] * PI2[0][10][2] + sp[29] * PI5[0][10][2] + sp[26] * PI7[0][2][10] + sp[27] * PI8[0][2][10] + sp[31] * PI3[0][10][2] + sp[32] * PI6[0][10][2] + sp[27] * PI8[0][10][2] + sp[30] * PI9[0][2][10];
    A[41] = sp[33] * PI0[0][2][11] + sp[34] * PI1[0][2][11] + sp[28] * PI2[0][2][11] + sp[31] * PI3[0][2][11] + sp[34] * PI1[0][11][2] + sp[35] * PI4[0][2][11] + sp[29] * PI5[0][2][11] + sp[32] * PI6[0][2][11] + sp[28] * PI2[0][11][2] + sp[29] * PI5[0][11][2] + sp[26] * PI7[0][2][11] + sp[27] * PI8[0][2][11] + sp[31] * PI3[0][11][2] + sp[32] * PI6[0][11][2] + sp[27] * PI8[0][11][2] + sp[30] * PI9[0][2][11];
    A[42] = sp[33] * PI0[0][2][12] + sp[34] * PI1[0][2][12] + sp[28] * PI2[0][2][12] + sp[31] * PI3[0][2][12] + sp[34] * PI1[0][12][2] + sp[35] * PI4[0][2][12] + sp[29] * PI5[0][2][12] + sp[32] * PI6[0][2][12] + sp[28] * PI2[0][12][2] + sp[29] * PI5[0][12][2] + sp[26] * PI7[0][2][12] + sp[27] * PI8[0][2][12] + sp[31] * PI3[0][12][2] + sp[32] * PI6[0][12][2] + sp[27] * PI8[0][12][2] + sp[30] * PI9[0][2][12];
    A[43] = sp[33] * PI0[0][2][13] + sp[34] * PI1[0][2][13] + sp[28] * PI2[0][2][13] + sp[31] * PI3[0][2][13] + sp[34] * PI1[0][13][2] + sp[35] * PI4[0][2][13] + sp[29] * PI5[0][2][13] + sp[32] * PI6[0][2][13] + sp[28] * PI2[0][13][2] + sp[29] * PI5[0][13][2] + sp[26] * PI7[0][2][13] + sp[27] * PI8[0][2][13] + sp[31] * PI3[0][13][2] + sp[32] * PI6[0][13][2] + sp[27] * PI8[0][13][2] + sp[30] * PI9[0][2][13];
    A[44] = sp[33] * PI0[0][2][14] + sp[34] * PI1[0][2][14] + sp[28] * PI2[0][2][14] + sp[31] * PI3[0][2][14] + sp[34] * PI1[0][14][2] + sp[35] * PI4[0][2][14] + sp[29] * PI5[0][2][14] + sp[32] * PI6[0][2][14] + sp[28] * PI2[0][14][2] + sp[29] * PI5[0][14][2] + sp[26] * PI7[0][2][14] + sp[27] * PI8[0][2][14] + sp[31] * PI3[0][14][2] + sp[32] * PI6[0][14][2] + sp[27] * PI8[0][14][2] + sp[30] * PI9[0][2][14];
    A[45] = sp[33] * PI0[0][3][0] + sp[34] * PI1[0][3][0] + sp[28] * PI2[0][3][0] + sp[31] * PI3[0][3][0] + sp[34] * PI1[0][0][3] + sp[35] * PI4[0][3][0] + sp[29] * PI5[0][3][0] + sp[32] * PI6[0][3][0] + sp[28] * PI2[0][0][3] + sp[29] * PI5[0][0][3] + sp[26] * PI7[0][3][0] + sp[27] * PI8[0][3][0] + sp[31] * PI3[0][0][3] + sp[32] * PI6[0][0][3] + sp[27] * PI8[0][0][3] + sp[30] * PI9[0][3][0];
    A[46] = sp[33] * PI0[0][3][1] + sp[34] * PI1[0][3][1] + sp[28] * PI2[0][3][1] + sp[31] * PI3[0][3][1] + sp[34] * PI1[0][1][3] + sp[35] * PI4[0][3][1] + sp[29] * PI5[0][3][1] + sp[32] * PI6[0][3][1] + sp[28] * PI2[0][1][3] + sp[29] * PI5[0][1][3] + sp[26] * PI7[0][3][1] + sp[27] * PI8[0][3][1] + sp[31] * PI3[0][1][3] + sp[32] * PI6[0][1][3] + sp[27] * PI8[0][1][3] + sp[30] * PI9[0][3][1];
    A[47] = sp[33] * PI0[0][3][2] + sp[34] * PI1[0][3][2] + sp[28] * PI2[0][3][2] + sp[31] * PI3[0][3][2] + sp[34] * PI1[0][2][3] + sp[35] * PI4[0][3][2] + sp[29] * PI5[0][3][2] + sp[32] * PI6[0][3][2] + sp[28] * PI2[0][2][3] + sp[29] * PI5[0][2][3] + sp[26] * PI7[0][3][2] + sp[27] * PI8[0][3][2] + sp[31] * PI3[0][2][3] + sp[32] * PI6[0][2][3] + sp[27] * PI8[0][2][3] + sp[30] * PI9[0][3][2];
    A[48] = sp[33] * PI0[0][3][3] + sp[34] * PI1[0][3][3] + sp[28] * PI2[0][3][3] + sp[31] * PI3[0][3][3] + sp[34] * PI1[0][3][3] + sp[35] * PI4[0][3][3] + sp[29] * PI5[0][3][3] + sp[32] * PI6[0][3][3] + sp[28] * PI2[0][3][3] + sp[29] * PI5[0][3][3] + sp[26] * PI7[0][3][3] + sp[27] * PI8[0][3][3] + sp[31] * PI3[0][3][3] + sp[32] * PI6[0][3][3] + sp[27] * PI8[0][3][3] + sp[30] * PI9[0][3][3];
    A[49] = sp[33] * PI0[0][3][4] + sp[34] * PI1[0][3][4] + sp[28] * PI2[0][3][4] + sp[31] * PI3[0][3][4] + sp[34] * PI1[0][4][3] + sp[35] * PI4[0][3][4] + sp[29] * PI5[0][3][4] + sp[32] * PI6[0][3][4] + sp[28] * PI2[0][4][3] + sp[29] * PI5[0][4][3] + sp[26] * PI7[0][3][4] + sp[27] * PI8[0][3][4] + sp[31] * PI3[0][4][3] + sp[32] * PI6[0][4][3] + sp[27] * PI8[0][4][3] + sp[30] * PI9[0][3][4];
    A[50] = sp[33] * PI0[0][3][5] + sp[34] * PI1[0][3][5] + sp[28] * PI2[0][3][5] + sp[31] * PI3[0][3][5] + sp[34] * PI1[0][5][3] + sp[35] * PI4[0][3][5] + sp[29] * PI5[0][3][5] + sp[32] * PI6[0][3][5] + sp[28] * PI2[0][5][3] + sp[29] * PI5[0][5][3] + sp[26] * PI7[0][3][5] + sp[27] * PI8[0][3][5] + sp[31] * PI3[0][5][3] + sp[32] * PI6[0][5][3] + sp[27] * PI8[0][5][3] + sp[30] * PI9[0][3][5];
    A[51] = sp[33] * PI0[0][3][6] + sp[34] * PI1[0][3][6] + sp[28] * PI2[0][3][6] + sp[31] * PI3[0][3][6] + sp[34] * PI1[0][6][3] + sp[35] * PI4[0][3][6] + sp[29] * PI5[0][3][6] + sp[32] * PI6[0][3][6] + sp[28] * PI2[0][6][3] + sp[29] * PI5[0][6][3] + sp[26] * PI7[0][3][6] + sp[27] * PI8[0][3][6] + sp[31] * PI3[0][6][3] + sp[32] * PI6[0][6][3] + sp[27] * PI8[0][6][3] + sp[30] * PI9[0][3][6];
    A[52] = sp[33] * PI0[0][3][7] + sp[34] * PI1[0][3][7] + sp[28] * PI2[0][3][7] + sp[31] * PI3[0][3][7] + sp[34] * PI1[0][7][3] + sp[35] * PI4[0][3][7] + sp[29] * PI5[0][3][7] + sp[32] * PI6[0][3][7] + sp[28] * PI2[0][7][3] + sp[29] * PI5[0][7][3] + sp[26] * PI7[0][3][7] + sp[27] * PI8[0][3][7] + sp[31] * PI3[0][7][3] + sp[32] * PI6[0][7][3] + sp[27] * PI8[0][7][3] + sp[30] * PI9[0][3][7];
    A[53] = sp[33] * PI0[0][3][8] + sp[34] * PI1[0][3][8] + sp[28] * PI2[0][3][8] + sp[31] * PI3[0][3][8] + sp[34] * PI1[0][8][3] + sp[35] * PI4[0][3][8] + sp[29] * PI5[0][3][8] + sp[32] * PI6[0][3][8] + sp[28] * PI2[0][8][3] + sp[29] * PI5[0][8][3] + sp[26] * PI7[0][3][8] + sp[27] * PI8[0][3][8] + sp[31] * PI3[0][8][3] + sp[32] * PI6[0][8][3] + sp[27] * PI8[0][8][3] + sp[30] * PI9[0][3][8];
    A[54] = sp[33] * PI0[0][3][9] + sp[34] * PI1[0][3][9] + sp[28] * PI2[0][3][9] + sp[31] * PI3[0][3][9] + sp[34] * PI1[0][9][3] + sp[35] * PI4[0][3][9] + sp[29] * PI5[0][3][9] + sp[32] * PI6[0][3][9] + sp[28] * PI2[0][9][3] + sp[29] * PI5[0][9][3] + sp[26] * PI7[0][3][9] + sp[27] * PI8[0][3][9] + sp[31] * PI3[0][9][3] + sp[32] * PI6[0][9][3] + sp[27] * PI8[0][9][3] + sp[30] * PI9[0][3][9];
    A[55] = sp[33] * PI0[0][3][10] + sp[34] * PI1[0][3][10] + sp[28] * PI2[0][3][10] + sp[31] * PI3[0][3][10] + sp[34] * PI1[0][10][3] + sp[35] * PI4[0][3][10] + sp[29] * PI5[0][3][10] + sp[32] * PI6[0][3][10] + sp[28] * PI2[0][10][3] + sp[29] * PI5[0][10][3] + sp[26] * PI7[0][3][10] + sp[27] * PI8[0][3][10] + sp[31] * PI3[0][10][3] + sp[32] * PI6[0][10][3] + sp[27] * PI8[0][10][3] + sp[30] * PI9[0][3][10];
    A[56] = sp[33] * PI0[0][3][11] + sp[34] * PI1[0][3][11] + sp[28] * PI2[0][3][11] + sp[31] * PI3[0][3][11] + sp[34] * PI1[0][11][3] + sp[35] * PI4[0][3][11] + sp[29] * PI5[0][3][11] + sp[32] * PI6[0][3][11] + sp[28] * PI2[0][11][3] + sp[29] * PI5[0][11][3] + sp[26] * PI7[0][3][11] + sp[27] * PI8[0][3][11] + sp[31] * PI3[0][11][3] + sp[32] * PI6[0][11][3] + sp[27] * PI8[0][11][3] + sp[30] * PI9[0][3][11];
    A[57] = sp[33] * PI0[0][3][12] + sp[34] * PI1[0][3][12] + sp[28] * PI2[0][3][12] + sp[31] * PI3[0][3][12] + sp[34] * PI1[0][12][3] + sp[35] * PI4[0][3][12] + sp[29] * PI5[0][3][12] + sp[32] * PI6[0][3][12] + sp[28] * PI2[0][12][3] + sp[29] * PI5[0][12][3] + sp[26] * PI7[0][3][12] + sp[27] * PI8[0][3][12] + sp[31] * PI3[0][12][3] + sp[32] * PI6[0][12][3] + sp[27] * PI8[0][12][3] + sp[30] * PI9[0][3][12];
    A[58] = sp[33] * PI0[0][3][13] + sp[34] * PI1[0][3][13] + sp[28] * PI2[0][3][13] + sp[31] * PI3[0][3][13] + sp[34] * PI1[0][13][3] + sp[35] * PI4[0][3][13] + sp[29] * PI5[0][3][13] + sp[32] * PI6[0][3][13] + sp[28] * PI2[0][13][3] + sp[29] * PI5[0][13][3] + sp[26] * PI7[0][3][13] + sp[27] * PI8[0][3][13] + sp[31] * PI3[0][13][3] + sp[32] * PI6[0][13][3] + sp[27] * PI8[0][13][3] + sp[30] * PI9[0][3][13];
    A[59] = sp[33] * PI0[0][3][14] + sp[34] * PI1[0][3][14] + sp[28] * PI2[0][3][14] + sp[31] * PI3[0][3][14] + sp[34] * PI1[0][14][3] + sp[35] * PI4[0][3][14] + sp[29] * PI5[0][3][14] + sp[32] * PI6[0][3][14] + sp[28] * PI2[0][14][3] + sp[29] * PI5[0][14][3] + sp[26] * PI7[0][3][14] + sp[27] * PI8[0][3][14] + sp[31] * PI3[0][14][3] + sp[32] * PI6[0][14][3] + sp[27] * PI8[0][14][3] + sp[30] * PI9[0][3][14];
    A[60] = sp[33] * PI0[0][4][0] + sp[34] * PI1[0][4][0] + sp[28] * PI2[0][4][0] + sp[31] * PI3[0][4][0] + sp[34] * PI1[0][0][4] + sp[35] * PI4[0][4][0] + sp[29] * PI5[0][4][0] + sp[32] * PI6[0][4][0] + sp[28] * PI2[0][0][4] + sp[29] * PI5[0][0][4] + sp[26] * PI7[0][4][0] + sp[27] * PI8[0][4][0] + sp[31] * PI3[0][0][4] + sp[32] * PI6[0][0][4] + sp[27] * PI8[0][0][4] + sp[30] * PI9[0][4][0];
    A[61] = sp[33] * PI0[0][4][1] + sp[34] * PI1[0][4][1] + sp[28] * PI2[0][4][1] + sp[31] * PI3[0][4][1] + sp[34] * PI1[0][1][4] + sp[35] * PI4[0][4][1] + sp[29] * PI5[0][4][1] + sp[32] * PI6[0][4][1] + sp[28] * PI2[0][1][4] + sp[29] * PI5[0][1][4] + sp[26] * PI7[0][4][1] + sp[27] * PI8[0][4][1] + sp[31] * PI3[0][1][4] + sp[32] * PI6[0][1][4] + sp[27] * PI8[0][1][4] + sp[30] * PI9[0][4][1];
    A[62] = sp[33] * PI0[0][4][2] + sp[34] * PI1[0][4][2] + sp[28] * PI2[0][4][2] + sp[31] * PI3[0][4][2] + sp[34] * PI1[0][2][4] + sp[35] * PI4[0][4][2] + sp[29] * PI5[0][4][2] + sp[32] * PI6[0][4][2] + sp[28] * PI2[0][2][4] + sp[29] * PI5[0][2][4] + sp[26] * PI7[0][4][2] + sp[27] * PI8[0][4][2] + sp[31] * PI3[0][2][4] + sp[32] * PI6[0][2][4] + sp[27] * PI8[0][2][4] + sp[30] * PI9[0][4][2];
    A[63] = sp[33] * PI0[0][4][3] + sp[34] * PI1[0][4][3] + sp[28] * PI2[0][4][3] + sp[31] * PI3[0][4][3] + sp[34] * PI1[0][3][4] + sp[35] * PI4[0][4][3] + sp[29] * PI5[0][4][3] + sp[32] * PI6[0][4][3] + sp[28] * PI2[0][3][4] + sp[29] * PI5[0][3][4] + sp[26] * PI7[0][4][3] + sp[27] * PI8[0][4][3] + sp[31] * PI3[0][3][4] + sp[32] * PI6[0][3][4] + sp[27] * PI8[0][3][4] + sp[30] * PI9[0][4][3];
    A[64] = sp[33] * PI0[0][4][4] + sp[34] * PI1[0][4][4] + sp[28] * PI2[0][4][4] + sp[31] * PI3[0][4][4] + sp[34] * PI1[0][4][4] + sp[35] * PI4[0][4][4] + sp[29] * PI5[0][4][4] + sp[32] * PI6[0][4][4] + sp[28] * PI2[0][4][4] + sp[29] * PI5[0][4][4] + sp[26] * PI7[0][4][4] + sp[27] * PI8[0][4][4] + sp[31] * PI3[0][4][4] + sp[32] * PI6[0][4][4] + sp[27] * PI8[0][4][4] + sp[30] * PI9[0][4][4];
    A[65] = sp[33] * PI0[0][4][5] + sp[34] * PI1[0][4][5] + sp[28] * PI2[0][4][5] + sp[31] * PI3[0][4][5] + sp[34] * PI1[0][5][4] + sp[35] * PI4[0][4][5] + sp[29] * PI5[0][4][5] + sp[32] * PI6[0][4][5] + sp[28] * PI2[0][5][4] + sp[29] * PI5[0][5][4] + sp[26] * PI7[0][4][5] + sp[27] * PI8[0][4][5] + sp[31] * PI3[0][5][4] + sp[32] * PI6[0][5][4] + sp[27] * PI8[0][5][4] + sp[30] * PI9[0][4][5];
    A[66] = sp[33] * PI0[0][4][6] + sp[34] * PI1[0][4][6] + sp[28] * PI2[0][4][6] + sp[31] * PI3[0][4][6] + sp[34] * PI1[0][6][4] + sp[35] * PI4[0][4][6] + sp[29] * PI5[0][4][6] + sp[32] * PI6[0][4][6] + sp[28] * PI2[0][6][4] + sp[29] * PI5[0][6][4] + sp[26] * PI7[0][4][6] + sp[27] * PI8[0][4][6] + sp[31] * PI3[0][6][4] + sp[32] * PI6[0][6][4] + sp[27] * PI8[0][6][4] + sp[30] * PI9[0][4][6];
    A[67] = sp[33] * PI0[0][4][7] + sp[34] * PI1[0][4][7] + sp[28] * PI2[0][4][7] + sp[31] * PI3[0][4][7] + sp[34] * PI1[0][7][4] + sp[35] * PI4[0][4][7] + sp[29] * PI5[0][4][7] + sp[32] * PI6[0][4][7] + sp[28] * PI2[0][7][4] + sp[29] * PI5[0][7][4] + sp[26] * PI7[0][4][7] + sp[27] * PI8[0][4][7] + sp[31] * PI3[0][7][4] + sp[32] * PI6[0][7][4] + sp[27] * PI8[0][7][4] + sp[30] * PI9[0][4][7];
    A[68] = sp[33] * PI0[0][4][8] + sp[34] * PI1[0][4][8] + sp[28] * PI2[0][4][8] + sp[31] * PI3[0][4][8] + sp[34] * PI1[0][8][4] + sp[35] * PI4[0][4][8] + sp[29] * PI5[0][4][8] + sp[32] * PI6[0][4][8] + sp[28] * PI2[0][8][4] + sp[29] * PI5[0][8][4] + sp[26] * PI7[0][4][8] + sp[27] * PI8[0][4][8] + sp[31] * PI3[0][8][4] + sp[32] * PI6[0][8][4] + sp[27] * PI8[0][8][4] + sp[30] * PI9[0][4][8];
    A[69] = sp[33] * PI0[0][4][9] + sp[34] * PI1[0][4][9] + sp[28] * PI2[0][4][9] + sp[31] * PI3[0][4][9] + sp[34] * PI1[0][9][4] + sp[35] * PI4[0][4][9] + sp[29] * PI5[0][4][9] + sp[32] * PI6[0][4][9] + sp[28] * PI2[0][9][4] + sp[29] * PI5[0][9][4] + sp[26] * PI7[0][4][9] + sp[27] * PI8[0][4][9] + sp[31] * PI3[0][9][4] + sp[32] * PI6[0][9][4] + sp[27] * PI8[0][9][4] + sp[30] * PI9[0][4][9];
    A[70] = sp[33] * PI0[0][4][10] + sp[34] * PI1[0][4][10] + sp[28] * PI2[0][4][10] + sp[31] * PI3[0][4][10] + sp[34] * PI1[0][10][4] + sp[35] * PI4[0][4][10] + sp[29] * PI5[0][4][10] + sp[32] * PI6[0][4][10] + sp[28] * PI2[0][10][4] + sp[29] * PI5[0][10][4] + sp[26] * PI7[0][4][10] + sp[27] * PI8[0][4][10] + sp[31] * PI3[0][10][4] + sp[32] * PI6[0][10][4] + sp[27] * PI8[0][10][4] + sp[30] * PI9[0][4][10];
    A[71] = sp[33] * PI0[0][4][11] + sp[34] * PI1[0][4][11] + sp[28] * PI2[0][4][11] + sp[31] * PI3[0][4][11] + sp[34] * PI1[0][11][4] + sp[35] * PI4[0][4][11] + sp[29] * PI5[0][4][11] + sp[32] * PI6[0][4][11] + sp[28] * PI2[0][11][4] + sp[29] * PI5[0][11][4] + sp[26] * PI7[0][4][11] + sp[27] * PI8[0][4][11] + sp[31] * PI3[0][11][4] + sp[32] * PI6[0][11][4] + sp[27] * PI8[0][11][4] + sp[30] * PI9[0][4][11];
    A[72] = sp[33] * PI0[0][4][12] + sp[34] * PI1[0][4][12] + sp[28] * PI2[0][4][12] + sp[31] * PI3[0][4][12] + sp[34] * PI1[0][12][4] + sp[35] * PI4[0][4][12] + sp[29] * PI5[0][4][12] + sp[32] * PI6[0][4][12] + sp[28] * PI2[0][12][4] + sp[29] * PI5[0][12][4] + sp[26] * PI7[0][4][12] + sp[27] * PI8[0][4][12] + sp[31] * PI3[0][12][4] + sp[32] * PI6[0][12][4] + sp[27] * PI8[0][12][4] + sp[30] * PI9[0][4][12];
    A[73] = sp[33] * PI0[0][4][13] + sp[34] * PI1[0][4][13] + sp[28] * PI2[0][4][13] + sp[31] * PI3[0][4][13] + sp[34] * PI1[0][13][4] + sp[35] * PI4[0][4][13] + sp[29] * PI5[0][4][13] + sp[32] * PI6[0][4][13] + sp[28] * PI2[0][13][4] + sp[29] * PI5[0][13][4] + sp[26] * PI7[0][4][13] + sp[27] * PI8[0][4][13] + sp[31] * PI3[0][13][4] + sp[32] * PI6[0][13][4] + sp[27] * PI8[0][13][4] + sp[30] * PI9[0][4][13];
    A[74] = sp[33] * PI0[0][4][14] + sp[34] * PI1[0][4][14] + sp[28] * PI2[0][4][14] + sp[31] * PI3[0][4][14] + sp[34] * PI1[0][14][4] + sp[35] * PI4[0][4][14] + sp[29] * PI5[0][4][14] + sp[32] * PI6[0][4][14] + sp[28] * PI2[0][14][4] + sp[29] * PI5[0][14][4] + sp[26] * PI7[0][4][14] + sp[27] * PI8[0][4][14] + sp[31] * PI3[0][14][4] + sp[32] * PI6[0][14][4] + sp[27] * PI8[0][14][4] + sp[30] * PI9[0][4][14];
    A[75] = sp[33] * PI0[0][5][0] + sp[34] * PI1[0][5][0] + sp[28] * PI2[0][5][0] + sp[31] * PI3[0][5][0] + sp[34] * PI1[0][0][5] + sp[35] * PI4[0][5][0] + sp[29] * PI5[0][5][0] + sp[32] * PI6[0][5][0] + sp[28] * PI2[0][0][5] + sp[29] * PI5[0][0][5] + sp[26] * PI7[0][5][0] + sp[27] * PI8[0][5][0] + sp[31] * PI3[0][0][5] + sp[32] * PI6[0][0][5] + sp[27] * PI8[0][0][5] + sp[30] * PI9[0][5][0];
    A[76] = sp[33] * PI0[0][5][1] + sp[34] * PI1[0][5][1] + sp[28] * PI2[0][5][1] + sp[31] * PI3[0][5][1] + sp[34] * PI1[0][1][5] + sp[35] * PI4[0][5][1] + sp[29] * PI5[0][5][1] + sp[32] * PI6[0][5][1] + sp[28] * PI2[0][1][5] + sp[29] * PI5[0][1][5] + sp[26] * PI7[0][5][1] + sp[27] * PI8[0][5][1] + sp[31] * PI3[0][1][5] + sp[32] * PI6[0][1][5] + sp[27] * PI8[0][1][5] + sp[30] * PI9[0][5][1];
    A[77] = sp[33] * PI0[0][5][2] + sp[34] * PI1[0][5][2] + sp[28] * PI2[0][5][2] + sp[31] * PI3[0][5][2] + sp[34] * PI1[0][2][5] + sp[35] * PI4[0][5][2] + sp[29] * PI5[0][5][2] + sp[32] * PI6[0][5][2] + sp[28] * PI2[0][2][5] + sp[29] * PI5[0][2][5] + sp[26] * PI7[0][5][2] + sp[27] * PI8[0][5][2] + sp[31] * PI3[0][2][5] + sp[32] * PI6[0][2][5] + sp[27] * PI8[0][2][5] + sp[30] * PI9[0][5][2];
    A[78] = sp[33] * PI0[0][5][3] + sp[34] * PI1[0][5][3] + sp[28] * PI2[0][5][3] + sp[31] * PI3[0][5][3] + sp[34] * PI1[0][3][5] + sp[35] * PI4[0][5][3] + sp[29] * PI5[0][5][3] + sp[32] * PI6[0][5][3] + sp[28] * PI2[0][3][5] + sp[29] * PI5[0][3][5] + sp[26] * PI7[0][5][3] + sp[27] * PI8[0][5][3] + sp[31] * PI3[0][3][5] + sp[32] * PI6[0][3][5] + sp[27] * PI8[0][3][5] + sp[30] * PI9[0][5][3];
    A[79] = sp[33] * PI0[0][5][4] + sp[34] * PI1[0][5][4] + sp[28] * PI2[0][5][4] + sp[31] * PI3[0][5][4] + sp[34] * PI1[0][4][5] + sp[35] * PI4[0][5][4] + sp[29] * PI5[0][5][4] + sp[32] * PI6[0][5][4] + sp[28] * PI2[0][4][5] + sp[29] * PI5[0][4][5] + sp[26] * PI7[0][5][4] + sp[27] * PI8[0][5][4] + sp[31] * PI3[0][4][5] + sp[32] * PI6[0][4][5] + sp[27] * PI8[0][4][5] + sp[30] * PI9[0][5][4];
    A[80] = sp[33] * PI0[0][5][5] + sp[34] * PI1[0][5][5] + sp[28] * PI2[0][5][5] + sp[31] * PI3[0][5][5] + sp[34] * PI1[0][5][5] + sp[35] * PI4[0][5][5] + sp[29] * PI5[0][5][5] + sp[32] * PI6[0][5][5] + sp[28] * PI2[0][5][5] + sp[29] * PI5[0][5][5] + sp[26] * PI7[0][5][5] + sp[27] * PI8[0][5][5] + sp[31] * PI3[0][5][5] + sp[32] * PI6[0][5][5] + sp[27] * PI8[0][5][5] + sp[30] * PI9[0][5][5];
    A[81] = sp[33] * PI0[0][5][6] + sp[34] * PI1[0][5][6] + sp[28] * PI2[0][5][6] + sp[31] * PI3[0][5][6] + sp[34] * PI1[0][6][5] + sp[35] * PI4[0][5][6] + sp[29] * PI5[0][5][6] + sp[32] * PI6[0][5][6] + sp[28] * PI2[0][6][5] + sp[29] * PI5[0][6][5] + sp[26] * PI7[0][5][6] + sp[27] * PI8[0][5][6] + sp[31] * PI3[0][6][5] + sp[32] * PI6[0][6][5] + sp[27] * PI8[0][6][5] + sp[30] * PI9[0][5][6];
    A[82] = sp[33] * PI0[0][5][7] + sp[34] * PI1[0][5][7] + sp[28] * PI2[0][5][7] + sp[31] * PI3[0][5][7] + sp[34] * PI1[0][7][5] + sp[35] * PI4[0][5][7] + sp[29] * PI5[0][5][7] + sp[32] * PI6[0][5][7] + sp[28] * PI2[0][7][5] + sp[29] * PI5[0][7][5] + sp[26] * PI7[0][5][7] + sp[27] * PI8[0][5][7] + sp[31] * PI3[0][7][5] + sp[32] * PI6[0][7][5] + sp[27] * PI8[0][7][5] + sp[30] * PI9[0][5][7];
    A[83] = sp[33] * PI0[0][5][8] + sp[34] * PI1[0][5][8] + sp[28] * PI2[0][5][8] + sp[31] * PI3[0][5][8] + sp[34] * PI1[0][8][5] + sp[35] * PI4[0][5][8] + sp[29] * PI5[0][5][8] + sp[32] * PI6[0][5][8] + sp[28] * PI2[0][8][5] + sp[29] * PI5[0][8][5] + sp[26] * PI7[0][5][8] + sp[27] * PI8[0][5][8] + sp[31] * PI3[0][8][5] + sp[32] * PI6[0][8][5] + sp[27] * PI8[0][8][5] + sp[30] * PI9[0][5][8];
    A[84] = sp[33] * PI0[0][5][9] + sp[34] * PI1[0][5][9] + sp[28] * PI2[0][5][9] + sp[31] * PI3[0][5][9] + sp[34] * PI1[0][9][5] + sp[35] * PI4[0][5][9] + sp[29] * PI5[0][5][9] + sp[32] * PI6[0][5][9] + sp[28] * PI2[0][9][5] + sp[29] * PI5[0][9][5] + sp[26] * PI7[0][5][9] + sp[27] * PI8[0][5][9] + sp[31] * PI3[0][9][5] + sp[32] * PI6[0][9][5] + sp[27] * PI8[0][9][5] + sp[30] * PI9[0][5][9];
    A[85] = sp[33] * PI0[0][5][10] + sp[34] * PI1[0][5][10] + sp[28] * PI2[0][5][10] + sp[31] * PI3[0][5][10] + sp[34] * PI1[0][10][5] + sp[35] * PI4[0][5][10] + sp[29] * PI5[0][5][10] + sp[32] * PI6[0][5][10] + sp[28] * PI2[0][10][5] + sp[29] * PI5[0][10][5] + sp[26] * PI7[0][5][10] + sp[27] * PI8[0][5][10] + sp[31] * PI3[0][10][5] + sp[32] * PI6[0][10][5] + sp[27] * PI8[0][10][5] + sp[30] * PI9[0][5][10];
    A[86] = sp[33] * PI0[0][5][11] + sp[34] * PI1[0][5][11] + sp[28] * PI2[0][5][11] + sp[31] * PI3[0][5][11] + sp[34] * PI1[0][11][5] + sp[35] * PI4[0][5][11] + sp[29] * PI5[0][5][11] + sp[32] * PI6[0][5][11] + sp[28] * PI2[0][11][5] + sp[29] * PI5[0][11][5] + sp[26] * PI7[0][5][11] + sp[27] * PI8[0][5][11] + sp[31] * PI3[0][11][5] + sp[32] * PI6[0][11][5] + sp[27] * PI8[0][11][5] + sp[30] * PI9[0][5][11];
    A[87] = sp[33] * PI0[0][5][12] + sp[34] * PI1[0][5][12] + sp[28] * PI2[0][5][12] + sp[31] * PI3[0][5][12] + sp[34] * PI1[0][12][5] + sp[35] * PI4[0][5][12] + sp[29] * PI5[0][5][12] + sp[32] * PI6[0][5][12] + sp[28] * PI2[0][12][5] + sp[29] * PI5[0][12][5] + sp[26] * PI7[0][5][12] + sp[27] * PI8[0][5][12] + sp[31] * PI3[0][12][5] + sp[32] * PI6[0][12][5] + sp[27] * PI8[0][12][5] + sp[30] * PI9[0][5][12];
    A[88] = sp[33] * PI0[0][5][13] + sp[34] * PI1[0][5][13] + sp[28] * PI2[0][5][13] + sp[31] * PI3[0][5][13] + sp[34] * PI1[0][13][5] + sp[35] * PI4[0][5][13] + sp[29] * PI5[0][5][13] + sp[32] * PI6[0][5][13] + sp[28] * PI2[0][13][5] + sp[29] * PI5[0][13][5] + sp[26] * PI7[0][5][13] + sp[27] * PI8[0][5][13] + sp[31] * PI3[0][13][5] + sp[32] * PI6[0][13][5] + sp[27] * PI8[0][13][5] + sp[30] * PI9[0][5][13];
    A[89] = sp[33] * PI0[0][5][14] + sp[34] * PI1[0][5][14] + sp[28] * PI2[0][5][14] + sp[31] * PI3[0][5][14] + sp[34] * PI1[0][14][5] + sp[35] * PI4[0][5][14] + sp[29] * PI5[0][5][14] + sp[32] * PI6[0][5][14] + sp[28] * PI2[0][14][5] + sp[29] * PI5[0][14][5] + sp[26] * PI7[0][5][14] + sp[27] * PI8[0][5][14] + sp[31] * PI3[0][14][5] + sp[32] * PI6[0][14][5] + sp[27] * PI8[0][14][5] + sp[30] * PI9[0][5][14];
    A[90] = sp[33] * PI0[0][6][0] + sp[34] * PI1[0][6][0] + sp[28] * PI2[0][6][0] + sp[31] * PI3[0][6][0] + sp[34] * PI1[0][0][6] + sp[35] * PI4[0][6][0] + sp[29] * PI5[0][6][0] + sp[32] * PI6[0][6][0] + sp[28] * PI2[0][0][6] + sp[29] * PI5[0][0][6] + sp[26] * PI7[0][6][0] + sp[27] * PI8[0][6][0] + sp[31] * PI3[0][0][6] + sp[32] * PI6[0][0][6] + sp[27] * PI8[0][0][6] + sp[30] * PI9[0][6][0];
    A[91] = sp[33] * PI0[0][6][1] + sp[34] * PI1[0][6][1] + sp[28] * PI2[0][6][1] + sp[31] * PI3[0][6][1] + sp[34] * PI1[0][1][6] + sp[35] * PI4[0][6][1] + sp[29] * PI5[0][6][1] + sp[32] * PI6[0][6][1] + sp[28] * PI2[0][1][6] + sp[29] * PI5[0][1][6] + sp[26] * PI7[0][6][1] + sp[27] * PI8[0][6][1] + sp[31] * PI3[0][1][6] + sp[32] * PI6[0][1][6] + sp[27] * PI8[0][1][6] + sp[30] * PI9[0][6][1];
    A[92] = sp[33] * PI0[0][6][2] + sp[34] * PI1[0][6][2] + sp[28] * PI2[0][6][2] + sp[31] * PI3[0][6][2] + sp[34] * PI1[0][2][6] + sp[35] * PI4[0][6][2] + sp[29] * PI5[0][6][2] + sp[32] * PI6[0][6][2] + sp[28] * PI2[0][2][6] + sp[29] * PI5[0][2][6] + sp[26] * PI7[0][6][2] + sp[27] * PI8[0][6][2] + sp[31] * PI3[0][2][6] + sp[32] * PI6[0][2][6] + sp[27] * PI8[0][2][6] + sp[30] * PI9[0][6][2];
    A[93] = sp[33] * PI0[0][6][3] + sp[34] * PI1[0][6][3] + sp[28] * PI2[0][6][3] + sp[31] * PI3[0][6][3] + sp[34] * PI1[0][3][6] + sp[35] * PI4[0][6][3] + sp[29] * PI5[0][6][3] + sp[32] * PI6[0][6][3] + sp[28] * PI2[0][3][6] + sp[29] * PI5[0][3][6] + sp[26] * PI7[0][6][3] + sp[27] * PI8[0][6][3] + sp[31] * PI3[0][3][6] + sp[32] * PI6[0][3][6] + sp[27] * PI8[0][3][6] + sp[30] * PI9[0][6][3];
    A[94] = sp[33] * PI0[0][6][4] + sp[34] * PI1[0][6][4] + sp[28] * PI2[0][6][4] + sp[31] * PI3[0][6][4] + sp[34] * PI1[0][4][6] + sp[35] * PI4[0][6][4] + sp[29] * PI5[0][6][4] + sp[32] * PI6[0][6][4] + sp[28] * PI2[0][4][6] + sp[29] * PI5[0][4][6] + sp[26] * PI7[0][6][4] + sp[27] * PI8[0][6][4] + sp[31] * PI3[0][4][6] + sp[32] * PI6[0][4][6] + sp[27] * PI8[0][4][6] + sp[30] * PI9[0][6][4];
    A[95] = sp[33] * PI0[0][6][5] + sp[34] * PI1[0][6][5] + sp[28] * PI2[0][6][5] + sp[31] * PI3[0][6][5] + sp[34] * PI1[0][5][6] + sp[35] * PI4[0][6][5] + sp[29] * PI5[0][6][5] + sp[32] * PI6[0][6][5] + sp[28] * PI2[0][5][6] + sp[29] * PI5[0][5][6] + sp[26] * PI7[0][6][5] + sp[27] * PI8[0][6][5] + sp[31] * PI3[0][5][6] + sp[32] * PI6[0][5][6] + sp[27] * PI8[0][5][6] + sp[30] * PI9[0][6][5];
    A[96] = sp[33] * PI0[0][6][6] + sp[34] * PI1[0][6][6] + sp[28] * PI2[0][6][6] + sp[31] * PI3[0][6][6] + sp[34] * PI1[0][6][6] + sp[35] * PI4[0][6][6] + sp[29] * PI5[0][6][6] + sp[32] * PI6[0][6][6] + sp[28] * PI2[0][6][6] + sp[29] * PI5[0][6][6] + sp[26] * PI7[0][6][6] + sp[27] * PI8[0][6][6] + sp[31] * PI3[0][6][6] + sp[32] * PI6[0][6][6] + sp[27] * PI8[0][6][6] + sp[30] * PI9[0][6][6];
    A[97] = sp[33] * PI0[0][6][7] + sp[34] * PI1[0][6][7] + sp[28] * PI2[0][6][7] + sp[31] * PI3[0][6][7] + sp[34] * PI1[0][7][6] + sp[35] * PI4[0][6][7] + sp[29] * PI5[0][6][7] + sp[32] * PI6[0][6][7] + sp[28] * PI2[0][7][6] + sp[29] * PI5[0][7][6] + sp[26] * PI7[0][6][7] + sp[27] * PI8[0][6][7] + sp[31] * PI3[0][7][6] + sp[32] * PI6[0][7][6] + sp[27] * PI8[0][7][6] + sp[30] * PI9[0][6][7];
    A[98] = sp[33] * PI0[0][6][8] + sp[34] * PI1[0][6][8] + sp[28] * PI2[0][6][8] + sp[31] * PI3[0][6][8] + sp[34] * PI1[0][8][6] + sp[35] * PI4[0][6][8] + sp[29] * PI5[0][6][8] + sp[32] * PI6[0][6][8] + sp[28] * PI2[0][8][6] + sp[29] * PI5[0][8][6] + sp[26] * PI7[0][6][8] + sp[27] * PI8[0][6][8] + sp[31] * PI3[0][8][6] + sp[32] * PI6[0][8][6] + sp[27] * PI8[0][8][6] + sp[30] * PI9[0][6][8];
    A[99] = sp[33] * PI0[0][6][9] + sp[34] * PI1[0][6][9] + sp[28] * PI2[0][6][9] + sp[31] * PI3[0][6][9] + sp[34] * PI1[0][9][6] + sp[35] * PI4[0][6][9] + sp[29] * PI5[0][6][9] + sp[32] * PI6[0][6][9] + sp[28] * PI2[0][9][6] + sp[29] * PI5[0][9][6] + sp[26] * PI7[0][6][9] + sp[27] * PI8[0][6][9] + sp[31] * PI3[0][9][6] + sp[32] * PI6[0][9][6] + sp[27] * PI8[0][9][6] + sp[30] * PI9[0][6][9];
    A[100] = sp[33] * PI0[0][6][10] + sp[34] * PI1[0][6][10] + sp[28] * PI2[0][6][10] + sp[31] * PI3[0][6][10] + sp[34] * PI1[0][10][6] + sp[35] * PI4[0][6][10] + sp[29] * PI5[0][6][10] + sp[32] * PI6[0][6][10] + sp[28] * PI2[0][10][6] + sp[29] * PI5[0][10][6] + sp[26] * PI7[0][6][10] + sp[27] * PI8[0][6][10] + sp[31] * PI3[0][10][6] + sp[32] * PI6[0][10][6] + sp[27] * PI8[0][10][6] + sp[30] * PI9[0][6][10];
    A[101] = sp[33] * PI0[0][6][11] + sp[34] * PI1[0][6][11] + sp[28] * PI2[0][6][11] + sp[31] * PI3[0][6][11] + sp[34] * PI1[0][11][6] + sp[35] * PI4[0][6][11] + sp[29] * PI5[0][6][11] + sp[32] * PI6[0][6][11] + sp[28] * PI2[0][11][6] + sp[29] * PI5[0][11][6] + sp[26] * PI7[0][6][11] + sp[27] * PI8[0][6][11] + sp[31] * PI3[0][11][6] + sp[32] * PI6[0][11][6] + sp[27] * PI8[0][11][6] + sp[30] * PI9[0][6][11];
    A[102] = sp[33] * PI0[0][6][12] + sp[34] * PI1[0][6][12] + sp[28] * PI2[0][6][12] + sp[31] * PI3[0][6][12] + sp[34] * PI1[0][12][6] + sp[35] * PI4[0][6][12] + sp[29] * PI5[0][6][12] + sp[32] * PI6[0][6][12] + sp[28] * PI2[0][12][6] + sp[29] * PI5[0][12][6] + sp[26] * PI7[0][6][12] + sp[27] * PI8[0][6][12] + sp[31] * PI3[0][12][6] + sp[32] * PI6[0][12][6] + sp[27] * PI8[0][12][6] + sp[30] * PI9[0][6][12];
    A[103] = sp[33] * PI0[0][6][13] + sp[34] * PI1[0][6][13] + sp[28] * PI2[0][6][13] + sp[31] * PI3[0][6][13] + sp[34] * PI1[0][13][6] + sp[35] * PI4[0][6][13] + sp[29] * PI5[0][6][13] + sp[32] * PI6[0][6][13] + sp[28] * PI2[0][13][6] + sp[29] * PI5[0][13][6] + sp[26] * PI7[0][6][13] + sp[27] * PI8[0][6][13] + sp[31] * PI3[0][13][6] + sp[32] * PI6[0][13][6] + sp[27] * PI8[0][13][6] + sp[30] * PI9[0][6][13];
    A[104] = sp[33] * PI0[0][6][14] + sp[34] * PI1[0][6][14] + sp[28] * PI2[0][6][14] + sp[31] * PI3[0][6][14] + sp[34] * PI1[0][14][6] + sp[35] * PI4[0][6][14] + sp[29] * PI5[0][6][14] + sp[32] * PI6[0][6][14] + sp[28] * PI2[0][14][6] + sp[29] * PI5[0][14][6] + sp[26] * PI7[0][6][14] + sp[27] * PI8[0][6][14] + sp[31] * PI3[0][14][6] + sp[32] * PI6[0][14][6] + sp[27] * PI8[0][14][6] + sp[30] * PI9[0][6][14];
    A[105] = sp[33] * PI0[0][7][0] + sp[34] * PI1[0][7][0] + sp[28] * PI2[0][7][0] + sp[31] * PI3[0][7][0] + sp[34] * PI1[0][0][7] + sp[35] * PI4[0][7][0] + sp[29] * PI5[0][7][0] + sp[32] * PI6[0][7][0] + sp[28] * PI2[0][0][7] + sp[29] * PI5[0][0][7] + sp[26] * PI7[0][7][0] + sp[27] * PI8[0][7][0] + sp[31] * PI3[0][0][7] + sp[32] * PI6[0][0][7] + sp[27] * PI8[0][0][7] + sp[30] * PI9[0][7][0];
    A[106] = sp[33] * PI0[0][7][1] + sp[34] * PI1[0][7][1] + sp[28] * PI2[0][7][1] + sp[31] * PI3[0][7][1] + sp[34] * PI1[0][1][7] + sp[35] * PI4[0][7][1] + sp[29] * PI5[0][7][1] + sp[32] * PI6[0][7][1] + sp[28] * PI2[0][1][7] + sp[29] * PI5[0][1][7] + sp[26] * PI7[0][7][1] + sp[27] * PI8[0][7][1] + sp[31] * PI3[0][1][7] + sp[32] * PI6[0][1][7] + sp[27] * PI8[0][1][7] + sp[30] * PI9[0][7][1];
    A[107] = sp[33] * PI0[0][7][2] + sp[34] * PI1[0][7][2] + sp[28] * PI2[0][7][2] + sp[31] * PI3[0][7][2] + sp[34] * PI1[0][2][7] + sp[35] * PI4[0][7][2] + sp[29] * PI5[0][7][2] + sp[32] * PI6[0][7][2] + sp[28] * PI2[0][2][7] + sp[29] * PI5[0][2][7] + sp[26] * PI7[0][7][2] + sp[27] * PI8[0][7][2] + sp[31] * PI3[0][2][7] + sp[32] * PI6[0][2][7] + sp[27] * PI8[0][2][7] + sp[30] * PI9[0][7][2];
    A[108] = sp[33] * PI0[0][7][3] + sp[34] * PI1[0][7][3] + sp[28] * PI2[0][7][3] + sp[31] * PI3[0][7][3] + sp[34] * PI1[0][3][7] + sp[35] * PI4[0][7][3] + sp[29] * PI5[0][7][3] + sp[32] * PI6[0][7][3] + sp[28] * PI2[0][3][7] + sp[29] * PI5[0][3][7] + sp[26] * PI7[0][7][3] + sp[27] * PI8[0][7][3] + sp[31] * PI3[0][3][7] + sp[32] * PI6[0][3][7] + sp[27] * PI8[0][3][7] + sp[30] * PI9[0][7][3];
    A[109] = sp[33] * PI0[0][7][4] + sp[34] * PI1[0][7][4] + sp[28] * PI2[0][7][4] + sp[31] * PI3[0][7][4] + sp[34] * PI1[0][4][7] + sp[35] * PI4[0][7][4] + sp[29] * PI5[0][7][4] + sp[32] * PI6[0][7][4] + sp[28] * PI2[0][4][7] + sp[29] * PI5[0][4][7] + sp[26] * PI7[0][7][4] + sp[27] * PI8[0][7][4] + sp[31] * PI3[0][4][7] + sp[32] * PI6[0][4][7] + sp[27] * PI8[0][4][7] + sp[30] * PI9[0][7][4];
    A[110] = sp[33] * PI0[0][7][5] + sp[34] * PI1[0][7][5] + sp[28] * PI2[0][7][5] + sp[31] * PI3[0][7][5] + sp[34] * PI1[0][5][7] + sp[35] * PI4[0][7][5] + sp[29] * PI5[0][7][5] + sp[32] * PI6[0][7][5] + sp[28] * PI2[0][5][7] + sp[29] * PI5[0][5][7] + sp[26] * PI7[0][7][5] + sp[27] * PI8[0][7][5] + sp[31] * PI3[0][5][7] + sp[32] * PI6[0][5][7] + sp[27] * PI8[0][5][7] + sp[30] * PI9[0][7][5];
    A[111] = sp[33] * PI0[0][7][6] + sp[34] * PI1[0][7][6] + sp[28] * PI2[0][7][6] + sp[31] * PI3[0][7][6] + sp[34] * PI1[0][6][7] + sp[35] * PI4[0][7][6] + sp[29] * PI5[0][7][6] + sp[32] * PI6[0][7][6] + sp[28] * PI2[0][6][7] + sp[29] * PI5[0][6][7] + sp[26] * PI7[0][7][6] + sp[27] * PI8[0][7][6] + sp[31] * PI3[0][6][7] + sp[32] * PI6[0][6][7] + sp[27] * PI8[0][6][7] + sp[30] * PI9[0][7][6];
    A[112] = sp[33] * PI0[0][7][7] + sp[34] * PI1[0][7][7] + sp[28] * PI2[0][7][7] + sp[31] * PI3[0][7][7] + sp[34] * PI1[0][7][7] + sp[35] * PI4[0][7][7] + sp[29] * PI5[0][7][7] + sp[32] * PI6[0][7][7] + sp[28] * PI2[0][7][7] + sp[29] * PI5[0][7][7] + sp[26] * PI7[0][7][7] + sp[27] * PI8[0][7][7] + sp[31] * PI3[0][7][7] + sp[32] * PI6[0][7][7] + sp[27] * PI8[0][7][7] + sp[30] * PI9[0][7][7];
    A[113] = sp[33] * PI0[0][7][8] + sp[34] * PI1[0][7][8] + sp[28] * PI2[0][7][8] + sp[31] * PI3[0][7][8] + sp[34] * PI1[0][8][7] + sp[35] * PI4[0][7][8] + sp[29] * PI5[0][7][8] + sp[32] * PI6[0][7][8] + sp[28] * PI2[0][8][7] + sp[29] * PI5[0][8][7] + sp[26] * PI7[0][7][8] + sp[27] * PI8[0][7][8] + sp[31] * PI3[0][8][7] + sp[32] * PI6[0][8][7] + sp[27] * PI8[0][8][7] + sp[30] * PI9[0][7][8];
    A[114] = sp[33] * PI0[0][7][9] + sp[34] * PI1[0][7][9] + sp[28] * PI2[0][7][9] + sp[31] * PI3[0][7][9] + sp[34] * PI1[0][9][7] + sp[35] * PI4[0][7][9] + sp[29] * PI5[0][7][9] + sp[32] * PI6[0][7][9] + sp[28] * PI2[0][9][7] + sp[29] * PI5[0][9][7] + sp[26] * PI7[0][7][9] + sp[27] * PI8[0][7][9] + sp[31] * PI3[0][9][7] + sp[32] * PI6[0][9][7] + sp[27] * PI8[0][9][7] + sp[30] * PI9[0][7][9];
    A[115] = sp[33] * PI0[0][7][10] + sp[34] * PI1[0][7][10] + sp[28] * PI2[0][7][10] + sp[31] * PI3[0][7][10] + sp[34] * PI1[0][10][7] + sp[35] * PI4[0][7][10] + sp[29] * PI5[0][7][10] + sp[32] * PI6[0][7][10] + sp[28] * PI2[0][10][7] + sp[29] * PI5[0][10][7] + sp[26] * PI7[0][7][10] + sp[27] * PI8[0][7][10] + sp[31] * PI3[0][10][7] + sp[32] * PI6[0][10][7] + sp[27] * PI8[0][10][7] + sp[30] * PI9[0][7][10];
    A[116] = sp[33] * PI0[0][7][11] + sp[34] * PI1[0][7][11] + sp[28] * PI2[0][7][11] + sp[31] * PI3[0][7][11] + sp[34] * PI1[0][11][7] + sp[35] * PI4[0][7][11] + sp[29] * PI5[0][7][11] + sp[32] * PI6[0][7][11] + sp[28] * PI2[0][11][7] + sp[29] * PI5[0][11][7] + sp[26] * PI7[0][7][11] + sp[27] * PI8[0][7][11] + sp[31] * PI3[0][11][7] + sp[32] * PI6[0][11][7] + sp[27] * PI8[0][11][7] + sp[30] * PI9[0][7][11];
    A[117] = sp[33] * PI0[0][7][12] + sp[34] * PI1[0][7][12] + sp[28] * PI2[0][7][12] + sp[31] * PI3[0][7][12] + sp[34] * PI1[0][12][7] + sp[35] * PI4[0][7][12] + sp[29] * PI5[0][7][12] + sp[32] * PI6[0][7][12] + sp[28] * PI2[0][12][7] + sp[29] * PI5[0][12][7] + sp[26] * PI7[0][7][12] + sp[27] * PI8[0][7][12] + sp[31] * PI3[0][12][7] + sp[32] * PI6[0][12][7] + sp[27] * PI8[0][12][7] + sp[30] * PI9[0][7][12];
    A[118] = sp[33] * PI0[0][7][13] + sp[34] * PI1[0][7][13] + sp[28] * PI2[0][7][13] + sp[31] * PI3[0][7][13] + sp[34] * PI1[0][13][7] + sp[35] * PI4[0][7][13] + sp[29] * PI5[0][7][13] + sp[32] * PI6[0][7][13] + sp[28] * PI2[0][13][7] + sp[29] * PI5[0][13][7] + sp[26] * PI7[0][7][13] + sp[27] * PI8[0][7][13] + sp[31] * PI3[0][13][7] + sp[32] * PI6[0][13][7] + sp[27] * PI8[0][13][7] + sp[30] * PI9[0][7][13];
    A[119] = sp[33] * PI0[0][7][14] + sp[34] * PI1[0][7][14] + sp[28] * PI2[0][7][14] + sp[31] * PI3[0][7][14] + sp[34] * PI1[0][14][7] + sp[35] * PI4[0][7][14] + sp[29] * PI5[0][7][14] + sp[32] * PI6[0][7][14] + sp[28] * PI2[0][14][7] + sp[29] * PI5[0][14][7] + sp[26] * PI7[0][7][14] + sp[27] * PI8[0][7][14] + sp[31] * PI3[0][14][7] + sp[32] * PI6[0][14][7] + sp[27] * PI8[0][14][7] + sp[30] * PI9[0][7][14];
    A[120] = sp[33] * PI0[0][8][0] + sp[34] * PI1[0][8][0] + sp[28] * PI2[0][8][0] + sp[31] * PI3[0][8][0] + sp[34] * PI1[0][0][8] + sp[35] * PI4[0][8][0] + sp[29] * PI5[0][8][0] + sp[32] * PI6[0][8][0] + sp[28] * PI2[0][0][8] + sp[29] * PI5[0][0][8] + sp[26] * PI7[0][8][0] + sp[27] * PI8[0][8][0] + sp[31] * PI3[0][0][8] + sp[32] * PI6[0][0][8] + sp[27] * PI8[0][0][8] + sp[30] * PI9[0][8][0];
    A[121] = sp[33] * PI0[0][8][1] + sp[34] * PI1[0][8][1] + sp[28] * PI2[0][8][1] + sp[31] * PI3[0][8][1] + sp[34] * PI1[0][1][8] + sp[35] * PI4[0][8][1] + sp[29] * PI5[0][8][1] + sp[32] * PI6[0][8][1] + sp[28] * PI2[0][1][8] + sp[29] * PI5[0][1][8] + sp[26] * PI7[0][8][1] + sp[27] * PI8[0][8][1] + sp[31] * PI3[0][1][8] + sp[32] * PI6[0][1][8] + sp[27] * PI8[0][1][8] + sp[30] * PI9[0][8][1];
    A[122] = sp[33] * PI0[0][8][2] + sp[34] * PI1[0][8][2] + sp[28] * PI2[0][8][2] + sp[31] * PI3[0][8][2] + sp[34] * PI1[0][2][8] + sp[35] * PI4[0][8][2] + sp[29] * PI5[0][8][2] + sp[32] * PI6[0][8][2] + sp[28] * PI2[0][2][8] + sp[29] * PI5[0][2][8] + sp[26] * PI7[0][8][2] + sp[27] * PI8[0][8][2] + sp[31] * PI3[0][2][8] + sp[32] * PI6[0][2][8] + sp[27] * PI8[0][2][8] + sp[30] * PI9[0][8][2];
    A[123] = sp[33] * PI0[0][8][3] + sp[34] * PI1[0][8][3] + sp[28] * PI2[0][8][3] + sp[31] * PI3[0][8][3] + sp[34] * PI1[0][3][8] + sp[35] * PI4[0][8][3] + sp[29] * PI5[0][8][3] + sp[32] * PI6[0][8][3] + sp[28] * PI2[0][3][8] + sp[29] * PI5[0][3][8] + sp[26] * PI7[0][8][3] + sp[27] * PI8[0][8][3] + sp[31] * PI3[0][3][8] + sp[32] * PI6[0][3][8] + sp[27] * PI8[0][3][8] + sp[30] * PI9[0][8][3];
    A[124] = sp[33] * PI0[0][8][4] + sp[34] * PI1[0][8][4] + sp[28] * PI2[0][8][4] + sp[31] * PI3[0][8][4] + sp[34] * PI1[0][4][8] + sp[35] * PI4[0][8][4] + sp[29] * PI5[0][8][4] + sp[32] * PI6[0][8][4] + sp[28] * PI2[0][4][8] + sp[29] * PI5[0][4][8] + sp[26] * PI7[0][8][4] + sp[27] * PI8[0][8][4] + sp[31] * PI3[0][4][8] + sp[32] * PI6[0][4][8] + sp[27] * PI8[0][4][8] + sp[30] * PI9[0][8][4];
    A[125] = sp[33] * PI0[0][8][5] + sp[34] * PI1[0][8][5] + sp[28] * PI2[0][8][5] + sp[31] * PI3[0][8][5] + sp[34] * PI1[0][5][8] + sp[35] * PI4[0][8][5] + sp[29] * PI5[0][8][5] + sp[32] * PI6[0][8][5] + sp[28] * PI2[0][5][8] + sp[29] * PI5[0][5][8] + sp[26] * PI7[0][8][5] + sp[27] * PI8[0][8][5] + sp[31] * PI3[0][5][8] + sp[32] * PI6[0][5][8] + sp[27] * PI8[0][5][8] + sp[30] * PI9[0][8][5];
    A[126] = sp[33] * PI0[0][8][6] + sp[34] * PI1[0][8][6] + sp[28] * PI2[0][8][6] + sp[31] * PI3[0][8][6] + sp[34] * PI1[0][6][8] + sp[35] * PI4[0][8][6] + sp[29] * PI5[0][8][6] + sp[32] * PI6[0][8][6] + sp[28] * PI2[0][6][8] + sp[29] * PI5[0][6][8] + sp[26] * PI7[0][8][6] + sp[27] * PI8[0][8][6] + sp[31] * PI3[0][6][8] + sp[32] * PI6[0][6][8] + sp[27] * PI8[0][6][8] + sp[30] * PI9[0][8][6];
    A[127] = sp[33] * PI0[0][8][7] + sp[34] * PI1[0][8][7] + sp[28] * PI2[0][8][7] + sp[31] * PI3[0][8][7] + sp[34] * PI1[0][7][8] + sp[35] * PI4[0][8][7] + sp[29] * PI5[0][8][7] + sp[32] * PI6[0][8][7] + sp[28] * PI2[0][7][8] + sp[29] * PI5[0][7][8] + sp[26] * PI7[0][8][7] + sp[27] * PI8[0][8][7] + sp[31] * PI3[0][7][8] + sp[32] * PI6[0][7][8] + sp[27] * PI8[0][7][8] + sp[30] * PI9[0][8][7];
    A[128] = sp[33] * PI0[0][8][8] + sp[34] * PI1[0][8][8] + sp[28] * PI2[0][8][8] + sp[31] * PI3[0][8][8] + sp[34] * PI1[0][8][8] + sp[35] * PI4[0][8][8] + sp[29] * PI5[0][8][8] + sp[32] * PI6[0][8][8] + sp[28] * PI2[0][8][8] + sp[29] * PI5[0][8][8] + sp[26] * PI7[0][8][8] + sp[27] * PI8[0][8][8] + sp[31] * PI3[0][8][8] + sp[32] * PI6[0][8][8] + sp[27] * PI8[0][8][8] + sp[30] * PI9[0][8][8];
    A[129] = sp[33] * PI0[0][8][9] + sp[34] * PI1[0][8][9] + sp[28] * PI2[0][8][9] + sp[31] * PI3[0][8][9] + sp[34] * PI1[0][9][8] + sp[35] * PI4[0][8][9] + sp[29] * PI5[0][8][9] + sp[32] * PI6[0][8][9] + sp[28] * PI2[0][9][8] + sp[29] * PI5[0][9][8] + sp[26] * PI7[0][8][9] + sp[27] * PI8[0][8][9] + sp[31] * PI3[0][9][8] + sp[32] * PI6[0][9][8] + sp[27] * PI8[0][9][8] + sp[30] * PI9[0][8][9];
    A[130] = sp[33] * PI0[0][8][10] + sp[34] * PI1[0][8][10] + sp[28] * PI2[0][8][10] + sp[31] * PI3[0][8][10] + sp[34] * PI1[0][10][8] + sp[35] * PI4[0][8][10] + sp[29] * PI5[0][8][10] + sp[32] * PI6[0][8][10] + sp[28] * PI2[0][10][8] + sp[29] * PI5[0][10][8] + sp[26] * PI7[0][8][10] + sp[27] * PI8[0][8][10] + sp[31] * PI3[0][10][8] + sp[32] * PI6[0][10][8] + sp[27] * PI8[0][10][8] + sp[30] * PI9[0][8][10];
    A[131] = sp[33] * PI0[0][8][11] + sp[34] * PI1[0][8][11] + sp[28] * PI2[0][8][11] + sp[31] * PI3[0][8][11] + sp[34] * PI1[0][11][8] + sp[35] * PI4[0][8][11] + sp[29] * PI5[0][8][11] + sp[32] * PI6[0][8][11] + sp[28] * PI2[0][11][8] + sp[29] * PI5[0][11][8] + sp[26] * PI7[0][8][11] + sp[27] * PI8[0][8][11] + sp[31] * PI3[0][11][8] + sp[32] * PI6[0][11][8] + sp[27] * PI8[0][11][8] + sp[30] * PI9[0][8][11];
    A[132] = sp[33] * PI0[0][8][12] + sp[34] * PI1[0][8][12] + sp[28] * PI2[0][8][12] + sp[31] * PI3[0][8][12] + sp[34] * PI1[0][12][8] + sp[35] * PI4[0][8][12] + sp[29] * PI5[0][8][12] + sp[32] * PI6[0][8][12] + sp[28] * PI2[0][12][8] + sp[29] * PI5[0][12][8] + sp[26] * PI7[0][8][12] + sp[27] * PI8[0][8][12] + sp[31] * PI3[0][12][8] + sp[32] * PI6[0][12][8] + sp[27] * PI8[0][12][8] + sp[30] * PI9[0][8][12];
    A[133] = sp[33] * PI0[0][8][13] + sp[34] * PI1[0][8][13] + sp[28] * PI2[0][8][13] + sp[31] * PI3[0][8][13] + sp[34] * PI1[0][13][8] + sp[35] * PI4[0][8][13] + sp[29] * PI5[0][8][13] + sp[32] * PI6[0][8][13] + sp[28] * PI2[0][13][8] + sp[29] * PI5[0][13][8] + sp[26] * PI7[0][8][13] + sp[27] * PI8[0][8][13] + sp[31] * PI3[0][13][8] + sp[32] * PI6[0][13][8] + sp[27] * PI8[0][13][8] + sp[30] * PI9[0][8][13];
    A[134] = sp[33] * PI0[0][8][14] + sp[34] * PI1[0][8][14] + sp[28] * PI2[0][8][14] + sp[31] * PI3[0][8][14] + sp[34] * PI1[0][14][8] + sp[35] * PI4[0][8][14] + sp[29] * PI5[0][8][14] + sp[32] * PI6[0][8][14] + sp[28] * PI2[0][14][8] + sp[29] * PI5[0][14][8] + sp[26] * PI7[0][8][14] + sp[27] * PI8[0][8][14] + sp[31] * PI3[0][14][8] + sp[32] * PI6[0][14][8] + sp[27] * PI8[0][14][8] + sp[30] * PI9[0][8][14];
    A[135] = sp[33] * PI0[0][9][0] + sp[34] * PI1[0][9][0] + sp[28] * PI2[0][9][0] + sp[31] * PI3[0][9][0] + sp[34] * PI1[0][0][9] + sp[35] * PI4[0][9][0] + sp[29] * PI5[0][9][0] + sp[32] * PI6[0][9][0] + sp[28] * PI2[0][0][9] + sp[29] * PI5[0][0][9] + sp[26] * PI7[0][9][0] + sp[27] * PI8[0][9][0] + sp[31] * PI3[0][0][9] + sp[32] * PI6[0][0][9] + sp[27] * PI8[0][0][9] + sp[30] * PI9[0][9][0];
    A[136] = sp[33] * PI0[0][9][1] + sp[34] * PI1[0][9][1] + sp[28] * PI2[0][9][1] + sp[31] * PI3[0][9][1] + sp[34] * PI1[0][1][9] + sp[35] * PI4[0][9][1] + sp[29] * PI5[0][9][1] + sp[32] * PI6[0][9][1] + sp[28] * PI2[0][1][9] + sp[29] * PI5[0][1][9] + sp[26] * PI7[0][9][1] + sp[27] * PI8[0][9][1] + sp[31] * PI3[0][1][9] + sp[32] * PI6[0][1][9] + sp[27] * PI8[0][1][9] + sp[30] * PI9[0][9][1];
    A[137] = sp[33] * PI0[0][9][2] + sp[34] * PI1[0][9][2] + sp[28] * PI2[0][9][2] + sp[31] * PI3[0][9][2] + sp[34] * PI1[0][2][9] + sp[35] * PI4[0][9][2] + sp[29] * PI5[0][9][2] + sp[32] * PI6[0][9][2] + sp[28] * PI2[0][2][9] + sp[29] * PI5[0][2][9] + sp[26] * PI7[0][9][2] + sp[27] * PI8[0][9][2] + sp[31] * PI3[0][2][9] + sp[32] * PI6[0][2][9] + sp[27] * PI8[0][2][9] + sp[30] * PI9[0][9][2];
    A[138] = sp[33] * PI0[0][9][3] + sp[34] * PI1[0][9][3] + sp[28] * PI2[0][9][3] + sp[31] * PI3[0][9][3] + sp[34] * PI1[0][3][9] + sp[35] * PI4[0][9][3] + sp[29] * PI5[0][9][3] + sp[32] * PI6[0][9][3] + sp[28] * PI2[0][3][9] + sp[29] * PI5[0][3][9] + sp[26] * PI7[0][9][3] + sp[27] * PI8[0][9][3] + sp[31] * PI3[0][3][9] + sp[32] * PI6[0][3][9] + sp[27] * PI8[0][3][9] + sp[30] * PI9[0][9][3];
    A[139] = sp[33] * PI0[0][9][4] + sp[34] * PI1[0][9][4] + sp[28] * PI2[0][9][4] + sp[31] * PI3[0][9][4] + sp[34] * PI1[0][4][9] + sp[35] * PI4[0][9][4] + sp[29] * PI5[0][9][4] + sp[32] * PI6[0][9][4] + sp[28] * PI2[0][4][9] + sp[29] * PI5[0][4][9] + sp[26] * PI7[0][9][4] + sp[27] * PI8[0][9][4] + sp[31] * PI3[0][4][9] + sp[32] * PI6[0][4][9] + sp[27] * PI8[0][4][9] + sp[30] * PI9[0][9][4];
    A[140] = sp[33] * PI0[0][9][5] + sp[34] * PI1[0][9][5] + sp[28] * PI2[0][9][5] + sp[31] * PI3[0][9][5] + sp[34] * PI1[0][5][9] + sp[35] * PI4[0][9][5] + sp[29] * PI5[0][9][5] + sp[32] * PI6[0][9][5] + sp[28] * PI2[0][5][9] + sp[29] * PI5[0][5][9] + sp[26] * PI7[0][9][5] + sp[27] * PI8[0][9][5] + sp[31] * PI3[0][5][9] + sp[32] * PI6[0][5][9] + sp[27] * PI8[0][5][9] + sp[30] * PI9[0][9][5];
    A[141] = sp[33] * PI0[0][9][6] + sp[34] * PI1[0][9][6] + sp[28] * PI2[0][9][6] + sp[31] * PI3[0][9][6] + sp[34] * PI1[0][6][9] + sp[35] * PI4[0][9][6] + sp[29] * PI5[0][9][6] + sp[32] * PI6[0][9][6] + sp[28] * PI2[0][6][9] + sp[29] * PI5[0][6][9] + sp[26] * PI7[0][9][6] + sp[27] * PI8[0][9][6] + sp[31] * PI3[0][6][9] + sp[32] * PI6[0][6][9] + sp[27] * PI8[0][6][9] + sp[30] * PI9[0][9][6];
    A[142] = sp[33] * PI0[0][9][7] + sp[34] * PI1[0][9][7] + sp[28] * PI2[0][9][7] + sp[31] * PI3[0][9][7] + sp[34] * PI1[0][7][9] + sp[35] * PI4[0][9][7] + sp[29] * PI5[0][9][7] + sp[32] * PI6[0][9][7] + sp[28] * PI2[0][7][9] + sp[29] * PI5[0][7][9] + sp[26] * PI7[0][9][7] + sp[27] * PI8[0][9][7] + sp[31] * PI3[0][7][9] + sp[32] * PI6[0][7][9] + sp[27] * PI8[0][7][9] + sp[30] * PI9[0][9][7];
    A[143] = sp[33] * PI0[0][9][8] + sp[34] * PI1[0][9][8] + sp[28] * PI2[0][9][8] + sp[31] * PI3[0][9][8] + sp[34] * PI1[0][8][9] + sp[35] * PI4[0][9][8] + sp[29] * PI5[0][9][8] + sp[32] * PI6[0][9][8] + sp[28] * PI2[0][8][9] + sp[29] * PI5[0][8][9] + sp[26] * PI7[0][9][8] + sp[27] * PI8[0][9][8] + sp[31] * PI3[0][8][9] + sp[32] * PI6[0][8][9] + sp[27] * PI8[0][8][9] + sp[30] * PI9[0][9][8];
    A[144] = sp[33] * PI0[0][9][9] + sp[34] * PI1[0][9][9] + sp[28] * PI2[0][9][9] + sp[31] * PI3[0][9][9] + sp[34] * PI1[0][9][9] + sp[35] * PI4[0][9][9] + sp[29] * PI5[0][9][9] + sp[32] * PI6[0][9][9] + sp[28] * PI2[0][9][9] + sp[29] * PI5[0][9][9] + sp[26] * PI7[0][9][9] + sp[27] * PI8[0][9][9] + sp[31] * PI3[0][9][9] + sp[32] * PI6[0][9][9] + sp[27] * PI8[0][9][9] + sp[30] * PI9[0][9][9];
    A[145] = sp[33] * PI0[0][9][10] + sp[34] * PI1[0][9][10] + sp[28] * PI2[0][9][10] + sp[31] * PI3[0][9][10] + sp[34] * PI1[0][10][9] + sp[35] * PI4[0][9][10] + sp[29] * PI5[0][9][10] + sp[32] * PI6[0][9][10] + sp[28] * PI2[0][10][9] + sp[29] * PI5[0][10][9] + sp[26] * PI7[0][9][10] + sp[27] * PI8[0][9][10] + sp[31] * PI3[0][10][9] + sp[32] * PI6[0][10][9] + sp[27] * PI8[0][10][9] + sp[30] * PI9[0][9][10];
    A[146] = sp[33] * PI0[0][9][11] + sp[34] * PI1[0][9][11] + sp[28] * PI2[0][9][11] + sp[31] * PI3[0][9][11] + sp[34] * PI1[0][11][9] + sp[35] * PI4[0][9][11] + sp[29] * PI5[0][9][11] + sp[32] * PI6[0][9][11] + sp[28] * PI2[0][11][9] + sp[29] * PI5[0][11][9] + sp[26] * PI7[0][9][11] + sp[27] * PI8[0][9][11] + sp[31] * PI3[0][11][9] + sp[32] * PI6[0][11][9] + sp[27] * PI8[0][11][9] + sp[30] * PI9[0][9][11];
    A[147] = sp[33] * PI0[0][9][12] + sp[34] * PI1[0][9][12] + sp[28] * PI2[0][9][12] + sp[31] * PI3[0][9][12] + sp[34] * PI1[0][12][9] + sp[35] * PI4[0][9][12] + sp[29] * PI5[0][9][12] + sp[32] * PI6[0][9][12] + sp[28] * PI2[0][12][9] + sp[29] * PI5[0][12][9] + sp[26] * PI7[0][9][12] + sp[27] * PI8[0][9][12] + sp[31] * PI3[0][12][9] + sp[32] * PI6[0][12][9] + sp[27] * PI8[0][12][9] + sp[30] * PI9[0][9][12];
    A[148] = sp[33] * PI0[0][9][13] + sp[34] * PI1[0][9][13] + sp[28] * PI2[0][9][13] + sp[31] * PI3[0][9][13] + sp[34] * PI1[0][13][9] + sp[35] * PI4[0][9][13] + sp[29] * PI5[0][9][13] + sp[32] * PI6[0][9][13] + sp[28] * PI2[0][13][9] + sp[29] * PI5[0][13][9] + sp[26] * PI7[0][9][13] + sp[27] * PI8[0][9][13] + sp[31] * PI3[0][13][9] + sp[32] * PI6[0][13][9] + sp[27] * PI8[0][13][9] + sp[30] * PI9[0][9][13];
    A[149] = sp[33] * PI0[0][9][14] + sp[34] * PI1[0][9][14] + sp[28] * PI2[0][9][14] + sp[31] * PI3[0][9][14] + sp[34] * PI1[0][14][9] + sp[35] * PI4[0][9][14] + sp[29] * PI5[0][9][14] + sp[32] * PI6[0][9][14] + sp[28] * PI2[0][14][9] + sp[29] * PI5[0][14][9] + sp[26] * PI7[0][9][14] + sp[27] * PI8[0][9][14] + sp[31] * PI3[0][14][9] + sp[32] * PI6[0][14][9] + sp[27] * PI8[0][14][9] + sp[30] * PI9[0][9][14];
    A[150] = sp[33] * PI0[0][10][0] + sp[34] * PI1[0][10][0] + sp[28] * PI2[0][10][0] + sp[31] * PI3[0][10][0] + sp[34] * PI1[0][0][10] + sp[35] * PI4[0][10][0] + sp[29] * PI5[0][10][0] + sp[32] * PI6[0][10][0] + sp[28] * PI2[0][0][10] + sp[29] * PI5[0][0][10] + sp[26] * PI7[0][10][0] + sp[27] * PI8[0][10][0] + sp[31] * PI3[0][0][10] + sp[32] * PI6[0][0][10] + sp[27] * PI8[0][0][10] + sp[30] * PI9[0][10][0];
    A[151] = sp[33] * PI0[0][10][1] + sp[34] * PI1[0][10][1] + sp[28] * PI2[0][10][1] + sp[31] * PI3[0][10][1] + sp[34] * PI1[0][1][10] + sp[35] * PI4[0][10][1] + sp[29] * PI5[0][10][1] + sp[32] * PI6[0][10][1] + sp[28] * PI2[0][1][10] + sp[29] * PI5[0][1][10] + sp[26] * PI7[0][10][1] + sp[27] * PI8[0][10][1] + sp[31] * PI3[0][1][10] + sp[32] * PI6[0][1][10] + sp[27] * PI8[0][1][10] + sp[30] * PI9[0][10][1];
    A[152] = sp[33] * PI0[0][10][2] + sp[34] * PI1[0][10][2] + sp[28] * PI2[0][10][2] + sp[31] * PI3[0][10][2] + sp[34] * PI1[0][2][10] + sp[35] * PI4[0][10][2] + sp[29] * PI5[0][10][2] + sp[32] * PI6[0][10][2] + sp[28] * PI2[0][2][10] + sp[29] * PI5[0][2][10] + sp[26] * PI7[0][10][2] + sp[27] * PI8[0][10][2] + sp[31] * PI3[0][2][10] + sp[32] * PI6[0][2][10] + sp[27] * PI8[0][2][10] + sp[30] * PI9[0][10][2];
    A[153] = sp[33] * PI0[0][10][3] + sp[34] * PI1[0][10][3] + sp[28] * PI2[0][10][3] + sp[31] * PI3[0][10][3] + sp[34] * PI1[0][3][10] + sp[35] * PI4[0][10][3] + sp[29] * PI5[0][10][3] + sp[32] * PI6[0][10][3] + sp[28] * PI2[0][3][10] + sp[29] * PI5[0][3][10] + sp[26] * PI7[0][10][3] + sp[27] * PI8[0][10][3] + sp[31] * PI3[0][3][10] + sp[32] * PI6[0][3][10] + sp[27] * PI8[0][3][10] + sp[30] * PI9[0][10][3];
    A[154] = sp[33] * PI0[0][10][4] + sp[34] * PI1[0][10][4] + sp[28] * PI2[0][10][4] + sp[31] * PI3[0][10][4] + sp[34] * PI1[0][4][10] + sp[35] * PI4[0][10][4] + sp[29] * PI5[0][10][4] + sp[32] * PI6[0][10][4] + sp[28] * PI2[0][4][10] + sp[29] * PI5[0][4][10] + sp[26] * PI7[0][10][4] + sp[27] * PI8[0][10][4] + sp[31] * PI3[0][4][10] + sp[32] * PI6[0][4][10] + sp[27] * PI8[0][4][10] + sp[30] * PI9[0][10][4];
    A[155] = sp[33] * PI0[0][10][5] + sp[34] * PI1[0][10][5] + sp[28] * PI2[0][10][5] + sp[31] * PI3[0][10][5] + sp[34] * PI1[0][5][10] + sp[35] * PI4[0][10][5] + sp[29] * PI5[0][10][5] + sp[32] * PI6[0][10][5] + sp[28] * PI2[0][5][10] + sp[29] * PI5[0][5][10] + sp[26] * PI7[0][10][5] + sp[27] * PI8[0][10][5] + sp[31] * PI3[0][5][10] + sp[32] * PI6[0][5][10] + sp[27] * PI8[0][5][10] + sp[30] * PI9[0][10][5];
    A[156] = sp[33] * PI0[0][10][6] + sp[34] * PI1[0][10][6] + sp[28] * PI2[0][10][6] + sp[31] * PI3[0][10][6] + sp[34] * PI1[0][6][10] + sp[35] * PI4[0][10][6] + sp[29] * PI5[0][10][6] + sp[32] * PI6[0][10][6] + sp[28] * PI2[0][6][10] + sp[29] * PI5[0][6][10] + sp[26] * PI7[0][10][6] + sp[27] * PI8[0][10][6] + sp[31] * PI3[0][6][10] + sp[32] * PI6[0][6][10] + sp[27] * PI8[0][6][10] + sp[30] * PI9[0][10][6];
    A[157] = sp[33] * PI0[0][10][7] + sp[34] * PI1[0][10][7] + sp[28] * PI2[0][10][7] + sp[31] * PI3[0][10][7] + sp[34] * PI1[0][7][10] + sp[35] * PI4[0][10][7] + sp[29] * PI5[0][10][7] + sp[32] * PI6[0][10][7] + sp[28] * PI2[0][7][10] + sp[29] * PI5[0][7][10] + sp[26] * PI7[0][10][7] + sp[27] * PI8[0][10][7] + sp[31] * PI3[0][7][10] + sp[32] * PI6[0][7][10] + sp[27] * PI8[0][7][10] + sp[30] * PI9[0][10][7];
    A[158] = sp[33] * PI0[0][10][8] + sp[34] * PI1[0][10][8] + sp[28] * PI2[0][10][8] + sp[31] * PI3[0][10][8] + sp[34] * PI1[0][8][10] + sp[35] * PI4[0][10][8] + sp[29] * PI5[0][10][8] + sp[32] * PI6[0][10][8] + sp[28] * PI2[0][8][10] + sp[29] * PI5[0][8][10] + sp[26] * PI7[0][10][8] + sp[27] * PI8[0][10][8] + sp[31] * PI3[0][8][10] + sp[32] * PI6[0][8][10] + sp[27] * PI8[0][8][10] + sp[30] * PI9[0][10][8];
    A[159] = sp[33] * PI0[0][10][9] + sp[34] * PI1[0][10][9] + sp[28] * PI2[0][10][9] + sp[31] * PI3[0][10][9] + sp[34] * PI1[0][9][10] + sp[35] * PI4[0][10][9] + sp[29] * PI5[0][10][9] + sp[32] * PI6[0][10][9] + sp[28] * PI2[0][9][10] + sp[29] * PI5[0][9][10] + sp[26] * PI7[0][10][9] + sp[27] * PI8[0][10][9] + sp[31] * PI3[0][9][10] + sp[32] * PI6[0][9][10] + sp[27] * PI8[0][9][10] + sp[30] * PI9[0][10][9];
    A[160] = sp[33] * PI0[0][10][10] + sp[34] * PI1[0][10][10] + sp[28] * PI2[0][10][10] + sp[31] * PI3[0][10][10] + sp[34] * PI1[0][10][10] + sp[35] * PI4[0][10][10] + sp[29] * PI5[0][10][10] + sp[32] * PI6[0][10][10] + sp[28] * PI2[0][10][10] + sp[29] * PI5[0][10][10] + sp[26] * PI7[0][10][10] + sp[27] * PI8[0][10][10] + sp[31] * PI3[0][10][10] + sp[32] * PI6[0][10][10] + sp[27] * PI8[0][10][10] + sp[30] * PI9[0][10][10];
    A[161] = sp[33] * PI0[0][10][11] + sp[34] * PI1[0][10][11] + sp[28] * PI2[0][10][11] + sp[31] * PI3[0][10][11] + sp[34] * PI1[0][11][10] + sp[35] * PI4[0][10][11] + sp[29] * PI5[0][10][11] + sp[32] * PI6[0][10][11] + sp[28] * PI2[0][11][10] + sp[29] * PI5[0][11][10] + sp[26] * PI7[0][10][11] + sp[27] * PI8[0][10][11] + sp[31] * PI3[0][11][10] + sp[32] * PI6[0][11][10] + sp[27] * PI8[0][11][10] + sp[30] * PI9[0][10][11];
    A[162] = sp[33] * PI0[0][10][12] + sp[34] * PI1[0][10][12] + sp[28] * PI2[0][10][12] + sp[31] * PI3[0][10][12] + sp[34] * PI1[0][12][10] + sp[35] * PI4[0][10][12] + sp[29] * PI5[0][10][12] + sp[32] * PI6[0][10][12] + sp[28] * PI2[0][12][10] + sp[29] * PI5[0][12][10] + sp[26] * PI7[0][10][12] + sp[27] * PI8[0][10][12] + sp[31] * PI3[0][12][10] + sp[32] * PI6[0][12][10] + sp[27] * PI8[0][12][10] + sp[30] * PI9[0][10][12];
    A[163] = sp[33] * PI0[0][10][13] + sp[34] * PI1[0][10][13] + sp[28] * PI2[0][10][13] + sp[31] * PI3[0][10][13] + sp[34] * PI1[0][13][10] + sp[35] * PI4[0][10][13] + sp[29] * PI5[0][10][13] + sp[32] * PI6[0][10][13] + sp[28] * PI2[0][13][10] + sp[29] * PI5[0][13][10] + sp[26] * PI7[0][10][13] + sp[27] * PI8[0][10][13] + sp[31] * PI3[0][13][10] + sp[32] * PI6[0][13][10] + sp[27] * PI8[0][13][10] + sp[30] * PI9[0][10][13];
    A[164] = sp[33] * PI0[0][10][14] + sp[34] * PI1[0][10][14] + sp[28] * PI2[0][10][14] + sp[31] * PI3[0][10][14] + sp[34] * PI1[0][14][10] + sp[35] * PI4[0][10][14] + sp[29] * PI5[0][10][14] + sp[32] * PI6[0][10][14] + sp[28] * PI2[0][14][10] + sp[29] * PI5[0][14][10] + sp[26] * PI7[0][10][14] + sp[27] * PI8[0][10][14] + sp[31] * PI3[0][14][10] + sp[32] * PI6[0][14][10] + sp[27] * PI8[0][14][10] + sp[30] * PI9[0][10][14];
    A[165] = sp[33] * PI0[0][11][0] + sp[34] * PI1[0][11][0] + sp[28] * PI2[0][11][0] + sp[31] * PI3[0][11][0] + sp[34] * PI1[0][0][11] + sp[35] * PI4[0][11][0] + sp[29] * PI5[0][11][0] + sp[32] * PI6[0][11][0] + sp[28] * PI2[0][0][11] + sp[29] * PI5[0][0][11] + sp[26] * PI7[0][11][0] + sp[27] * PI8[0][11][0] + sp[31] * PI3[0][0][11] + sp[32] * PI6[0][0][11] + sp[27] * PI8[0][0][11] + sp[30] * PI9[0][11][0];
    A[166] = sp[33] * PI0[0][11][1] + sp[34] * PI1[0][11][1] + sp[28] * PI2[0][11][1] + sp[31] * PI3[0][11][1] + sp[34] * PI1[0][1][11] + sp[35] * PI4[0][11][1] + sp[29] * PI5[0][11][1] + sp[32] * PI6[0][11][1] + sp[28] * PI2[0][1][11] + sp[29] * PI5[0][1][11] + sp[26] * PI7[0][11][1] + sp[27] * PI8[0][11][1] + sp[31] * PI3[0][1][11] + sp[32] * PI6[0][1][11] + sp[27] * PI8[0][1][11] + sp[30] * PI9[0][11][1];
    A[167] = sp[33] * PI0[0][11][2] + sp[34] * PI1[0][11][2] + sp[28] * PI2[0][11][2] + sp[31] * PI3[0][11][2] + sp[34] * PI1[0][2][11] + sp[35] * PI4[0][11][2] + sp[29] * PI5[0][11][2] + sp[32] * PI6[0][11][2] + sp[28] * PI2[0][2][11] + sp[29] * PI5[0][2][11] + sp[26] * PI7[0][11][2] + sp[27] * PI8[0][11][2] + sp[31] * PI3[0][2][11] + sp[32] * PI6[0][2][11] + sp[27] * PI8[0][2][11] + sp[30] * PI9[0][11][2];
    A[168] = sp[33] * PI0[0][11][3] + sp[34] * PI1[0][11][3] + sp[28] * PI2[0][11][3] + sp[31] * PI3[0][11][3] + sp[34] * PI1[0][3][11] + sp[35] * PI4[0][11][3] + sp[29] * PI5[0][11][3] + sp[32] * PI6[0][11][3] + sp[28] * PI2[0][3][11] + sp[29] * PI5[0][3][11] + sp[26] * PI7[0][11][3] + sp[27] * PI8[0][11][3] + sp[31] * PI3[0][3][11] + sp[32] * PI6[0][3][11] + sp[27] * PI8[0][3][11] + sp[30] * PI9[0][11][3];
    A[169] = sp[33] * PI0[0][11][4] + sp[34] * PI1[0][11][4] + sp[28] * PI2[0][11][4] + sp[31] * PI3[0][11][4] + sp[34] * PI1[0][4][11] + sp[35] * PI4[0][11][4] + sp[29] * PI5[0][11][4] + sp[32] * PI6[0][11][4] + sp[28] * PI2[0][4][11] + sp[29] * PI5[0][4][11] + sp[26] * PI7[0][11][4] + sp[27] * PI8[0][11][4] + sp[31] * PI3[0][4][11] + sp[32] * PI6[0][4][11] + sp[27] * PI8[0][4][11] + sp[30] * PI9[0][11][4];
    A[170] = sp[33] * PI0[0][11][5] + sp[34] * PI1[0][11][5] + sp[28] * PI2[0][11][5] + sp[31] * PI3[0][11][5] + sp[34] * PI1[0][5][11] + sp[35] * PI4[0][11][5] + sp[29] * PI5[0][11][5] + sp[32] * PI6[0][11][5] + sp[28] * PI2[0][5][11] + sp[29] * PI5[0][5][11] + sp[26] * PI7[0][11][5] + sp[27] * PI8[0][11][5] + sp[31] * PI3[0][5][11] + sp[32] * PI6[0][5][11] + sp[27] * PI8[0][5][11] + sp[30] * PI9[0][11][5];
    A[171] = sp[33] * PI0[0][11][6] + sp[34] * PI1[0][11][6] + sp[28] * PI2[0][11][6] + sp[31] * PI3[0][11][6] + sp[34] * PI1[0][6][11] + sp[35] * PI4[0][11][6] + sp[29] * PI5[0][11][6] + sp[32] * PI6[0][11][6] + sp[28] * PI2[0][6][11] + sp[29] * PI5[0][6][11] + sp[26] * PI7[0][11][6] + sp[27] * PI8[0][11][6] + sp[31] * PI3[0][6][11] + sp[32] * PI6[0][6][11] + sp[27] * PI8[0][6][11] + sp[30] * PI9[0][11][6];
    A[172] = sp[33] * PI0[0][11][7] + sp[34] * PI1[0][11][7] + sp[28] * PI2[0][11][7] + sp[31] * PI3[0][11][7] + sp[34] * PI1[0][7][11] + sp[35] * PI4[0][11][7] + sp[29] * PI5[0][11][7] + sp[32] * PI6[0][11][7] + sp[28] * PI2[0][7][11] + sp[29] * PI5[0][7][11] + sp[26] * PI7[0][11][7] + sp[27] * PI8[0][11][7] + sp[31] * PI3[0][7][11] + sp[32] * PI6[0][7][11] + sp[27] * PI8[0][7][11] + sp[30] * PI9[0][11][7];
    A[173] = sp[33] * PI0[0][11][8] + sp[34] * PI1[0][11][8] + sp[28] * PI2[0][11][8] + sp[31] * PI3[0][11][8] + sp[34] * PI1[0][8][11] + sp[35] * PI4[0][11][8] + sp[29] * PI5[0][11][8] + sp[32] * PI6[0][11][8] + sp[28] * PI2[0][8][11] + sp[29] * PI5[0][8][11] + sp[26] * PI7[0][11][8] + sp[27] * PI8[0][11][8] + sp[31] * PI3[0][8][11] + sp[32] * PI6[0][8][11] + sp[27] * PI8[0][8][11] + sp[30] * PI9[0][11][8];
    A[174] = sp[33] * PI0[0][11][9] + sp[34] * PI1[0][11][9] + sp[28] * PI2[0][11][9] + sp[31] * PI3[0][11][9] + sp[34] * PI1[0][9][11] + sp[35] * PI4[0][11][9] + sp[29] * PI5[0][11][9] + sp[32] * PI6[0][11][9] + sp[28] * PI2[0][9][11] + sp[29] * PI5[0][9][11] + sp[26] * PI7[0][11][9] + sp[27] * PI8[0][11][9] + sp[31] * PI3[0][9][11] + sp[32] * PI6[0][9][11] + sp[27] * PI8[0][9][11] + sp[30] * PI9[0][11][9];
    A[175] = sp[33] * PI0[0][11][10] + sp[34] * PI1[0][11][10] + sp[28] * PI2[0][11][10] + sp[31] * PI3[0][11][10] + sp[34] * PI1[0][10][11] + sp[35] * PI4[0][11][10] + sp[29] * PI5[0][11][10] + sp[32] * PI6[0][11][10] + sp[28] * PI2[0][10][11] + sp[29] * PI5[0][10][11] + sp[26] * PI7[0][11][10] + sp[27] * PI8[0][11][10] + sp[31] * PI3[0][10][11] + sp[32] * PI6[0][10][11] + sp[27] * PI8[0][10][11] + sp[30] * PI9[0][11][10];
    A[176] = sp[33] * PI0[0][11][11] + sp[34] * PI1[0][11][11] + sp[28] * PI2[0][11][11] + sp[31] * PI3[0][11][11] + sp[34] * PI1[0][11][11] + sp[35] * PI4[0][11][11] + sp[29] * PI5[0][11][11] + sp[32] * PI6[0][11][11] + sp[28] * PI2[0][11][11] + sp[29] * PI5[0][11][11] + sp[26] * PI7[0][11][11] + sp[27] * PI8[0][11][11] + sp[31] * PI3[0][11][11] + sp[32] * PI6[0][11][11] + sp[27] * PI8[0][11][11] + sp[30] * PI9[0][11][11];
    A[177] = sp[33] * PI0[0][11][12] + sp[34] * PI1[0][11][12] + sp[28] * PI2[0][11][12] + sp[31] * PI3[0][11][12] + sp[34] * PI1[0][12][11] + sp[35] * PI4[0][11][12] + sp[29] * PI5[0][11][12] + sp[32] * PI6[0][11][12] + sp[28] * PI2[0][12][11] + sp[29] * PI5[0][12][11] + sp[26] * PI7[0][11][12] + sp[27] * PI8[0][11][12] + sp[31] * PI3[0][12][11] + sp[32] * PI6[0][12][11] + sp[27] * PI8[0][12][11] + sp[30] * PI9[0][11][12];
    A[178] = sp[33] * PI0[0][11][13] + sp[34] * PI1[0][11][13] + sp[28] * PI2[0][11][13] + sp[31] * PI3[0][11][13] + sp[34] * PI1[0][13][11] + sp[35] * PI4[0][11][13] + sp[29] * PI5[0][11][13] + sp[32] * PI6[0][11][13] + sp[28] * PI2[0][13][11] + sp[29] * PI5[0][13][11] + sp[26] * PI7[0][11][13] + sp[27] * PI8[0][11][13] + sp[31] * PI3[0][13][11] + sp[32] * PI6[0][13][11] + sp[27] * PI8[0][13][11] + sp[30] * PI9[0][11][13];
    A[179] = sp[33] * PI0[0][11][14] + sp[34] * PI1[0][11][14] + sp[28] * PI2[0][11][14] + sp[31] * PI3[0][11][14] + sp[34] * PI1[0][14][11] + sp[35] * PI4[0][11][14] + sp[29] * PI5[0][11][14] + sp[32] * PI6[0][11][14] + sp[28] * PI2[0][14][11] + sp[29] * PI5[0][14][11] + sp[26] * PI7[0][11][14] + sp[27] * PI8[0][11][14] + sp[31] * PI3[0][14][11] + sp[32] * PI6[0][14][11] + sp[27] * PI8[0][14][11] + sp[30] * PI9[0][11][14];
    A[180] = sp[33] * PI0[0][12][0] + sp[34] * PI1[0][12][0] + sp[28] * PI2[0][12][0] + sp[31] * PI3[0][12][0] + sp[34] * PI1[0][0][12] + sp[35] * PI4[0][12][0] + sp[29] * PI5[0][12][0] + sp[32] * PI6[0][12][0] + sp[28] * PI2[0][0][12] + sp[29] * PI5[0][0][12] + sp[26] * PI7[0][12][0] + sp[27] * PI8[0][12][0] + sp[31] * PI3[0][0][12] + sp[32] * PI6[0][0][12] + sp[27] * PI8[0][0][12] + sp[30] * PI9[0][12][0];
    A[181] = sp[33] * PI0[0][12][1] + sp[34] * PI1[0][12][1] + sp[28] * PI2[0][12][1] + sp[31] * PI3[0][12][1] + sp[34] * PI1[0][1][12] + sp[35] * PI4[0][12][1] + sp[29] * PI5[0][12][1] + sp[32] * PI6[0][12][1] + sp[28] * PI2[0][1][12] + sp[29] * PI5[0][1][12] + sp[26] * PI7[0][12][1] + sp[27] * PI8[0][12][1] + sp[31] * PI3[0][1][12] + sp[32] * PI6[0][1][12] + sp[27] * PI8[0][1][12] + sp[30] * PI9[0][12][1];
    A[182] = sp[33] * PI0[0][12][2] + sp[34] * PI1[0][12][2] + sp[28] * PI2[0][12][2] + sp[31] * PI3[0][12][2] + sp[34] * PI1[0][2][12] + sp[35] * PI4[0][12][2] + sp[29] * PI5[0][12][2] + sp[32] * PI6[0][12][2] + sp[28] * PI2[0][2][12] + sp[29] * PI5[0][2][12] + sp[26] * PI7[0][12][2] + sp[27] * PI8[0][12][2] + sp[31] * PI3[0][2][12] + sp[32] * PI6[0][2][12] + sp[27] * PI8[0][2][12] + sp[30] * PI9[0][12][2];
    A[183] = sp[33] * PI0[0][12][3] + sp[34] * PI1[0][12][3] + sp[28] * PI2[0][12][3] + sp[31] * PI3[0][12][3] + sp[34] * PI1[0][3][12] + sp[35] * PI4[0][12][3] + sp[29] * PI5[0][12][3] + sp[32] * PI6[0][12][3] + sp[28] * PI2[0][3][12] + sp[29] * PI5[0][3][12] + sp[26] * PI7[0][12][3] + sp[27] * PI8[0][12][3] + sp[31] * PI3[0][3][12] + sp[32] * PI6[0][3][12] + sp[27] * PI8[0][3][12] + sp[30] * PI9[0][12][3];
    A[184] = sp[33] * PI0[0][12][4] + sp[34] * PI1[0][12][4] + sp[28] * PI2[0][12][4] + sp[31] * PI3[0][12][4] + sp[34] * PI1[0][4][12] + sp[35] * PI4[0][12][4] + sp[29] * PI5[0][12][4] + sp[32] * PI6[0][12][4] + sp[28] * PI2[0][4][12] + sp[29] * PI5[0][4][12] + sp[26] * PI7[0][12][4] + sp[27] * PI8[0][12][4] + sp[31] * PI3[0][4][12] + sp[32] * PI6[0][4][12] + sp[27] * PI8[0][4][12] + sp[30] * PI9[0][12][4];
    A[185] = sp[33] * PI0[0][12][5] + sp[34] * PI1[0][12][5] + sp[28] * PI2[0][12][5] + sp[31] * PI3[0][12][5] + sp[34] * PI1[0][5][12] + sp[35] * PI4[0][12][5] + sp[29] * PI5[0][12][5] + sp[32] * PI6[0][12][5] + sp[28] * PI2[0][5][12] + sp[29] * PI5[0][5][12] + sp[26] * PI7[0][12][5] + sp[27] * PI8[0][12][5] + sp[31] * PI3[0][5][12] + sp[32] * PI6[0][5][12] + sp[27] * PI8[0][5][12] + sp[30] * PI9[0][12][5];
    A[186] = sp[33] * PI0[0][12][6] + sp[34] * PI1[0][12][6] + sp[28] * PI2[0][12][6] + sp[31] * PI3[0][12][6] + sp[34] * PI1[0][6][12] + sp[35] * PI4[0][12][6] + sp[29] * PI5[0][12][6] + sp[32] * PI6[0][12][6] + sp[28] * PI2[0][6][12] + sp[29] * PI5[0][6][12] + sp[26] * PI7[0][12][6] + sp[27] * PI8[0][12][6] + sp[31] * PI3[0][6][12] + sp[32] * PI6[0][6][12] + sp[27] * PI8[0][6][12] + sp[30] * PI9[0][12][6];
    A[187] = sp[33] * PI0[0][12][7] + sp[34] * PI1[0][12][7] + sp[28] * PI2[0][12][7] + sp[31] * PI3[0][12][7] + sp[34] * PI1[0][7][12] + sp[35] * PI4[0][12][7] + sp[29] * PI5[0][12][7] + sp[32] * PI6[0][12][7] + sp[28] * PI2[0][7][12] + sp[29] * PI5[0][7][12] + sp[26] * PI7[0][12][7] + sp[27] * PI8[0][12][7] + sp[31] * PI3[0][7][12] + sp[32] * PI6[0][7][12] + sp[27] * PI8[0][7][12] + sp[30] * PI9[0][12][7];
    A[188] = sp[33] * PI0[0][12][8] + sp[34] * PI1[0][12][8] + sp[28] * PI2[0][12][8] + sp[31] * PI3[0][12][8] + sp[34] * PI1[0][8][12] + sp[35] * PI4[0][12][8] + sp[29] * PI5[0][12][8] + sp[32] * PI6[0][12][8] + sp[28] * PI2[0][8][12] + sp[29] * PI5[0][8][12] + sp[26] * PI7[0][12][8] + sp[27] * PI8[0][12][8] + sp[31] * PI3[0][8][12] + sp[32] * PI6[0][8][12] + sp[27] * PI8[0][8][12] + sp[30] * PI9[0][12][8];
    A[189] = sp[33] * PI0[0][12][9] + sp[34] * PI1[0][12][9] + sp[28] * PI2[0][12][9] + sp[31] * PI3[0][12][9] + sp[34] * PI1[0][9][12] + sp[35] * PI4[0][12][9] + sp[29] * PI5[0][12][9] + sp[32] * PI6[0][12][9] + sp[28] * PI2[0][9][12] + sp[29] * PI5[0][9][12] + sp[26] * PI7[0][12][9] + sp[27] * PI8[0][12][9] + sp[31] * PI3[0][9][12] + sp[32] * PI6[0][9][12] + sp[27] * PI8[0][9][12] + sp[30] * PI9[0][12][9];
    A[190] = sp[33] * PI0[0][12][10] + sp[34] * PI1[0][12][10] + sp[28] * PI2[0][12][10] + sp[31] * PI3[0][12][10] + sp[34] * PI1[0][10][12] + sp[35] * PI4[0][12][10] + sp[29] * PI5[0][12][10] + sp[32] * PI6[0][12][10] + sp[28] * PI2[0][10][12] + sp[29] * PI5[0][10][12] + sp[26] * PI7[0][12][10] + sp[27] * PI8[0][12][10] + sp[31] * PI3[0][10][12] + sp[32] * PI6[0][10][12] + sp[27] * PI8[0][10][12] + sp[30] * PI9[0][12][10];
    A[191] = sp[33] * PI0[0][12][11] + sp[34] * PI1[0][12][11] + sp[28] * PI2[0][12][11] + sp[31] * PI3[0][12][11] + sp[34] * PI1[0][11][12] + sp[35] * PI4[0][12][11] + sp[29] * PI5[0][12][11] + sp[32] * PI6[0][12][11] + sp[28] * PI2[0][11][12] + sp[29] * PI5[0][11][12] + sp[26] * PI7[0][12][11] + sp[27] * PI8[0][12][11] + sp[31] * PI3[0][11][12] + sp[32] * PI6[0][11][12] + sp[27] * PI8[0][11][12] + sp[30] * PI9[0][12][11];
    A[192] = sp[33] * PI0[0][12][12] + sp[34] * PI1[0][12][12] + sp[28] * PI2[0][12][12] + sp[31] * PI3[0][12][12] + sp[34] * PI1[0][12][12] + sp[35] * PI4[0][12][12] + sp[29] * PI5[0][12][12] + sp[32] * PI6[0][12][12] + sp[28] * PI2[0][12][12] + sp[29] * PI5[0][12][12] + sp[26] * PI7[0][12][12] + sp[27] * PI8[0][12][12] + sp[31] * PI3[0][12][12] + sp[32] * PI6[0][12][12] + sp[27] * PI8[0][12][12] + sp[30] * PI9[0][12][12];
    A[193] = sp[33] * PI0[0][12][13] + sp[34] * PI1[0][12][13] + sp[28] * PI2[0][12][13] + sp[31] * PI3[0][12][13] + sp[34] * PI1[0][13][12] + sp[35] * PI4[0][12][13] + sp[29] * PI5[0][12][13] + sp[32] * PI6[0][12][13] + sp[28] * PI2[0][13][12] + sp[29] * PI5[0][13][12] + sp[26] * PI7[0][12][13] + sp[27] * PI8[0][12][13] + sp[31] * PI3[0][13][12] + sp[32] * PI6[0][13][12] + sp[27] * PI8[0][13][12] + sp[30] * PI9[0][12][13];
    A[194] = sp[33] * PI0[0][12][14] + sp[34] * PI1[0][12][14] + sp[28] * PI2[0][12][14] + sp[31] * PI3[0][12][14] + sp[34] * PI1[0][14][12] + sp[35] * PI4[0][12][14] + sp[29] * PI5[0][12][14] + sp[32] * PI6[0][12][14] + sp[28] * PI2[0][14][12] + sp[29] * PI5[0][14][12] + sp[26] * PI7[0][12][14] + sp[27] * PI8[0][12][14] + sp[31] * PI3[0][14][12] + sp[32] * PI6[0][14][12] + sp[27] * PI8[0][14][12] + sp[30] * PI9[0][12][14];
    A[195] = sp[33] * PI0[0][13][0] + sp[34] * PI1[0][13][0] + sp[28] * PI2[0][13][0] + sp[31] * PI3[0][13][0] + sp[34] * PI1[0][0][13] + sp[35] * PI4[0][13][0] + sp[29] * PI5[0][13][0] + sp[32] * PI6[0][13][0] + sp[28] * PI2[0][0][13] + sp[29] * PI5[0][0][13] + sp[26] * PI7[0][13][0] + sp[27] * PI8[0][13][0] + sp[31] * PI3[0][0][13] + sp[32] * PI6[0][0][13] + sp[27] * PI8[0][0][13] + sp[30] * PI9[0][13][0];
    A[196] = sp[33] * PI0[0][13][1] + sp[34] * PI1[0][13][1] + sp[28] * PI2[0][13][1] + sp[31] * PI3[0][13][1] + sp[34] * PI1[0][1][13] + sp[35] * PI4[0][13][1] + sp[29] * PI5[0][13][1] + sp[32] * PI6[0][13][1] + sp[28] * PI2[0][1][13] + sp[29] * PI5[0][1][13] + sp[26] * PI7[0][13][1] + sp[27] * PI8[0][13][1] + sp[31] * PI3[0][1][13] + sp[32] * PI6[0][1][13] + sp[27] * PI8[0][1][13] + sp[30] * PI9[0][13][1];
    A[197] = sp[33] * PI0[0][13][2] + sp[34] * PI1[0][13][2] + sp[28] * PI2[0][13][2] + sp[31] * PI3[0][13][2] + sp[34] * PI1[0][2][13] + sp[35] * PI4[0][13][2] + sp[29] * PI5[0][13][2] + sp[32] * PI6[0][13][2] + sp[28] * PI2[0][2][13] + sp[29] * PI5[0][2][13] + sp[26] * PI7[0][13][2] + sp[27] * PI8[0][13][2] + sp[31] * PI3[0][2][13] + sp[32] * PI6[0][2][13] + sp[27] * PI8[0][2][13] + sp[30] * PI9[0][13][2];
    A[198] = sp[33] * PI0[0][13][3] + sp[34] * PI1[0][13][3] + sp[28] * PI2[0][13][3] + sp[31] * PI3[0][13][3] + sp[34] * PI1[0][3][13] + sp[35] * PI4[0][13][3] + sp[29] * PI5[0][13][3] + sp[32] * PI6[0][13][3] + sp[28] * PI2[0][3][13] + sp[29] * PI5[0][3][13] + sp[26] * PI7[0][13][3] + sp[27] * PI8[0][13][3] + sp[31] * PI3[0][3][13] + sp[32] * PI6[0][3][13] + sp[27] * PI8[0][3][13] + sp[30] * PI9[0][13][3];
    A[199] = sp[33] * PI0[0][13][4] + sp[34] * PI1[0][13][4] + sp[28] * PI2[0][13][4] + sp[31] * PI3[0][13][4] + sp[34] * PI1[0][4][13] + sp[35] * PI4[0][13][4] + sp[29] * PI5[0][13][4] + sp[32] * PI6[0][13][4] + sp[28] * PI2[0][4][13] + sp[29] * PI5[0][4][13] + sp[26] * PI7[0][13][4] + sp[27] * PI8[0][13][4] + sp[31] * PI3[0][4][13] + sp[32] * PI6[0][4][13] + sp[27] * PI8[0][4][13] + sp[30] * PI9[0][13][4];
    A[200] = sp[33] * PI0[0][13][5] + sp[34] * PI1[0][13][5] + sp[28] * PI2[0][13][5] + sp[31] * PI3[0][13][5] + sp[34] * PI1[0][5][13] + sp[35] * PI4[0][13][5] + sp[29] * PI5[0][13][5] + sp[32] * PI6[0][13][5] + sp[28] * PI2[0][5][13] + sp[29] * PI5[0][5][13] + sp[26] * PI7[0][13][5] + sp[27] * PI8[0][13][5] + sp[31] * PI3[0][5][13] + sp[32] * PI6[0][5][13] + sp[27] * PI8[0][5][13] + sp[30] * PI9[0][13][5];
    A[201] = sp[33] * PI0[0][13][6] + sp[34] * PI1[0][13][6] + sp[28] * PI2[0][13][6] + sp[31] * PI3[0][13][6] + sp[34] * PI1[0][6][13] + sp[35] * PI4[0][13][6] + sp[29] * PI5[0][13][6] + sp[32] * PI6[0][13][6] + sp[28] * PI2[0][6][13] + sp[29] * PI5[0][6][13] + sp[26] * PI7[0][13][6] + sp[27] * PI8[0][13][6] + sp[31] * PI3[0][6][13] + sp[32] * PI6[0][6][13] + sp[27] * PI8[0][6][13] + sp[30] * PI9[0][13][6];
    A[202] = sp[33] * PI0[0][13][7] + sp[34] * PI1[0][13][7] + sp[28] * PI2[0][13][7] + sp[31] * PI3[0][13][7] + sp[34] * PI1[0][7][13] + sp[35] * PI4[0][13][7] + sp[29] * PI5[0][13][7] + sp[32] * PI6[0][13][7] + sp[28] * PI2[0][7][13] + sp[29] * PI5[0][7][13] + sp[26] * PI7[0][13][7] + sp[27] * PI8[0][13][7] + sp[31] * PI3[0][7][13] + sp[32] * PI6[0][7][13] + sp[27] * PI8[0][7][13] + sp[30] * PI9[0][13][7];
    A[203] = sp[33] * PI0[0][13][8] + sp[34] * PI1[0][13][8] + sp[28] * PI2[0][13][8] + sp[31] * PI3[0][13][8] + sp[34] * PI1[0][8][13] + sp[35] * PI4[0][13][8] + sp[29] * PI5[0][13][8] + sp[32] * PI6[0][13][8] + sp[28] * PI2[0][8][13] + sp[29] * PI5[0][8][13] + sp[26] * PI7[0][13][8] + sp[27] * PI8[0][13][8] + sp[31] * PI3[0][8][13] + sp[32] * PI6[0][8][13] + sp[27] * PI8[0][8][13] + sp[30] * PI9[0][13][8];
    A[204] = sp[33] * PI0[0][13][9] + sp[34] * PI1[0][13][9] + sp[28] * PI2[0][13][9] + sp[31] * PI3[0][13][9] + sp[34] * PI1[0][9][13] + sp[35] * PI4[0][13][9] + sp[29] * PI5[0][13][9] + sp[32] * PI6[0][13][9] + sp[28] * PI2[0][9][13] + sp[29] * PI5[0][9][13] + sp[26] * PI7[0][13][9] + sp[27] * PI8[0][13][9] + sp[31] * PI3[0][9][13] + sp[32] * PI6[0][9][13] + sp[27] * PI8[0][9][13] + sp[30] * PI9[0][13][9];
    A[205] = sp[33] * PI0[0][13][10] + sp[34] * PI1[0][13][10] + sp[28] * PI2[0][13][10] + sp[31] * PI3[0][13][10] + sp[34] * PI1[0][10][13] + sp[35] * PI4[0][13][10] + sp[29] * PI5[0][13][10] + sp[32] * PI6[0][13][10] + sp[28] * PI2[0][10][13] + sp[29] * PI5[0][10][13] + sp[26] * PI7[0][13][10] + sp[27] * PI8[0][13][10] + sp[31] * PI3[0][10][13] + sp[32] * PI6[0][10][13] + sp[27] * PI8[0][10][13] + sp[30] * PI9[0][13][10];
    A[206] = sp[33] * PI0[0][13][11] + sp[34] * PI1[0][13][11] + sp[28] * PI2[0][13][11] + sp[31] * PI3[0][13][11] + sp[34] * PI1[0][11][13] + sp[35] * PI4[0][13][11] + sp[29] * PI5[0][13][11] + sp[32] * PI6[0][13][11] + sp[28] * PI2[0][11][13] + sp[29] * PI5[0][11][13] + sp[26] * PI7[0][13][11] + sp[27] * PI8[0][13][11] + sp[31] * PI3[0][11][13] + sp[32] * PI6[0][11][13] + sp[27] * PI8[0][11][13] + sp[30] * PI9[0][13][11];
    A[207] = sp[33] * PI0[0][13][12] + sp[34] * PI1[0][13][12] + sp[28] * PI2[0][13][12] + sp[31] * PI3[0][13][12] + sp[34] * PI1[0][12][13] + sp[35] * PI4[0][13][12] + sp[29] * PI5[0][13][12] + sp[32] * PI6[0][13][12] + sp[28] * PI2[0][12][13] + sp[29] * PI5[0][12][13] + sp[26] * PI7[0][13][12] + sp[27] * PI8[0][13][12] + sp[31] * PI3[0][12][13] + sp[32] * PI6[0][12][13] + sp[27] * PI8[0][12][13] + sp[30] * PI9[0][13][12];
    A[208] = sp[33] * PI0[0][13][13] + sp[34] * PI1[0][13][13] + sp[28] * PI2[0][13][13] + sp[31] * PI3[0][13][13] + sp[34] * PI1[0][13][13] + sp[35] * PI4[0][13][13] + sp[29] * PI5[0][13][13] + sp[32] * PI6[0][13][13] + sp[28] * PI2[0][13][13] + sp[29] * PI5[0][13][13] + sp[26] * PI7[0][13][13] + sp[27] * PI8[0][13][13] + sp[31] * PI3[0][13][13] + sp[32] * PI6[0][13][13] + sp[27] * PI8[0][13][13] + sp[30] * PI9[0][13][13];
    A[209] = sp[33] * PI0[0][13][14] + sp[34] * PI1[0][13][14] + sp[28] * PI2[0][13][14] + sp[31] * PI3[0][13][14] + sp[34] * PI1[0][14][13] + sp[35] * PI4[0][13][14] + sp[29] * PI5[0][13][14] + sp[32] * PI6[0][13][14] + sp[28] * PI2[0][14][13] + sp[29] * PI5[0][14][13] + sp[26] * PI7[0][13][14] + sp[27] * PI8[0][13][14] + sp[31] * PI3[0][14][13] + sp[32] * PI6[0][14][13] + sp[27] * PI8[0][14][13] + sp[30] * PI9[0][13][14];
    A[210] = sp[33] * PI0[0][14][0] + sp[34] * PI1[0][14][0] + sp[28] * PI2[0][14][0] + sp[31] * PI3[0][14][0] + sp[34] * PI1[0][0][14] + sp[35] * PI4[0][14][0] + sp[29] * PI5[0][14][0] + sp[32] * PI6[0][14][0] + sp[28] * PI2[0][0][14] + sp[29] * PI5[0][0][14] + sp[26] * PI7[0][14][0] + sp[27] * PI8[0][14][0] + sp[31] * PI3[0][0][14] + sp[32] * PI6[0][0][14] + sp[27] * PI8[0][0][14] + sp[30] * PI9[0][14][0];
    A[211] = sp[33] * PI0[0][14][1] + sp[34] * PI1[0][14][1] + sp[28] * PI2[0][14][1] + sp[31] * PI3[0][14][1] + sp[34] * PI1[0][1][14] + sp[35] * PI4[0][14][1] + sp[29] * PI5[0][14][1] + sp[32] * PI6[0][14][1] + sp[28] * PI2[0][1][14] + sp[29] * PI5[0][1][14] + sp[26] * PI7[0][14][1] + sp[27] * PI8[0][14][1] + sp[31] * PI3[0][1][14] + sp[32] * PI6[0][1][14] + sp[27] * PI8[0][1][14] + sp[30] * PI9[0][14][1];
    A[212] = sp[33] * PI0[0][14][2] + sp[34] * PI1[0][14][2] + sp[28] * PI2[0][14][2] + sp[31] * PI3[0][14][2] + sp[34] * PI1[0][2][14] + sp[35] * PI4[0][14][2] + sp[29] * PI5[0][14][2] + sp[32] * PI6[0][14][2] + sp[28] * PI2[0][2][14] + sp[29] * PI5[0][2][14] + sp[26] * PI7[0][14][2] + sp[27] * PI8[0][14][2] + sp[31] * PI3[0][2][14] + sp[32] * PI6[0][2][14] + sp[27] * PI8[0][2][14] + sp[30] * PI9[0][14][2];
    A[213] = sp[33] * PI0[0][14][3] + sp[34] * PI1[0][14][3] + sp[28] * PI2[0][14][3] + sp[31] * PI3[0][14][3] + sp[34] * PI1[0][3][14] + sp[35] * PI4[0][14][3] + sp[29] * PI5[0][14][3] + sp[32] * PI6[0][14][3] + sp[28] * PI2[0][3][14] + sp[29] * PI5[0][3][14] + sp[26] * PI7[0][14][3] + sp[27] * PI8[0][14][3] + sp[31] * PI3[0][3][14] + sp[32] * PI6[0][3][14] + sp[27] * PI8[0][3][14] + sp[30] * PI9[0][14][3];
    A[214] = sp[33] * PI0[0][14][4] + sp[34] * PI1[0][14][4] + sp[28] * PI2[0][14][4] + sp[31] * PI3[0][14][4] + sp[34] * PI1[0][4][14] + sp[35] * PI4[0][14][4] + sp[29] * PI5[0][14][4] + sp[32] * PI6[0][14][4] + sp[28] * PI2[0][4][14] + sp[29] * PI5[0][4][14] + sp[26] * PI7[0][14][4] + sp[27] * PI8[0][14][4] + sp[31] * PI3[0][4][14] + sp[32] * PI6[0][4][14] + sp[27] * PI8[0][4][14] + sp[30] * PI9[0][14][4];
    A[215] = sp[33] * PI0[0][14][5] + sp[34] * PI1[0][14][5] + sp[28] * PI2[0][14][5] + sp[31] * PI3[0][14][5] + sp[34] * PI1[0][5][14] + sp[35] * PI4[0][14][5] + sp[29] * PI5[0][14][5] + sp[32] * PI6[0][14][5] + sp[28] * PI2[0][5][14] + sp[29] * PI5[0][5][14] + sp[26] * PI7[0][14][5] + sp[27] * PI8[0][14][5] + sp[31] * PI3[0][5][14] + sp[32] * PI6[0][5][14] + sp[27] * PI8[0][5][14] + sp[30] * PI9[0][14][5];
    A[216] = sp[33] * PI0[0][14][6] + sp[34] * PI1[0][14][6] + sp[28] * PI2[0][14][6] + sp[31] * PI3[0][14][6] + sp[34] * PI1[0][6][14] + sp[35] * PI4[0][14][6] + sp[29] * PI5[0][14][6] + sp[32] * PI6[0][14][6] + sp[28] * PI2[0][6][14] + sp[29] * PI5[0][6][14] + sp[26] * PI7[0][14][6] + sp[27] * PI8[0][14][6] + sp[31] * PI3[0][6][14] + sp[32] * PI6[0][6][14] + sp[27] * PI8[0][6][14] + sp[30] * PI9[0][14][6];
    A[217] = sp[33] * PI0[0][14][7] + sp[34] * PI1[0][14][7] + sp[28] * PI2[0][14][7] + sp[31] * PI3[0][14][7] + sp[34] * PI1[0][7][14] + sp[35] * PI4[0][14][7] + sp[29] * PI5[0][14][7] + sp[32] * PI6[0][14][7] + sp[28] * PI2[0][7][14] + sp[29] * PI5[0][7][14] + sp[26] * PI7[0][14][7] + sp[27] * PI8[0][14][7] + sp[31] * PI3[0][7][14] + sp[32] * PI6[0][7][14] + sp[27] * PI8[0][7][14] + sp[30] * PI9[0][14][7];
    A[218] = sp[33] * PI0[0][14][8] + sp[34] * PI1[0][14][8] + sp[28] * PI2[0][14][8] + sp[31] * PI3[0][14][8] + sp[34] * PI1[0][8][14] + sp[35] * PI4[0][14][8] + sp[29] * PI5[0][14][8] + sp[32] * PI6[0][14][8] + sp[28] * PI2[0][8][14] + sp[29] * PI5[0][8][14] + sp[26] * PI7[0][14][8] + sp[27] * PI8[0][14][8] + sp[31] * PI3[0][8][14] + sp[32] * PI6[0][8][14] + sp[27] * PI8[0][8][14] + sp[30] * PI9[0][14][8];
    A[219] = sp[33] * PI0[0][14][9] + sp[34] * PI1[0][14][9] + sp[28] * PI2[0][14][9] + sp[31] * PI3[0][14][9] + sp[34] * PI1[0][9][14] + sp[35] * PI4[0][14][9] + sp[29] * PI5[0][14][9] + sp[32] * PI6[0][14][9] + sp[28] * PI2[0][9][14] + sp[29] * PI5[0][9][14] + sp[26] * PI7[0][14][9] + sp[27] * PI8[0][14][9] + sp[31] * PI3[0][9][14] + sp[32] * PI6[0][9][14] + sp[27] * PI8[0][9][14] + sp[30] * PI9[0][14][9];
    A[220] = sp[33] * PI0[0][14][10] + sp[34] * PI1[0][14][10] + sp[28] * PI2[0][14][10] + sp[31] * PI3[0][14][10] + sp[34] * PI1[0][10][14] + sp[35] * PI4[0][14][10] + sp[29] * PI5[0][14][10] + sp[32] * PI6[0][14][10] + sp[28] * PI2[0][10][14] + sp[29] * PI5[0][10][14] + sp[26] * PI7[0][14][10] + sp[27] * PI8[0][14][10] + sp[31] * PI3[0][10][14] + sp[32] * PI6[0][10][14] + sp[27] * PI8[0][10][14] + sp[30] * PI9[0][14][10];
    A[221] = sp[33] * PI0[0][14][11] + sp[34] * PI1[0][14][11] + sp[28] * PI2[0][14][11] + sp[31] * PI3[0][14][11] + sp[34] * PI1[0][11][14] + sp[35] * PI4[0][14][11] + sp[29] * PI5[0][14][11] + sp[32] * PI6[0][14][11] + sp[28] * PI2[0][11][14] + sp[29] * PI5[0][11][14] + sp[26] * PI7[0][14][11] + sp[27] * PI8[0][14][11] + sp[31] * PI3[0][11][14] + sp[32] * PI6[0][11][14] + sp[27] * PI8[0][11][14] + sp[30] * PI9[0][14][11];
    A[222] = sp[33] * PI0[0][14][12] + sp[34] * PI1[0][14][12] + sp[28] * PI2[0][14][12] + sp[31] * PI3[0][14][12] + sp[34] * PI1[0][12][14] + sp[35] * PI4[0][14][12] + sp[29] * PI5[0][14][12] + sp[32] * PI6[0][14][12] + sp[28] * PI2[0][12][14] + sp[29] * PI5[0][12][14] + sp[26] * PI7[0][14][12] + sp[27] * PI8[0][14][12] + sp[31] * PI3[0][12][14] + sp[32] * PI6[0][12][14] + sp[27] * PI8[0][12][14] + sp[30] * PI9[0][14][12];
    A[223] = sp[33] * PI0[0][14][13] + sp[34] * PI1[0][14][13] + sp[28] * PI2[0][14][13] + sp[31] * PI3[0][14][13] + sp[34] * PI1[0][13][14] + sp[35] * PI4[0][14][13] + sp[29] * PI5[0][14][13] + sp[32] * PI6[0][14][13] + sp[28] * PI2[0][13][14] + sp[29] * PI5[0][13][14] + sp[26] * PI7[0][14][13] + sp[27] * PI8[0][14][13] + sp[31] * PI3[0][13][14] + sp[32] * PI6[0][13][14] + sp[27] * PI8[0][13][14] + sp[30] * PI9[0][14][13];
    A[224] = sp[33] * PI0[0][14][14] + sp[34] * PI1[0][14][14] + sp[28] * PI2[0][14][14] + sp[31] * PI3[0][14][14] + sp[34] * PI1[0][14][14] + sp[35] * PI4[0][14][14] + sp[29] * PI5[0][14][14] + sp[32] * PI6[0][14][14] + sp[28] * PI2[0][14][14] + sp[29] * PI5[0][14][14] + sp[26] * PI7[0][14][14] + sp[27] * PI8[0][14][14] + sp[31] * PI3[0][14][14] + sp[32] * PI6[0][14][14] + sp[27] * PI8[0][14][14] + sp[30] * PI9[0][14][14];
  }

};


class forms_cell_integral_1_otherwise: public ufc::cell_integral
{
public:

  forms_cell_integral_1_otherwise() : ufc::cell_integral()
  {

  }

  ~forms_cell_integral_1_otherwise() override
  {

  }

  const std::vector<bool> & enabled_coefficients() const final override
  {
static const std::vector<bool> enabled({});
return enabled;
  }

  void tabulate_tensor(double * A,
                       const double * const * w,
                       const double * coordinate_dofs,
                       int cell_orientation,
                       std::size_t local_facet) const final override
  {
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    // num_cells:         None
    // optimize:          True
    // precision:         16
    // quadrature_degree: 6
    // quadrature_rule:   'default'
    // representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    // estimated_polynomial_degree: 6
    // optimize:                    True
    // precision:                   16
    // quadrature_degree:           6
    // quadrature_rule:             'default'
    // representation:              'uflacs'
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE3_C0_D01_Q12[1][1][2] = { { { -1.0, 1.0 } } };
    alignas(32) static const double PI0[1][15][15] =
        { { { 0.02162698412698432, -0.0298611111111112, 0.01765873015873006, -0.01542658730158738, 0.01746031746031735, -0.02385912698412697, -0.01314484126984128, 0.02777777777777796, -0.02058531746031761, 0.04349267900155131, 0.06529556615835214, -0.01686507936508176, 0.03507474113028575, -0.1005208057964093, 0.06200396825396944 },
            { -0.0298611111111112, 0.06865079365079398, -0.04871031746031751, 0.01746031746031736, -0.04384920634920628, 0.06111111111111132, 0.01041666666666665, -0.01785714285714292, 0.02529761904761933, -0.07856742013183737, -0.05326743555023476, -0.004960317460313899, -0.07014948226057148, 0.04639421805988012, -0.1240079365079388 },
            { 0.01765873015873006, -0.04871031746031751, 0.05734126984127013, -0.02385912698412703, 0.06111111111111146, -0.05114087301587317, -0.01860119047619067, 0.01190476190476192, -0.01116071428571434, 0.1248660784238152, -0.003436608745177797, 0.1001984126984117, -0.03507474113028571, -0.02319710902993941, -0.06200396825396937 },
            { -0.01542658730158738, 0.01746031746031736, -0.02385912698412703, 0.0216269841269843, -0.02986111111111125, 0.01765873015873008, 0.02058531746031757, -0.02777777777777791, 0.01314484126984126, -0.07856742013183697, -0.03522523963805747, -0.04513888888888794, 0.03507474113028566, 0.1005208057964091, 0.06200396825396921 },
            { 0.01746031746031735, -0.04384920634920628, 0.06111111111111146, -0.02986111111111125, 0.06865079365079413, -0.04871031746031756, -0.02529761904761931, 0.0178571428571429, -0.01041666666666664, 0.1487169023924089, -0.006873217490354935, 0.1289682539682535, -0.07014948226057147, -0.04639421805988004, -0.1240079365079388 },
            { -0.02385912698412697, 0.06111111111111132, -0.05114087301587317, 0.01765873015873008, -0.04871031746031756, 0.05734126984127004, 0.01116071428571433, -0.01190476190476189, 0.01860119047619064, -0.08979133729352934, -0.02663371777511684, -0.03819444444444207, -0.03507474113028566, 0.02319710902993935, -0.06200396825396923 },
            { -0.01314484126984128, 0.01041666666666665, -0.01860119047619067, 0.02058531746031757, -0.02529761904761931, 0.01116071428571433, 0.1012896825396833, -0.09444444444444483, 0.04474206349206343, -0.2062394778460752, 0.1314502845029979, 0.1473214285714272, 0.04208968935634285, 0.1030982623552903, 0.07440476190476317 },
            { 0.02777777777777796, -0.01785714285714292, 0.01190476190476192, -0.02777777777777791, 0.0178571428571429, -0.01190476190476189, -0.09444444444444483, 0.1630952380952393, -0.09444444444444482, 0.1346870059402914, 0.1030982623552913, -0.107142857142856, 0.0, -0.2061965247105818, 0.0 },
            { -0.02058531746031761, 0.02529761904761933, -0.01116071428571434, 0.01314484126984126, -0.01041666666666664, 0.01860119047619064, 0.04474206349206343, -0.09444444444444482, 0.1012896825396832, -0.1641497884897317, -0.234548546858288, 0.2217261904761906, -0.04208968935634289, 0.1030982623552904, -0.07440476190476332 },
            { 0.04349267900155131, -0.07856742013183737, 0.1248660784238152, -0.07856742013183697, 0.1487169023924089, -0.08979133729352934, -0.2062394778460752, 0.1346870059402914, -0.1641497884897317, 4.920634920634907, 0.0243004934799691, -0.5191061687282033, -0.1984126984127006, -0.2187044413199097, -0.3507474113028545 },
            { 0.06529556615835214, -0.05326743555023476, -0.003436608745177797, -0.03522523963805747, -0.006873217490354935, -0.02663371777511684, 0.1314502845029979, 0.1030982623552913, -0.234548546858288, 0.0243004934799691, 5.416666666666706, -0.1890134809847089, 0.1701034543599525, -0.4017857142857223, 0.3007032652029473 },
            { -0.01686507936508176, -0.004960317460313899, 0.1001984126984117, -0.04513888888888794, 0.1289682539682535, -0.03819444444444207, 0.1473214285714272, -0.107142857142856, 0.2217261904761906, -0.5191061687282033, -0.1890134809847089, 5.555555555555567, -0.3507474113028582, 0.07732369676647627, -0.6200396825396958 },
            { 0.03507474113028575, -0.07014948226057148, -0.03507474113028571, 0.03507474113028566, -0.07014948226057147, -0.03507474113028566, 0.04208968935634285, 0.0, -0.04208968935634289, -0.1984126984127006, 0.1701034543599525, -0.3507474113028582, 0.3968253968254037, 0.0, 0.7014948226057141 },
            { -0.1005208057964093, 0.04639421805988012, -0.02319710902993941, 0.1005208057964091, -0.04639421805988004, 0.02319710902993935, 0.1030982623552903, -0.2061965247105818, 0.1030982623552904, -0.2187044413199097, -0.4017857142857223, 0.07732369676647627, 0.0, 0.8035714285714404, 0.0 },
            { 0.06200396825396944, -0.1240079365079388, -0.06200396825396937, 0.06200396825396921, -0.1240079365079388, -0.06200396825396923, 0.07440476190476317, 0.0, -0.07440476190476332, -0.3507474113028545, 0.3007032652029473, -0.6200396825396958, 0.7014948226057141, 0.0, 1.240079365079387 } } };
    alignas(32) static const double PI1[1][15][15] =
        { { { -0.01116071428571435, 0.00595238095238092, -0.004712301587301571, -0.02447916666666676, 0.02167658730158712, -0.03266369047619055, -0.008804563492063535, 0.01413690476190486, -0.007068452380952378, -0.02314932914598858, -0.05154913117764573, -0.007440476190475876, 0.1283735525368425, -0.06314768569261549, 0.09598214285714154 },
            { 0.009920634920634991, -0.01289682539682551, 0.005952380952380917, 0.02316468253968246, -0.05327380952380956, 0.07524801587301629, 0.004216269841269748, -0.009424603174603193, 0.01165674603174616, -0.009820927516479937, -0.008591521862941532, 0.01984126984126935, -0.1360899955855055, 0.04897167461876208, -0.2405753968253959 },
            { -0.004712301587301591, 0.009920634920634989, -0.01116071428571436, -0.03067956349206364, 0.07276785714285766, -0.0582093253968256, -0.009052579365079387, 0.005704365079365044, -0.006820436507936561, 0.01192541198429709, -0.01718304372588163, -0.07192460317460365, 0.06243303921190634, 0.001288728279440823, 0.1460813492063476 },
            { 0.009052579365079378, -0.004216269841269767, 0.008804563492063544, 0.03278769841269864, -0.03581349206349215, 0.02237103174603167, 0.0135168650793652, -0.01364087301587307, 0.004340277777777709, 0.02665680325901707, 0.07947157723220394, 0.04340277777777808, -0.09329881140655677, 0.03737312010379357, -0.03397817460317264 },
            { -0.005704365079365063, 0.009424603174603197, -0.01413690476190488, -0.0397817460317463, 0.0815476190476197, -0.05466269841269854, -0.0136408730158731, 0.008432539682539653, -0.006200396825396829, 0.002805979290422831, -0.04725337024617515, -0.09176587301587381, 0.06594051332493429, 0.002577456558881318, 0.116567460317458 },
            { 0.006820436507936532, -0.01165674603174612, 0.007068452380952377, 0.0223710317460317, -0.05863095238095261, 0.06850198412698448, 0.0043402777777777, -0.006200396825396791, 0.009548611111111207, -0.01543288609732565, -0.0107394023286767, 0.03596230158730143, -0.09750778034219169, 0.02448583730938088, -0.2080853174603165 },
            { 0.03067956349206368, -0.02316468253968259, 0.02447916666666684, 0.07879464285714322, -0.1005456349206357, 0.04382440476190495, 0.03278769841269871, -0.03978174603174632, 0.02237103174603178, 0.04700015311458285, 0.1576544261849668, 0.1068948412698419, -0.1529258713280408, 0.0154647393532923, 0.0153769841269832 },
            { -0.07276785714285774, 0.05327380952380983, -0.02167658730158723, -0.1005456349206355, 0.0711309523809525, -0.033581349206349, -0.03581349206349219, 0.08154761904761976, -0.05863095238095278, -0.07997040977705125, -0.1520699369740542, 0.01934523809524032, 0.2946278254943938, -0.1030982623552902, -0.1458333333333376 },
            { 0.05820932539682568, -0.07524801587301649, 0.03266369047619069, 0.04382440476190484, -0.03358134920634909, 0.04308035714285736, 0.0223710317460317, -0.05466269841269858, 0.06850198412698465, -0.05822407027627437, -0.06142938132002924, 0.09945436507936579, -0.1950155606843829, 0.08763352300199798, -0.05902777777777969 },
            { -0.0624330392119062, 0.1360899955855054, -0.1283735525368425, -0.1529258713280407, 0.294627825494395, -0.1950155606843839, -0.09329881140655705, 0.06594051332493452, -0.09750778034219192, 0.1984126984127015, -0.06075123369997129, -0.8067190459965513, 4.305555555555533, -0.03645074021998884, 0.5401510134063853 },
            { -0.1271545235715235, 0.1838585678669347, -0.05154913117764433, 0.02104922856420387, -0.1778445025628794, -0.007302793583500347, -0.01073940232867385, 0.1022391101689941, -0.167964252420494, 0.2308546880599295, 0.4315476190476347, -0.06873217490352299, 0.4495591293798425, 3.593749999999993, 0.176126198190291 },
            { 0.07192460317460271, -0.1626984126984121, 0.1026785714285713, 0.005704365079364598, -0.01636904761904701, 0.105406746031749, 0.04935515873015908, -0.05605158730158727, 0.1252480158730152, -0.3016427737204513, -0.274928699614106, 0.5902777777777768, -0.3016427737204448, 0.1675346763273464, 3.395337301587296 },
            { -0.01192541198429713, 0.009820927516480053, 0.02314932914598854, 0.04700015311458292, -0.07997040977705144, -0.05822407027627428, 0.02665680325901714, 0.0028059792904229, -0.01543288609732577, 0.01984126984127017, 0.1579532076199499, 0.2034334985556567, 0.1984126984127023, -0.1458029608799467, 0.3507474113028566 },
            { 0.0708800553692623, -0.01288728279441056, 0.0322182069860282, 0.1714008611656712, -0.0592815008542904, 0.05541531601596761, 0.07732369676646841, -0.103098262355291, 0.02577456558882199, 0.2551551815399182, 0.5580357142857217, 0.06443641397205574, -0.7290148043997465, 0.4017857142857187, -0.051549131177635 },
            { -0.0210813492063496, 0.01736111111111151, 0.04092261904761971, 0.08308531746031894, -0.1413690476190502, -0.1029265873015891, 0.04712301587301667, 0.004960317460317699, -0.02728174603174662, 0.03507474113028545, 0.2792244605455828, 0.3596230158730216, 0.3507474113028586, -0.2577456558882179, 0.6200396825396917 } } };
    alignas(32) static const double PI2[1][15][15] =
        { { { 0.05734126984127032, -0.04871031746031779, 0.01765873015873018, 0.01860119047619062, -0.0119047619047619, 0.01116071428571418, 0.02385912698412709, -0.06111111111111162, 0.05114087301587341, 0.03507474113028573, 0.06529556615835097, -0.01091269841269951, -0.1248660784238147, -0.08505606644311392, 0.05307539682539861 },
            { -0.04871031746031779, 0.06865079365079432, -0.02986111111111136, -0.01041666666666665, 0.01785714285714286, -0.02529761904761914, -0.01746031746031747, 0.04384920634920659, -0.0611111111111117, 0.07014948226057124, 0.08419691425682223, -0.1021825396825406, 0.07856742013183718, 0.03092947870658591, 0.04365079365079522 },
            { 0.01765873015873018, -0.02986111111111136, 0.02162698412698439, 0.01314484126984127, -0.02777777777777798, 0.02058531746031758, 0.01542658730158743, -0.01746031746031746, 0.02385912698412715, -0.03507474113028573, -0.00343660874517654, 0.1180555555555574, -0.043492679001551, -0.01804219591217497, -0.06498015873016103 },
            { 0.01860119047619062, -0.01041666666666665, 0.01314484126984127, 0.1012896825396832, -0.09444444444444487, 0.04474206349206342, 0.02058531746031757, -0.02529761904761924, 0.01116071428571429, 0.04208968935634282, 0.1159855451497027, 0.05208333333333277, -0.2062394778460746, 0.1933092419161691, 0.04017857142857466 },
            { -0.0119047619047619, 0.01785714285714286, -0.02777777777777798, -0.09444444444444487, 0.1630952380952394, -0.09444444444444489, -0.02777777777777796, 0.01785714285714286, -0.01190476190476188, 0.0, -0.1030982623552915, -0.1785714285714299, 0.1346870059402919, -0.04123930494211465, 0.1428571428571426 },
            { 0.01116071428571418, -0.02529761904761914, 0.02058531746031758, 0.04474206349206342, -0.09444444444444489, 0.1012896825396832, 0.01314484126984123, -0.01041666666666649, 0.01860119047619052, -0.04208968935634268, -0.01288728279441195, 0.1264880952380963, -0.1641497884897319, 0.07474624020758433, -0.3139880952380971 },
            { 0.02385912698412709, -0.01746031746031747, 0.01542658730158743, 0.02058531746031757, -0.02777777777777796, 0.01314484126984123, 0.02162698412698433, -0.02986111111111129, 0.01765873015873017, 0.03507474113028561, 0.1039574145415858, 0.05605158730158798, -0.07856742013183682, -0.05670404429540887, -0.007936507936507606 },
            { -0.06111111111111162, 0.04384920634920659, -0.01746031746031746, -0.02529761904761924, 0.01785714285714286, -0.01041666666666649, -0.02986111111111129, 0.06865079365079427, -0.04871031746031777, -0.07014948226057136, -0.1305911323167024, 0.02182539682539818, 0.1487169023924087, 0.1082531754730541, -0.07043650793651073 },
            { 0.05114087301587341, -0.0611111111111117, 0.02385912698412715, 0.01116071428571429, -0.01190476190476188, 0.01860119047619052, 0.01765873015873017, -0.04871031746031777, 0.05734126984127039, -0.03507474113028568, -0.04209845712841156, 0.05109126984126997, -0.08979133729352917, -0.04639421805987991, -0.003968253968254573 },
            { 0.03507474113028573, 0.07014948226057124, -0.03507474113028573, 0.04208968935634282, 0.0, -0.04208968935634268, 0.03507474113028561, -0.07014948226057136, -0.03507474113028568, 0.396825396825403, 0.607512336999805, -0.3507474113028571, -0.1984126984127011, -0.2187044413199275, 0.3226876183986339 },
            { 0.06529556615835097, 0.08419691425682223, -0.00343660874517654, 0.1159855451497027, -0.1030982623552915, -0.01288728279441195, 0.1039574145415858, -0.1305911323167024, -0.04209845712841156, 0.607512336999805, 1.130952380952397, -0.1890134809847014, -0.4131083891598561, -0.4017857142857142, 0.3007032652029404 },
            { -0.01091269841269951, -0.1021825396825406, 0.1180555555555574, 0.05208333333333277, -0.1785714285714299, 0.1264880952380963, 0.05605158730158798, 0.02182539682539818, 0.05109126984126997, -0.3507474113028571, -0.1890134809847014, 0.912698412698429, -0.0140298964520944, 0.07732369676647288, -0.6200396825397049 },
            { -0.1248660784238147, 0.07856742013183718, -0.043492679001551, -0.2062394778460746, 0.1346870059402919, -0.1641497884897319, -0.07856742013183682, 0.1487169023924087, -0.08979133729352917, -0.1984126984127011, -0.4131083891598561, -0.0140298964520944, 4.920634920634906, -0.437408882639851, 0.280597929042256 },
            { -0.08505606644311392, 0.03092947870658591, -0.01804219591217497, 0.1933092419161691, -0.04123930494211465, 0.07474624020758433, -0.05670404429540887, 0.1082531754730541, -0.04639421805987991, -0.2187044413199275, -0.4017857142857142, 0.07732369676647288, -0.437408882639851, 5.357142857142864, -0.154647393532929 },
            { 0.05307539682539861, 0.04365079365079522, -0.06498015873016103, 0.04017857142857466, 0.1428571428571426, -0.3139880952380971, -0.007936507936507606, -0.07043650793651073, -0.003968253968254573, 0.3226876183986339, 0.3007032652029404, -0.6200396825397049, 0.280597929042256, -0.154647393532929, 5.615079365079418 } } };
    // Unstructured piecewise computations
    const double J_c0 = coordinate_dofs[0] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[2] * FE3_C0_D01_Q12[0][0][1];
    const double J_c3 = coordinate_dofs[1] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[5] * FE3_C0_D01_Q12[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[4] * FE3_C0_D01_Q12[0][0][1];
    const double J_c2 = coordinate_dofs[1] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[3] * FE3_C0_D01_Q12[0][0][1];
    alignas(32) double sp[20];
    sp[0] = J_c0 * J_c3;
    sp[1] = J_c1 * J_c2;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = J_c0 / sp[2];
    sp[4] = -1 * J_c1 / sp[2];
    sp[5] = sp[3] * sp[3];
    sp[6] = sp[3] * sp[4];
    sp[7] = sp[4] * sp[4];
    sp[8] = J_c3 / sp[2];
    sp[9] = -1 * J_c2 / sp[2];
    sp[10] = sp[9] * sp[9];
    sp[11] = sp[8] * sp[9];
    sp[12] = sp[8] * sp[8];
    sp[13] = sp[5] + sp[10];
    sp[14] = sp[6] + sp[11];
    sp[15] = sp[12] + sp[7];
    sp[16] = std::abs(sp[2]);
    sp[17] = sp[13] * sp[16];
    sp[18] = sp[14] * sp[16];
    sp[19] = sp[15] * sp[16];
    A[0] = sp[19] * PI0[0][0][0] + sp[18] * PI1[0][0][0] + sp[18] * PI1[0][0][0] + sp[17] * PI2[0][0][0];
    A[1] = sp[19] * PI0[0][0][1] + sp[18] * PI1[0][0][1] + sp[18] * PI1[0][1][0] + sp[17] * PI2[0][0][1];
    A[2] = sp[19] * PI0[0][0][2] + sp[18] * PI1[0][0][2] + sp[18] * PI1[0][2][0] + sp[17] * PI2[0][0][2];
    A[3] = sp[19] * PI0[0][0][3] + sp[18] * PI1[0][0][3] + sp[18] * PI1[0][3][0] + sp[17] * PI2[0][0][3];
    A[4] = sp[19] * PI0[0][0][4] + sp[18] * PI1[0][0][4] + sp[18] * PI1[0][4][0] + sp[17] * PI2[0][0][4];
    A[5] = sp[19] * PI0[0][0][5] + sp[18] * PI1[0][0][5] + sp[18] * PI1[0][5][0] + sp[17] * PI2[0][0][5];
    A[6] = sp[19] * PI0[0][0][6] + sp[18] * PI1[0][0][6] + sp[18] * PI1[0][6][0] + sp[17] * PI2[0][0][6];
    A[7] = sp[19] * PI0[0][0][7] + sp[18] * PI1[0][0][7] + sp[18] * PI1[0][7][0] + sp[17] * PI2[0][0][7];
    A[8] = sp[19] * PI0[0][0][8] + sp[18] * PI1[0][0][8] + sp[18] * PI1[0][8][0] + sp[17] * PI2[0][0][8];
    A[9] = sp[19] * PI0[0][0][9] + sp[18] * PI1[0][0][9] + sp[18] * PI1[0][9][0] + sp[17] * PI2[0][0][9];
    A[10] = sp[19] * PI0[0][0][10] + sp[18] * PI1[0][0][10] + sp[18] * PI1[0][10][0] + sp[17] * PI2[0][0][10];
    A[11] = sp[19] * PI0[0][0][11] + sp[18] * PI1[0][0][11] + sp[18] * PI1[0][11][0] + sp[17] * PI2[0][0][11];
    A[12] = sp[19] * PI0[0][0][12] + sp[18] * PI1[0][0][12] + sp[18] * PI1[0][12][0] + sp[17] * PI2[0][0][12];
    A[13] = sp[19] * PI0[0][0][13] + sp[18] * PI1[0][0][13] + sp[18] * PI1[0][13][0] + sp[17] * PI2[0][0][13];
    A[14] = sp[19] * PI0[0][0][14] + sp[18] * PI1[0][0][14] + sp[18] * PI1[0][14][0] + sp[17] * PI2[0][0][14];
    A[15] = sp[19] * PI0[0][1][0] + sp[18] * PI1[0][1][0] + sp[18] * PI1[0][0][1] + sp[17] * PI2[0][1][0];
    A[16] = sp[19] * PI0[0][1][1] + sp[18] * PI1[0][1][1] + sp[18] * PI1[0][1][1] + sp[17] * PI2[0][1][1];
    A[17] = sp[19] * PI0[0][1][2] + sp[18] * PI1[0][1][2] + sp[18] * PI1[0][2][1] + sp[17] * PI2[0][1][2];
    A[18] = sp[19] * PI0[0][1][3] + sp[18] * PI1[0][1][3] + sp[18] * PI1[0][3][1] + sp[17] * PI2[0][1][3];
    A[19] = sp[19] * PI0[0][1][4] + sp[18] * PI1[0][1][4] + sp[18] * PI1[0][4][1] + sp[17] * PI2[0][1][4];
    A[20] = sp[19] * PI0[0][1][5] + sp[18] * PI1[0][1][5] + sp[18] * PI1[0][5][1] + sp[17] * PI2[0][1][5];
    A[21] = sp[19] * PI0[0][1][6] + sp[18] * PI1[0][1][6] + sp[18] * PI1[0][6][1] + sp[17] * PI2[0][1][6];
    A[22] = sp[19] * PI0[0][1][7] + sp[18] * PI1[0][1][7] + sp[18] * PI1[0][7][1] + sp[17] * PI2[0][1][7];
    A[23] = sp[19] * PI0[0][1][8] + sp[18] * PI1[0][1][8] + sp[18] * PI1[0][8][1] + sp[17] * PI2[0][1][8];
    A[24] = sp[19] * PI0[0][1][9] + sp[18] * PI1[0][1][9] + sp[18] * PI1[0][9][1] + sp[17] * PI2[0][1][9];
    A[25] = sp[19] * PI0[0][1][10] + sp[18] * PI1[0][1][10] + sp[18] * PI1[0][10][1] + sp[17] * PI2[0][1][10];
    A[26] = sp[19] * PI0[0][1][11] + sp[18] * PI1[0][1][11] + sp[18] * PI1[0][11][1] + sp[17] * PI2[0][1][11];
    A[27] = sp[19] * PI0[0][1][12] + sp[18] * PI1[0][1][12] + sp[18] * PI1[0][12][1] + sp[17] * PI2[0][1][12];
    A[28] = sp[19] * PI0[0][1][13] + sp[18] * PI1[0][1][13] + sp[18] * PI1[0][13][1] + sp[17] * PI2[0][1][13];
    A[29] = sp[19] * PI0[0][1][14] + sp[18] * PI1[0][1][14] + sp[18] * PI1[0][14][1] + sp[17] * PI2[0][1][14];
    A[30] = sp[19] * PI0[0][2][0] + sp[18] * PI1[0][2][0] + sp[18] * PI1[0][0][2] + sp[17] * PI2[0][2][0];
    A[31] = sp[19] * PI0[0][2][1] + sp[18] * PI1[0][2][1] + sp[18] * PI1[0][1][2] + sp[17] * PI2[0][2][1];
    A[32] = sp[19] * PI0[0][2][2] + sp[18] * PI1[0][2][2] + sp[18] * PI1[0][2][2] + sp[17] * PI2[0][2][2];
    A[33] = sp[19] * PI0[0][2][3] + sp[18] * PI1[0][2][3] + sp[18] * PI1[0][3][2] + sp[17] * PI2[0][2][3];
    A[34] = sp[19] * PI0[0][2][4] + sp[18] * PI1[0][2][4] + sp[18] * PI1[0][4][2] + sp[17] * PI2[0][2][4];
    A[35] = sp[19] * PI0[0][2][5] + sp[18] * PI1[0][2][5] + sp[18] * PI1[0][5][2] + sp[17] * PI2[0][2][5];
    A[36] = sp[19] * PI0[0][2][6] + sp[18] * PI1[0][2][6] + sp[18] * PI1[0][6][2] + sp[17] * PI2[0][2][6];
    A[37] = sp[19] * PI0[0][2][7] + sp[18] * PI1[0][2][7] + sp[18] * PI1[0][7][2] + sp[17] * PI2[0][2][7];
    A[38] = sp[19] * PI0[0][2][8] + sp[18] * PI1[0][2][8] + sp[18] * PI1[0][8][2] + sp[17] * PI2[0][2][8];
    A[39] = sp[19] * PI0[0][2][9] + sp[18] * PI1[0][2][9] + sp[18] * PI1[0][9][2] + sp[17] * PI2[0][2][9];
    A[40] = sp[19] * PI0[0][2][10] + sp[18] * PI1[0][2][10] + sp[18] * PI1[0][10][2] + sp[17] * PI2[0][2][10];
    A[41] = sp[19] * PI0[0][2][11] + sp[18] * PI1[0][2][11] + sp[18] * PI1[0][11][2] + sp[17] * PI2[0][2][11];
    A[42] = sp[19] * PI0[0][2][12] + sp[18] * PI1[0][2][12] + sp[18] * PI1[0][12][2] + sp[17] * PI2[0][2][12];
    A[43] = sp[19] * PI0[0][2][13] + sp[18] * PI1[0][2][13] + sp[18] * PI1[0][13][2] + sp[17] * PI2[0][2][13];
    A[44] = sp[19] * PI0[0][2][14] + sp[18] * PI1[0][2][14] + sp[18] * PI1[0][14][2] + sp[17] * PI2[0][2][14];
    A[45] = sp[19] * PI0[0][3][0] + sp[18] * PI1[0][3][0] + sp[18] * PI1[0][0][3] + sp[17] * PI2[0][3][0];
    A[46] = sp[19] * PI0[0][3][1] + sp[18] * PI1[0][3][1] + sp[18] * PI1[0][1][3] + sp[17] * PI2[0][3][1];
    A[47] = sp[19] * PI0[0][3][2] + sp[18] * PI1[0][3][2] + sp[18] * PI1[0][2][3] + sp[17] * PI2[0][3][2];
    A[48] = sp[19] * PI0[0][3][3] + sp[18] * PI1[0][3][3] + sp[18] * PI1[0][3][3] + sp[17] * PI2[0][3][3];
    A[49] = sp[19] * PI0[0][3][4] + sp[18] * PI1[0][3][4] + sp[18] * PI1[0][4][3] + sp[17] * PI2[0][3][4];
    A[50] = sp[19] * PI0[0][3][5] + sp[18] * PI1[0][3][5] + sp[18] * PI1[0][5][3] + sp[17] * PI2[0][3][5];
    A[51] = sp[19] * PI0[0][3][6] + sp[18] * PI1[0][3][6] + sp[18] * PI1[0][6][3] + sp[17] * PI2[0][3][6];
    A[52] = sp[19] * PI0[0][3][7] + sp[18] * PI1[0][3][7] + sp[18] * PI1[0][7][3] + sp[17] * PI2[0][3][7];
    A[53] = sp[19] * PI0[0][3][8] + sp[18] * PI1[0][3][8] + sp[18] * PI1[0][8][3] + sp[17] * PI2[0][3][8];
    A[54] = sp[19] * PI0[0][3][9] + sp[18] * PI1[0][3][9] + sp[18] * PI1[0][9][3] + sp[17] * PI2[0][3][9];
    A[55] = sp[19] * PI0[0][3][10] + sp[18] * PI1[0][3][10] + sp[18] * PI1[0][10][3] + sp[17] * PI2[0][3][10];
    A[56] = sp[19] * PI0[0][3][11] + sp[18] * PI1[0][3][11] + sp[18] * PI1[0][11][3] + sp[17] * PI2[0][3][11];
    A[57] = sp[19] * PI0[0][3][12] + sp[18] * PI1[0][3][12] + sp[18] * PI1[0][12][3] + sp[17] * PI2[0][3][12];
    A[58] = sp[19] * PI0[0][3][13] + sp[18] * PI1[0][3][13] + sp[18] * PI1[0][13][3] + sp[17] * PI2[0][3][13];
    A[59] = sp[19] * PI0[0][3][14] + sp[18] * PI1[0][3][14] + sp[18] * PI1[0][14][3] + sp[17] * PI2[0][3][14];
    A[60] = sp[19] * PI0[0][4][0] + sp[18] * PI1[0][4][0] + sp[18] * PI1[0][0][4] + sp[17] * PI2[0][4][0];
    A[61] = sp[19] * PI0[0][4][1] + sp[18] * PI1[0][4][1] + sp[18] * PI1[0][1][4] + sp[17] * PI2[0][4][1];
    A[62] = sp[19] * PI0[0][4][2] + sp[18] * PI1[0][4][2] + sp[18] * PI1[0][2][4] + sp[17] * PI2[0][4][2];
    A[63] = sp[19] * PI0[0][4][3] + sp[18] * PI1[0][4][3] + sp[18] * PI1[0][3][4] + sp[17] * PI2[0][4][3];
    A[64] = sp[19] * PI0[0][4][4] + sp[18] * PI1[0][4][4] + sp[18] * PI1[0][4][4] + sp[17] * PI2[0][4][4];
    A[65] = sp[19] * PI0[0][4][5] + sp[18] * PI1[0][4][5] + sp[18] * PI1[0][5][4] + sp[17] * PI2[0][4][5];
    A[66] = sp[19] * PI0[0][4][6] + sp[18] * PI1[0][4][6] + sp[18] * PI1[0][6][4] + sp[17] * PI2[0][4][6];
    A[67] = sp[19] * PI0[0][4][7] + sp[18] * PI1[0][4][7] + sp[18] * PI1[0][7][4] + sp[17] * PI2[0][4][7];
    A[68] = sp[19] * PI0[0][4][8] + sp[18] * PI1[0][4][8] + sp[18] * PI1[0][8][4] + sp[17] * PI2[0][4][8];
    A[69] = sp[19] * PI0[0][4][9] + sp[18] * PI1[0][4][9] + sp[18] * PI1[0][9][4] + sp[17] * PI2[0][4][9];
    A[70] = sp[19] * PI0[0][4][10] + sp[18] * PI1[0][4][10] + sp[18] * PI1[0][10][4] + sp[17] * PI2[0][4][10];
    A[71] = sp[19] * PI0[0][4][11] + sp[18] * PI1[0][4][11] + sp[18] * PI1[0][11][4] + sp[17] * PI2[0][4][11];
    A[72] = sp[19] * PI0[0][4][12] + sp[18] * PI1[0][4][12] + sp[18] * PI1[0][12][4] + sp[17] * PI2[0][4][12];
    A[73] = sp[19] * PI0[0][4][13] + sp[18] * PI1[0][4][13] + sp[18] * PI1[0][13][4] + sp[17] * PI2[0][4][13];
    A[74] = sp[19] * PI0[0][4][14] + sp[18] * PI1[0][4][14] + sp[18] * PI1[0][14][4] + sp[17] * PI2[0][4][14];
    A[75] = sp[19] * PI0[0][5][0] + sp[18] * PI1[0][5][0] + sp[18] * PI1[0][0][5] + sp[17] * PI2[0][5][0];
    A[76] = sp[19] * PI0[0][5][1] + sp[18] * PI1[0][5][1] + sp[18] * PI1[0][1][5] + sp[17] * PI2[0][5][1];
    A[77] = sp[19] * PI0[0][5][2] + sp[18] * PI1[0][5][2] + sp[18] * PI1[0][2][5] + sp[17] * PI2[0][5][2];
    A[78] = sp[19] * PI0[0][5][3] + sp[18] * PI1[0][5][3] + sp[18] * PI1[0][3][5] + sp[17] * PI2[0][5][3];
    A[79] = sp[19] * PI0[0][5][4] + sp[18] * PI1[0][5][4] + sp[18] * PI1[0][4][5] + sp[17] * PI2[0][5][4];
    A[80] = sp[19] * PI0[0][5][5] + sp[18] * PI1[0][5][5] + sp[18] * PI1[0][5][5] + sp[17] * PI2[0][5][5];
    A[81] = sp[19] * PI0[0][5][6] + sp[18] * PI1[0][5][6] + sp[18] * PI1[0][6][5] + sp[17] * PI2[0][5][6];
    A[82] = sp[19] * PI0[0][5][7] + sp[18] * PI1[0][5][7] + sp[18] * PI1[0][7][5] + sp[17] * PI2[0][5][7];
    A[83] = sp[19] * PI0[0][5][8] + sp[18] * PI1[0][5][8] + sp[18] * PI1[0][8][5] + sp[17] * PI2[0][5][8];
    A[84] = sp[19] * PI0[0][5][9] + sp[18] * PI1[0][5][9] + sp[18] * PI1[0][9][5] + sp[17] * PI2[0][5][9];
    A[85] = sp[19] * PI0[0][5][10] + sp[18] * PI1[0][5][10] + sp[18] * PI1[0][10][5] + sp[17] * PI2[0][5][10];
    A[86] = sp[19] * PI0[0][5][11] + sp[18] * PI1[0][5][11] + sp[18] * PI1[0][11][5] + sp[17] * PI2[0][5][11];
    A[87] = sp[19] * PI0[0][5][12] + sp[18] * PI1[0][5][12] + sp[18] * PI1[0][12][5] + sp[17] * PI2[0][5][12];
    A[88] = sp[19] * PI0[0][5][13] + sp[18] * PI1[0][5][13] + sp[18] * PI1[0][13][5] + sp[17] * PI2[0][5][13];
    A[89] = sp[19] * PI0[0][5][14] + sp[18] * PI1[0][5][14] + sp[18] * PI1[0][14][5] + sp[17] * PI2[0][5][14];
    A[90] = sp[19] * PI0[0][6][0] + sp[18] * PI1[0][6][0] + sp[18] * PI1[0][0][6] + sp[17] * PI2[0][6][0];
    A[91] = sp[19] * PI0[0][6][1] + sp[18] * PI1[0][6][1] + sp[18] * PI1[0][1][6] + sp[17] * PI2[0][6][1];
    A[92] = sp[19] * PI0[0][6][2] + sp[18] * PI1[0][6][2] + sp[18] * PI1[0][2][6] + sp[17] * PI2[0][6][2];
    A[93] = sp[19] * PI0[0][6][3] + sp[18] * PI1[0][6][3] + sp[18] * PI1[0][3][6] + sp[17] * PI2[0][6][3];
    A[94] = sp[19] * PI0[0][6][4] + sp[18] * PI1[0][6][4] + sp[18] * PI1[0][4][6] + sp[17] * PI2[0][6][4];
    A[95] = sp[19] * PI0[0][6][5] + sp[18] * PI1[0][6][5] + sp[18] * PI1[0][5][6] + sp[17] * PI2[0][6][5];
    A[96] = sp[19] * PI0[0][6][6] + sp[18] * PI1[0][6][6] + sp[18] * PI1[0][6][6] + sp[17] * PI2[0][6][6];
    A[97] = sp[19] * PI0[0][6][7] + sp[18] * PI1[0][6][7] + sp[18] * PI1[0][7][6] + sp[17] * PI2[0][6][7];
    A[98] = sp[19] * PI0[0][6][8] + sp[18] * PI1[0][6][8] + sp[18] * PI1[0][8][6] + sp[17] * PI2[0][6][8];
    A[99] = sp[19] * PI0[0][6][9] + sp[18] * PI1[0][6][9] + sp[18] * PI1[0][9][6] + sp[17] * PI2[0][6][9];
    A[100] = sp[19] * PI0[0][6][10] + sp[18] * PI1[0][6][10] + sp[18] * PI1[0][10][6] + sp[17] * PI2[0][6][10];
    A[101] = sp[19] * PI0[0][6][11] + sp[18] * PI1[0][6][11] + sp[18] * PI1[0][11][6] + sp[17] * PI2[0][6][11];
    A[102] = sp[19] * PI0[0][6][12] + sp[18] * PI1[0][6][12] + sp[18] * PI1[0][12][6] + sp[17] * PI2[0][6][12];
    A[103] = sp[19] * PI0[0][6][13] + sp[18] * PI1[0][6][13] + sp[18] * PI1[0][13][6] + sp[17] * PI2[0][6][13];
    A[104] = sp[19] * PI0[0][6][14] + sp[18] * PI1[0][6][14] + sp[18] * PI1[0][14][6] + sp[17] * PI2[0][6][14];
    A[105] = sp[19] * PI0[0][7][0] + sp[18] * PI1[0][7][0] + sp[18] * PI1[0][0][7] + sp[17] * PI2[0][7][0];
    A[106] = sp[19] * PI0[0][7][1] + sp[18] * PI1[0][7][1] + sp[18] * PI1[0][1][7] + sp[17] * PI2[0][7][1];
    A[107] = sp[19] * PI0[0][7][2] + sp[18] * PI1[0][7][2] + sp[18] * PI1[0][2][7] + sp[17] * PI2[0][7][2];
    A[108] = sp[19] * PI0[0][7][3] + sp[18] * PI1[0][7][3] + sp[18] * PI1[0][3][7] + sp[17] * PI2[0][7][3];
    A[109] = sp[19] * PI0[0][7][4] + sp[18] * PI1[0][7][4] + sp[18] * PI1[0][4][7] + sp[17] * PI2[0][7][4];
    A[110] = sp[19] * PI0[0][7][5] + sp[18] * PI1[0][7][5] + sp[18] * PI1[0][5][7] + sp[17] * PI2[0][7][5];
    A[111] = sp[19] * PI0[0][7][6] + sp[18] * PI1[0][7][6] + sp[18] * PI1[0][6][7] + sp[17] * PI2[0][7][6];
    A[112] = sp[19] * PI0[0][7][7] + sp[18] * PI1[0][7][7] + sp[18] * PI1[0][7][7] + sp[17] * PI2[0][7][7];
    A[113] = sp[19] * PI0[0][7][8] + sp[18] * PI1[0][7][8] + sp[18] * PI1[0][8][7] + sp[17] * PI2[0][7][8];
    A[114] = sp[19] * PI0[0][7][9] + sp[18] * PI1[0][7][9] + sp[18] * PI1[0][9][7] + sp[17] * PI2[0][7][9];
    A[115] = sp[19] * PI0[0][7][10] + sp[18] * PI1[0][7][10] + sp[18] * PI1[0][10][7] + sp[17] * PI2[0][7][10];
    A[116] = sp[19] * PI0[0][7][11] + sp[18] * PI1[0][7][11] + sp[18] * PI1[0][11][7] + sp[17] * PI2[0][7][11];
    A[117] = sp[19] * PI0[0][7][12] + sp[18] * PI1[0][7][12] + sp[18] * PI1[0][12][7] + sp[17] * PI2[0][7][12];
    A[118] = sp[19] * PI0[0][7][13] + sp[18] * PI1[0][7][13] + sp[18] * PI1[0][13][7] + sp[17] * PI2[0][7][13];
    A[119] = sp[19] * PI0[0][7][14] + sp[18] * PI1[0][7][14] + sp[18] * PI1[0][14][7] + sp[17] * PI2[0][7][14];
    A[120] = sp[19] * PI0[0][8][0] + sp[18] * PI1[0][8][0] + sp[18] * PI1[0][0][8] + sp[17] * PI2[0][8][0];
    A[121] = sp[19] * PI0[0][8][1] + sp[18] * PI1[0][8][1] + sp[18] * PI1[0][1][8] + sp[17] * PI2[0][8][1];
    A[122] = sp[19] * PI0[0][8][2] + sp[18] * PI1[0][8][2] + sp[18] * PI1[0][2][8] + sp[17] * PI2[0][8][2];
    A[123] = sp[19] * PI0[0][8][3] + sp[18] * PI1[0][8][3] + sp[18] * PI1[0][3][8] + sp[17] * PI2[0][8][3];
    A[124] = sp[19] * PI0[0][8][4] + sp[18] * PI1[0][8][4] + sp[18] * PI1[0][4][8] + sp[17] * PI2[0][8][4];
    A[125] = sp[19] * PI0[0][8][5] + sp[18] * PI1[0][8][5] + sp[18] * PI1[0][5][8] + sp[17] * PI2[0][8][5];
    A[126] = sp[19] * PI0[0][8][6] + sp[18] * PI1[0][8][6] + sp[18] * PI1[0][6][8] + sp[17] * PI2[0][8][6];
    A[127] = sp[19] * PI0[0][8][7] + sp[18] * PI1[0][8][7] + sp[18] * PI1[0][7][8] + sp[17] * PI2[0][8][7];
    A[128] = sp[19] * PI0[0][8][8] + sp[18] * PI1[0][8][8] + sp[18] * PI1[0][8][8] + sp[17] * PI2[0][8][8];
    A[129] = sp[19] * PI0[0][8][9] + sp[18] * PI1[0][8][9] + sp[18] * PI1[0][9][8] + sp[17] * PI2[0][8][9];
    A[130] = sp[19] * PI0[0][8][10] + sp[18] * PI1[0][8][10] + sp[18] * PI1[0][10][8] + sp[17] * PI2[0][8][10];
    A[131] = sp[19] * PI0[0][8][11] + sp[18] * PI1[0][8][11] + sp[18] * PI1[0][11][8] + sp[17] * PI2[0][8][11];
    A[132] = sp[19] * PI0[0][8][12] + sp[18] * PI1[0][8][12] + sp[18] * PI1[0][12][8] + sp[17] * PI2[0][8][12];
    A[133] = sp[19] * PI0[0][8][13] + sp[18] * PI1[0][8][13] + sp[18] * PI1[0][13][8] + sp[17] * PI2[0][8][13];
    A[134] = sp[19] * PI0[0][8][14] + sp[18] * PI1[0][8][14] + sp[18] * PI1[0][14][8] + sp[17] * PI2[0][8][14];
    A[135] = sp[19] * PI0[0][9][0] + sp[18] * PI1[0][9][0] + sp[18] * PI1[0][0][9] + sp[17] * PI2[0][9][0];
    A[136] = sp[19] * PI0[0][9][1] + sp[18] * PI1[0][9][1] + sp[18] * PI1[0][1][9] + sp[17] * PI2[0][9][1];
    A[137] = sp[19] * PI0[0][9][2] + sp[18] * PI1[0][9][2] + sp[18] * PI1[0][2][9] + sp[17] * PI2[0][9][2];
    A[138] = sp[19] * PI0[0][9][3] + sp[18] * PI1[0][9][3] + sp[18] * PI1[0][3][9] + sp[17] * PI2[0][9][3];
    A[139] = sp[19] * PI0[0][9][4] + sp[18] * PI1[0][9][4] + sp[18] * PI1[0][4][9] + sp[17] * PI2[0][9][4];
    A[140] = sp[19] * PI0[0][9][5] + sp[18] * PI1[0][9][5] + sp[18] * PI1[0][5][9] + sp[17] * PI2[0][9][5];
    A[141] = sp[19] * PI0[0][9][6] + sp[18] * PI1[0][9][6] + sp[18] * PI1[0][6][9] + sp[17] * PI2[0][9][6];
    A[142] = sp[19] * PI0[0][9][7] + sp[18] * PI1[0][9][7] + sp[18] * PI1[0][7][9] + sp[17] * PI2[0][9][7];
    A[143] = sp[19] * PI0[0][9][8] + sp[18] * PI1[0][9][8] + sp[18] * PI1[0][8][9] + sp[17] * PI2[0][9][8];
    A[144] = sp[19] * PI0[0][9][9] + sp[18] * PI1[0][9][9] + sp[18] * PI1[0][9][9] + sp[17] * PI2[0][9][9];
    A[145] = sp[19] * PI0[0][9][10] + sp[18] * PI1[0][9][10] + sp[18] * PI1[0][10][9] + sp[17] * PI2[0][9][10];
    A[146] = sp[19] * PI0[0][9][11] + sp[18] * PI1[0][9][11] + sp[18] * PI1[0][11][9] + sp[17] * PI2[0][9][11];
    A[147] = sp[19] * PI0[0][9][12] + sp[18] * PI1[0][9][12] + sp[18] * PI1[0][12][9] + sp[17] * PI2[0][9][12];
    A[148] = sp[19] * PI0[0][9][13] + sp[18] * PI1[0][9][13] + sp[18] * PI1[0][13][9] + sp[17] * PI2[0][9][13];
    A[149] = sp[19] * PI0[0][9][14] + sp[18] * PI1[0][9][14] + sp[18] * PI1[0][14][9] + sp[17] * PI2[0][9][14];
    A[150] = sp[19] * PI0[0][10][0] + sp[18] * PI1[0][10][0] + sp[18] * PI1[0][0][10] + sp[17] * PI2[0][10][0];
    A[151] = sp[19] * PI0[0][10][1] + sp[18] * PI1[0][10][1] + sp[18] * PI1[0][1][10] + sp[17] * PI2[0][10][1];
    A[152] = sp[19] * PI0[0][10][2] + sp[18] * PI1[0][10][2] + sp[18] * PI1[0][2][10] + sp[17] * PI2[0][10][2];
    A[153] = sp[19] * PI0[0][10][3] + sp[18] * PI1[0][10][3] + sp[18] * PI1[0][3][10] + sp[17] * PI2[0][10][3];
    A[154] = sp[19] * PI0[0][10][4] + sp[18] * PI1[0][10][4] + sp[18] * PI1[0][4][10] + sp[17] * PI2[0][10][4];
    A[155] = sp[19] * PI0[0][10][5] + sp[18] * PI1[0][10][5] + sp[18] * PI1[0][5][10] + sp[17] * PI2[0][10][5];
    A[156] = sp[19] * PI0[0][10][6] + sp[18] * PI1[0][10][6] + sp[18] * PI1[0][6][10] + sp[17] * PI2[0][10][6];
    A[157] = sp[19] * PI0[0][10][7] + sp[18] * PI1[0][10][7] + sp[18] * PI1[0][7][10] + sp[17] * PI2[0][10][7];
    A[158] = sp[19] * PI0[0][10][8] + sp[18] * PI1[0][10][8] + sp[18] * PI1[0][8][10] + sp[17] * PI2[0][10][8];
    A[159] = sp[19] * PI0[0][10][9] + sp[18] * PI1[0][10][9] + sp[18] * PI1[0][9][10] + sp[17] * PI2[0][10][9];
    A[160] = sp[19] * PI0[0][10][10] + sp[18] * PI1[0][10][10] + sp[18] * PI1[0][10][10] + sp[17] * PI2[0][10][10];
    A[161] = sp[19] * PI0[0][10][11] + sp[18] * PI1[0][10][11] + sp[18] * PI1[0][11][10] + sp[17] * PI2[0][10][11];
    A[162] = sp[19] * PI0[0][10][12] + sp[18] * PI1[0][10][12] + sp[18] * PI1[0][12][10] + sp[17] * PI2[0][10][12];
    A[163] = sp[19] * PI0[0][10][13] + sp[18] * PI1[0][10][13] + sp[18] * PI1[0][13][10] + sp[17] * PI2[0][10][13];
    A[164] = sp[19] * PI0[0][10][14] + sp[18] * PI1[0][10][14] + sp[18] * PI1[0][14][10] + sp[17] * PI2[0][10][14];
    A[165] = sp[19] * PI0[0][11][0] + sp[18] * PI1[0][11][0] + sp[18] * PI1[0][0][11] + sp[17] * PI2[0][11][0];
    A[166] = sp[19] * PI0[0][11][1] + sp[18] * PI1[0][11][1] + sp[18] * PI1[0][1][11] + sp[17] * PI2[0][11][1];
    A[167] = sp[19] * PI0[0][11][2] + sp[18] * PI1[0][11][2] + sp[18] * PI1[0][2][11] + sp[17] * PI2[0][11][2];
    A[168] = sp[19] * PI0[0][11][3] + sp[18] * PI1[0][11][3] + sp[18] * PI1[0][3][11] + sp[17] * PI2[0][11][3];
    A[169] = sp[19] * PI0[0][11][4] + sp[18] * PI1[0][11][4] + sp[18] * PI1[0][4][11] + sp[17] * PI2[0][11][4];
    A[170] = sp[19] * PI0[0][11][5] + sp[18] * PI1[0][11][5] + sp[18] * PI1[0][5][11] + sp[17] * PI2[0][11][5];
    A[171] = sp[19] * PI0[0][11][6] + sp[18] * PI1[0][11][6] + sp[18] * PI1[0][6][11] + sp[17] * PI2[0][11][6];
    A[172] = sp[19] * PI0[0][11][7] + sp[18] * PI1[0][11][7] + sp[18] * PI1[0][7][11] + sp[17] * PI2[0][11][7];
    A[173] = sp[19] * PI0[0][11][8] + sp[18] * PI1[0][11][8] + sp[18] * PI1[0][8][11] + sp[17] * PI2[0][11][8];
    A[174] = sp[19] * PI0[0][11][9] + sp[18] * PI1[0][11][9] + sp[18] * PI1[0][9][11] + sp[17] * PI2[0][11][9];
    A[175] = sp[19] * PI0[0][11][10] + sp[18] * PI1[0][11][10] + sp[18] * PI1[0][10][11] + sp[17] * PI2[0][11][10];
    A[176] = sp[19] * PI0[0][11][11] + sp[18] * PI1[0][11][11] + sp[18] * PI1[0][11][11] + sp[17] * PI2[0][11][11];
    A[177] = sp[19] * PI0[0][11][12] + sp[18] * PI1[0][11][12] + sp[18] * PI1[0][12][11] + sp[17] * PI2[0][11][12];
    A[178] = sp[19] * PI0[0][11][13] + sp[18] * PI1[0][11][13] + sp[18] * PI1[0][13][11] + sp[17] * PI2[0][11][13];
    A[179] = sp[19] * PI0[0][11][14] + sp[18] * PI1[0][11][14] + sp[18] * PI1[0][14][11] + sp[17] * PI2[0][11][14];
    A[180] = sp[19] * PI0[0][12][0] + sp[18] * PI1[0][12][0] + sp[18] * PI1[0][0][12] + sp[17] * PI2[0][12][0];
    A[181] = sp[19] * PI0[0][12][1] + sp[18] * PI1[0][12][1] + sp[18] * PI1[0][1][12] + sp[17] * PI2[0][12][1];
    A[182] = sp[19] * PI0[0][12][2] + sp[18] * PI1[0][12][2] + sp[18] * PI1[0][2][12] + sp[17] * PI2[0][12][2];
    A[183] = sp[19] * PI0[0][12][3] + sp[18] * PI1[0][12][3] + sp[18] * PI1[0][3][12] + sp[17] * PI2[0][12][3];
    A[184] = sp[19] * PI0[0][12][4] + sp[18] * PI1[0][12][4] + sp[18] * PI1[0][4][12] + sp[17] * PI2[0][12][4];
    A[185] = sp[19] * PI0[0][12][5] + sp[18] * PI1[0][12][5] + sp[18] * PI1[0][5][12] + sp[17] * PI2[0][12][5];
    A[186] = sp[19] * PI0[0][12][6] + sp[18] * PI1[0][12][6] + sp[18] * PI1[0][6][12] + sp[17] * PI2[0][12][6];
    A[187] = sp[19] * PI0[0][12][7] + sp[18] * PI1[0][12][7] + sp[18] * PI1[0][7][12] + sp[17] * PI2[0][12][7];
    A[188] = sp[19] * PI0[0][12][8] + sp[18] * PI1[0][12][8] + sp[18] * PI1[0][8][12] + sp[17] * PI2[0][12][8];
    A[189] = sp[19] * PI0[0][12][9] + sp[18] * PI1[0][12][9] + sp[18] * PI1[0][9][12] + sp[17] * PI2[0][12][9];
    A[190] = sp[19] * PI0[0][12][10] + sp[18] * PI1[0][12][10] + sp[18] * PI1[0][10][12] + sp[17] * PI2[0][12][10];
    A[191] = sp[19] * PI0[0][12][11] + sp[18] * PI1[0][12][11] + sp[18] * PI1[0][11][12] + sp[17] * PI2[0][12][11];
    A[192] = sp[19] * PI0[0][12][12] + sp[18] * PI1[0][12][12] + sp[18] * PI1[0][12][12] + sp[17] * PI2[0][12][12];
    A[193] = sp[19] * PI0[0][12][13] + sp[18] * PI1[0][12][13] + sp[18] * PI1[0][13][12] + sp[17] * PI2[0][12][13];
    A[194] = sp[19] * PI0[0][12][14] + sp[18] * PI1[0][12][14] + sp[18] * PI1[0][14][12] + sp[17] * PI2[0][12][14];
    A[195] = sp[19] * PI0[0][13][0] + sp[18] * PI1[0][13][0] + sp[18] * PI1[0][0][13] + sp[17] * PI2[0][13][0];
    A[196] = sp[19] * PI0[0][13][1] + sp[18] * PI1[0][13][1] + sp[18] * PI1[0][1][13] + sp[17] * PI2[0][13][1];
    A[197] = sp[19] * PI0[0][13][2] + sp[18] * PI1[0][13][2] + sp[18] * PI1[0][2][13] + sp[17] * PI2[0][13][2];
    A[198] = sp[19] * PI0[0][13][3] + sp[18] * PI1[0][13][3] + sp[18] * PI1[0][3][13] + sp[17] * PI2[0][13][3];
    A[199] = sp[19] * PI0[0][13][4] + sp[18] * PI1[0][13][4] + sp[18] * PI1[0][4][13] + sp[17] * PI2[0][13][4];
    A[200] = sp[19] * PI0[0][13][5] + sp[18] * PI1[0][13][5] + sp[18] * PI1[0][5][13] + sp[17] * PI2[0][13][5];
    A[201] = sp[19] * PI0[0][13][6] + sp[18] * PI1[0][13][6] + sp[18] * PI1[0][6][13] + sp[17] * PI2[0][13][6];
    A[202] = sp[19] * PI0[0][13][7] + sp[18] * PI1[0][13][7] + sp[18] * PI1[0][7][13] + sp[17] * PI2[0][13][7];
    A[203] = sp[19] * PI0[0][13][8] + sp[18] * PI1[0][13][8] + sp[18] * PI1[0][8][13] + sp[17] * PI2[0][13][8];
    A[204] = sp[19] * PI0[0][13][9] + sp[18] * PI1[0][13][9] + sp[18] * PI1[0][9][13] + sp[17] * PI2[0][13][9];
    A[205] = sp[19] * PI0[0][13][10] + sp[18] * PI1[0][13][10] + sp[18] * PI1[0][10][13] + sp[17] * PI2[0][13][10];
    A[206] = sp[19] * PI0[0][13][11] + sp[18] * PI1[0][13][11] + sp[18] * PI1[0][11][13] + sp[17] * PI2[0][13][11];
    A[207] = sp[19] * PI0[0][13][12] + sp[18] * PI1[0][13][12] + sp[18] * PI1[0][12][13] + sp[17] * PI2[0][13][12];
    A[208] = sp[19] * PI0[0][13][13] + sp[18] * PI1[0][13][13] + sp[18] * PI1[0][13][13] + sp[17] * PI2[0][13][13];
    A[209] = sp[19] * PI0[0][13][14] + sp[18] * PI1[0][13][14] + sp[18] * PI1[0][14][13] + sp[17] * PI2[0][13][14];
    A[210] = sp[19] * PI0[0][14][0] + sp[18] * PI1[0][14][0] + sp[18] * PI1[0][0][14] + sp[17] * PI2[0][14][0];
    A[211] = sp[19] * PI0[0][14][1] + sp[18] * PI1[0][14][1] + sp[18] * PI1[0][1][14] + sp[17] * PI2[0][14][1];
    A[212] = sp[19] * PI0[0][14][2] + sp[18] * PI1[0][14][2] + sp[18] * PI1[0][2][14] + sp[17] * PI2[0][14][2];
    A[213] = sp[19] * PI0[0][14][3] + sp[18] * PI1[0][14][3] + sp[18] * PI1[0][3][14] + sp[17] * PI2[0][14][3];
    A[214] = sp[19] * PI0[0][14][4] + sp[18] * PI1[0][14][4] + sp[18] * PI1[0][4][14] + sp[17] * PI2[0][14][4];
    A[215] = sp[19] * PI0[0][14][5] + sp[18] * PI1[0][14][5] + sp[18] * PI1[0][5][14] + sp[17] * PI2[0][14][5];
    A[216] = sp[19] * PI0[0][14][6] + sp[18] * PI1[0][14][6] + sp[18] * PI1[0][6][14] + sp[17] * PI2[0][14][6];
    A[217] = sp[19] * PI0[0][14][7] + sp[18] * PI1[0][14][7] + sp[18] * PI1[0][7][14] + sp[17] * PI2[0][14][7];
    A[218] = sp[19] * PI0[0][14][8] + sp[18] * PI1[0][14][8] + sp[18] * PI1[0][8][14] + sp[17] * PI2[0][14][8];
    A[219] = sp[19] * PI0[0][14][9] + sp[18] * PI1[0][14][9] + sp[18] * PI1[0][9][14] + sp[17] * PI2[0][14][9];
    A[220] = sp[19] * PI0[0][14][10] + sp[18] * PI1[0][14][10] + sp[18] * PI1[0][10][14] + sp[17] * PI2[0][14][10];
    A[221] = sp[19] * PI0[0][14][11] + sp[18] * PI1[0][14][11] + sp[18] * PI1[0][11][14] + sp[17] * PI2[0][14][11];
    A[222] = sp[19] * PI0[0][14][12] + sp[18] * PI1[0][14][12] + sp[18] * PI1[0][12][14] + sp[17] * PI2[0][14][12];
    A[223] = sp[19] * PI0[0][14][13] + sp[18] * PI1[0][14][13] + sp[18] * PI1[0][13][14] + sp[17] * PI2[0][14][13];
    A[224] = sp[19] * PI0[0][14][14] + sp[18] * PI1[0][14][14] + sp[18] * PI1[0][14][14] + sp[17] * PI2[0][14][14];
  }

};


class forms_form_0: public ufc::form
{
public:

  forms_form_0() : ufc::form()
  {
    // Do nothing
  }

  ~forms_form_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "1c9f2722f2f6220661ca872251535a0591b94c8bf328e636d07baddfb70002626dc60b51378046bd622a1ea5d06be457784b36454f010c37a5c3c72c337bbb9b";
  }

  std::size_t rank() const final override
  {
    return 2;
  }

  std::size_t num_coefficients() const final override
  {
    return 0;
  }

  std::size_t original_coefficient_position(std::size_t i) const final override
  {
    throw std::runtime_error("Invalid original coefficient index.");
    return i;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
   }

  ufc::coordinate_mapping * create_coordinate_mapping() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  ufc::finite_element * create_finite_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_2();
    case 1:
        return new forms_finite_element_2();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_2();
    case 1:
        return new forms_dofmap_2();
    default:
        return nullptr;
    }
  }

  std::size_t max_cell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_exterior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_vertex_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_custom_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_cutcell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interface_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_overlap_subdomain_id() const final override
  {
    return 0;
  }

  bool has_cell_integrals() const final override
  {
    return true;
  }

  bool has_exterior_facet_integrals() const final override
  {
    return false;
  }

  bool has_interior_facet_integrals() const final override
  {
    return false;
  }

  bool has_vertex_integrals() const final override
  {
    return false;
  }

  bool has_custom_integrals() const final override
  {
    return false;
  }

  bool has_cutcell_integrals() const final override
  {
    return false;
  }

  bool has_interface_integrals() const final override
  {
    return false;
  }

  bool has_overlap_integrals() const final override
  {
    return false;
  }

  ufc::cell_integral * create_cell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::exterior_facet_integral * create_exterior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_interior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_vertex_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_custom_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_cutcell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_interface_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_overlap_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cell_integral * create_default_cell_integral() const final override
  {
    return new forms_cell_integral_0_otherwise();
  }

  ufc::exterior_facet_integral * create_default_exterior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_default_interior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_default_vertex_integral() const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_default_custom_integral() const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_default_cutcell_integral() const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_default_interface_integral() const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_default_overlap_integral() const final override
  {
    return nullptr;
  }

};


class forms_form_1: public ufc::form
{
public:

  forms_form_1() : ufc::form()
  {
    // Do nothing
  }

  ~forms_form_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "499f292275f354a5c9ba500a5876308055354915a275bd6c468b66ad436ed8f88d82e4d026ada849298959a57aac31fb643a3ed042a61a0d6e7be8c17e801392";
  }

  std::size_t rank() const final override
  {
    return 2;
  }

  std::size_t num_coefficients() const final override
  {
    return 0;
  }

  std::size_t original_coefficient_position(std::size_t i) const final override
  {
    throw std::runtime_error("Invalid original coefficient index.");
    return i;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
   }

  ufc::coordinate_mapping * create_coordinate_mapping() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  ufc::finite_element * create_finite_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_2();
    case 1:
        return new forms_finite_element_2();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_2();
    case 1:
        return new forms_dofmap_2();
    default:
        return nullptr;
    }
  }

  std::size_t max_cell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_exterior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_vertex_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_custom_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_cutcell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interface_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_overlap_subdomain_id() const final override
  {
    return 0;
  }

  bool has_cell_integrals() const final override
  {
    return true;
  }

  bool has_exterior_facet_integrals() const final override
  {
    return false;
  }

  bool has_interior_facet_integrals() const final override
  {
    return false;
  }

  bool has_vertex_integrals() const final override
  {
    return false;
  }

  bool has_custom_integrals() const final override
  {
    return false;
  }

  bool has_cutcell_integrals() const final override
  {
    return false;
  }

  bool has_interface_integrals() const final override
  {
    return false;
  }

  bool has_overlap_integrals() const final override
  {
    return false;
  }

  ufc::cell_integral * create_cell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::exterior_facet_integral * create_exterior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_interior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_vertex_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_custom_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_cutcell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_interface_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_overlap_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cell_integral * create_default_cell_integral() const final override
  {
    return new forms_cell_integral_1_otherwise();
  }

  ufc::exterior_facet_integral * create_default_exterior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_default_interior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_default_vertex_integral() const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_default_custom_integral() const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_default_cutcell_integral() const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_default_interface_integral() const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_default_overlap_integral() const final override
  {
    return nullptr;
  }

};

// DOLFIN wrappers

// Standard library includes
#include <string>

// DOLFIN includes
#include <dolfin/common/NoDeleter.h>
#include <dolfin/mesh/Mesh.h>
#include <dolfin/mesh/MultiMesh.h>
#include <dolfin/fem/FiniteElement.h>
#include <dolfin/fem/DofMap.h>
#include <dolfin/fem/Form.h>
#include <dolfin/fem/MultiMeshForm.h>
#include <dolfin/function/FunctionSpace.h>
#include <dolfin/function/MultiMeshFunctionSpace.h>
#include <dolfin/function/GenericFunction.h>
#include <dolfin/function/CoefficientAssigner.h>
#include <dolfin/function/MultiMeshCoefficientAssigner.h>
#include <dolfin/adaptivity/ErrorControl.h>
#include <dolfin/adaptivity/GoalFunctional.h>
#include <dolfin/la/GenericVector.h>

namespace Forms
{

class Form_a_FunctionSpace_0: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_a_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_a_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_a_FunctionSpace_1: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_a_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_a_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_a_MultiMeshFunctionSpace_0: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_a_MultiMeshFunctionSpace_0(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_a_FunctionSpace_0(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_a_MultiMeshFunctionSpace_1: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_a_MultiMeshFunctionSpace_1(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_a_FunctionSpace_1(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_a: public dolfin::Form
{
public:

  // Constructor
  Form_a(std::shared_ptr<const dolfin::FunctionSpace> V1, std::shared_ptr<const dolfin::FunctionSpace> V0):
    dolfin::Form(2, 0)
  {
    _function_spaces[0] = V0;
    _function_spaces[1] = V1;

    _ufc_form = std::make_shared<const forms_form_0>();
  }

  // Destructor
  ~Form_a()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_a_FunctionSpace_0 TestSpace;
  typedef Form_a_FunctionSpace_1 TrialSpace;
  typedef Form_a_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_a_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class MultiMeshForm_a: public dolfin::MultiMeshForm
{
public:

  // Constructor
  MultiMeshForm_a(std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V1, std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V0):
    dolfin::MultiMeshForm(V1, V0)
  {
    // Create and add standard forms
    std::size_t num_parts = V0->num_parts(); // assume all equal and pick first
    for (std::size_t part = 0; part < num_parts; part++)
    {
      std::shared_ptr<dolfin::Form> a(new Form_a(V1->part(part), V0->part(part)));
    add(a);

    }
    // Build multimesh form
    build();

    /// Assign coefficients

  }

  // Destructor
  ~MultiMeshForm_a()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_a_FunctionSpace_0 TestSpace;
  typedef Form_a_FunctionSpace_1 TrialSpace;
  typedef Form_a_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_a_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class Form_L_FunctionSpace_0: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_L_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_L_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_L_FunctionSpace_1: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_L_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_L_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_L_MultiMeshFunctionSpace_0: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_L_MultiMeshFunctionSpace_0(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_L_FunctionSpace_0(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_L_MultiMeshFunctionSpace_1: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_L_MultiMeshFunctionSpace_1(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_L_FunctionSpace_1(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_L: public dolfin::Form
{
public:

  // Constructor
  Form_L(std::shared_ptr<const dolfin::FunctionSpace> V1, std::shared_ptr<const dolfin::FunctionSpace> V0):
    dolfin::Form(2, 0)
  {
    _function_spaces[0] = V0;
    _function_spaces[1] = V1;

    _ufc_form = std::make_shared<const forms_form_1>();
  }

  // Destructor
  ~Form_L()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_L_FunctionSpace_0 TestSpace;
  typedef Form_L_FunctionSpace_1 TrialSpace;
  typedef Form_L_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_L_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class MultiMeshForm_L: public dolfin::MultiMeshForm
{
public:

  // Constructor
  MultiMeshForm_L(std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V1, std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V0):
    dolfin::MultiMeshForm(V1, V0)
  {
    // Create and add standard forms
    std::size_t num_parts = V0->num_parts(); // assume all equal and pick first
    for (std::size_t part = 0; part < num_parts; part++)
    {
      std::shared_ptr<dolfin::Form> a(new Form_L(V1->part(part), V0->part(part)));
    add(a);

    }
    // Build multimesh form
    build();

    /// Assign coefficients

  }

  // Destructor
  ~MultiMeshForm_L()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_L_FunctionSpace_0 TestSpace;
  typedef Form_L_FunctionSpace_1 TrialSpace;
  typedef Form_L_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_L_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

// Class typedefs
typedef Form_a::TestSpace FunctionSpace;
typedef Form_a::MultiMeshTestSpace MultiMeshFunctionSpace;

}

#endif
